
 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0001
  0002            	IDT  'EA_HDX'
  0003            
  0004 A000       	AORG	>A000
  0005            
  0006            	DEF	SFIRST,SLAST
  0007            
  0008 A000 0460  SFIRST	B	@MAIN
       A002 A074 
  0009            	
  0010 A004 0000  SCROFF	DATA	>0000	Screen offset
  0011            
  0012            	COPY ".\MEMT_HDX.A99"
  0013            * MEMT_HDX - Main Memory Test Program for Hdx Card
  0014            *
  0016            	IDT 'MAIN'
  0017            
  0018            *---------------------------------------------------	
  0019 A006   48  TITLE	TEXT	'Hdx Ram Memory test'
  0020 A019   00  	BYTE	0
  0021 A01A   45  TXTCRU	TEXT	'Enter HDX-card CRU address >1x'
  0022 A038   00  	BYTE	0
  0023            	EVEN
  0024            *---------------------------------------------------	
  0025            * Memorytable with testaddresses 
  0026            *
  0027            *               Base  Size  Width Mask  Pages
  0028 A03A 4000  MEMTAB	DATA	>4000,>1000,>0008,>0FFF,2
       A03C 1000 
       A03E 0008 
       A040 0FFF 
       A042 0002 
  0029 A044 0000  ENDTAB	DATA	>0000,>0000
       A046 0000 
  0030            
  0031      0000  OFBASE	EQU	0		Offset Base address
  0032      0002  OFSIZE	EQU	2		Offset Region Size
  0033      0004  OFWIDT	EQU	4		Offset Databus width
  0034      0006  OFMASK	EQU	6		Offset Address mask
  0035      0008  OFPAGE	EQU	8		Offset Number of pages
  0036      000A  MEMTEZ	EQU	10		Memtab entry size
  0037            
  0038 A048 0000  MYCRU	DATA	0		My Card's CRU address
  0039 A04A       MYWS	BSS	32		My workspace
  0040 A06A       STACK	BSS	10		My stack
  0041            *---------------------------------------------------	
  0042            
  0043            MAIN	
  0044 A074 02E0  BEGIN	LWPI	MYWS
       A076 A04A 
  0045 A078 020A  	LI	R10,STACK
       A07A A06A 
  0046            *	DATA	>0D00
  0047            
  0048            * Title	
  0049 A07C 0201  BEGIN1	LI	R1,TITLE
       A07E A006 
  0050 A080 06A0  	BL	@PRTLIN
       A082 A772 
  0051 A084 06A0  	BL	@SCROLL

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0002
       A086 A704 
  0052            
  0053            * Ask CRU address
  0054 A088 06A0  	BL	@ASKCRU
       A08A A78A 
  0055 A08C C80C  	MOV	R12,@MYCRU	Save CRU addres
       A08E A048 
  0056 A090 1602  	JNE	BEGIN2		Not >0000, Continue
  0057 A092 0460  	B	@QUIT		Goodbye!
       A094 A67A 
  0058 A096 06A0  BEGIN2	BL	@SCROLL
       A098 A704 
  0059            
  0060            * First initialization and select Page 0
  0061 A09A 06A0  	BL	@USINIT		Card on
       A09C A0BE 
  0062 A09E 06A0  	BL	@SELPG0		Page 0
       A0A0 A0E2 
  0063 A0A2 06A0  	BL	@USEXIT		Card off
       A0A4 A0CC 
  0064            
  0065 A0A6 020F  	LI	R15,MEMTAB
       A0A8 A03A 
  0066 A0AA 06A0  BEGIN3	BL	@MTEST
       A0AC A3C8 
  0067            	
  0068            *	DATA	>0D00
  0069 A0AE 022F  	AI	R15,MEMTEZ	Next entry
       A0B0 000A 
  0070 A0B2 C02F  	MOV	@2(R15),R0	Size nil?
       A0B4 0002 
  0071 A0B6 16F9  	JNE	BEGIN3		No!
  0072            
  0073            * Return to title screen
  0074            *	DATA	>0D00		Debugger
  0075 A0B8 06A0  	BL	@REDO
       A0BA A636 
  0076 A0BC 10DB  	JMP	BEGIN
  0077            
  0078            * User Init function
  0079            *
  0080            * Initialize your hardware, like card on, etc.
  0081            * This function is called before a test is executed.
  0082            *
  0083 A0BE C320  USINIT	MOV	@MYCRU,R12
       A0C0 A048 
  0084 A0C2 1303  	JEQ	USINI0
  0085 A0C4 1D00  	SBO	0		Card on
  0086 A0C6 1E04  	SBZ	4		Page 0
  0087 A0C8 1D07  	SBO	7		Led on
  0088 A0CA 045B  USINI0	B	*R11
  0089            
  0090            * User Exit function.
  0091            *
  0092            * Save your hardware, like card off, etc.
  0093            * This function is called after a test has been executed.
  0094            *
  0095 A0CC C320  USEXIT	MOV	@MYCRU,R12
       A0CE A048 

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0003
  0096 A0D0 1303  	JEQ	USEXT0
  0097 A0D2 1E00  	SBZ	0		Card off
  0098 A0D4 1E04  	SBZ	4		Page 0
  0099 A0D6 1E07  	SBZ	7		Led off
  0100 A0D8 045B  USEXT0	B	*R11
  0101            
  0102            *---------------------------------------------------	
  0103            * Page Test Functions
  0104            *---------------------------------------------------	
  0105            
  0106            * SELPG0 - Select page 0
  0107            * SELPG  - Select a page x
  0108            *
  0109            * Input : R1 Page address 0-63
  0110            * Output: Page selected
  0111            * Uses  : R1, R11, R12
  0112            *
  0113 A0DA C320  SELPG	MOV	@MYCRU,R12
       A0DC A048 
  0114 A0DE C041  	MOV	R1,R1
  0115 A0E0 1602  	JNE	SELPG1
  0116 A0E2 1E04  SELPG0	SBZ	4		Page 0
  0117 A0E4 045B  	B	*R11
  0118 A0E6 1D04  SELPG1	SBO	4		Page 1
  0119 A0E8 045B  	B	*R11
  0120            	
  0121            * MTPB - Memorytest PageBus
  0122            *
  0123            * Test the page bus wiring by performing a walking 1's test
  0124            * on the relevant bits of the page addresses and checking
  0125            * for aliasing. This test will find single-bit address
  0126            * failures such as stuck-high, stuck-low, and shorted pins.
  0127            * The base address and size of the region are selected by
  0128            * the caller.
  0129            *
  0130            * Input : R0 of callers workspace contains address of
  0131            *            structure with Base address, Region size,
  0132            *            Databus width 8/16, Address mask and
  0133            *            Number of pages.
  0134            *
  0135            * Output: SR EQ=1 test succeeded
  0136            *         SR EQ=0 test failed
  0137            *         MT#ERR=7 Page line stuck low
  0138            *         MT#ERR=8 Page line stuck high
  0139            *         MT#ERR=9 Page lines shorted
  0140            *         and rest of MT#WSP filled as described.
  0141            *
  0142            * Uses  : All
  0143            
  0144 A0EA A834  MTPB	DATA	MT#WSP,MTPB$	Pagebus test
       A0EC A0EE 
  0145            
  0146 A0EE 06A0  MTPB$	BL	@MTGTTV		Get memory test table values
       A0F0 A860 
  0147 A0F2 C181  	MOV	R1,R6		Base address
  0148            
  0149 A0F4 0207  	LI	R7,>A500	Pattern
       A0F6 A500 
  0150 A0F8 0208  	LI	R8,>5A00	Inverted pattern

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0004
       A0FA 5A00 
  0151            	
  0152            * Clear all pages base address
  0153 A0FC 04C4  	CLR	R4		Page 0
  0154 A0FE C044  MTPB0	MOV	R4,R1	
  0155 A100 06A0  	BL	@SELPG
       A102 A0DA 
  0156 A104 04D6  	CLR	*R6		Base address = 0
  0157 A106 0584  	INC	R4		Next page
  0158 A108 8284  	C	R4,R10		More pages?
  0159 A10A 1AF9  	JL	MTPB0		Yes!
  0160            
  0161            * Write the default pattern at each page of the power-of-two
  0162 A10C 0204  	LI	R4,1		Page 1
       A10E 0001 
  0163 A110 C044  MTPB1	MOV	R4,R1
  0164 A112 06A0  	BL	@SELPG
       A114 A0DA 
  0165 A116 D587  	MOVB	R7,*R6		= Pattern
  0166 A118 0A14  	SLA	R4,1		Page <<= 1
  0167 A11A 8284  	C	R4,R10		More pages?
  0168 A11C 1AF9  	JL	MTPB1		Yes!
  0169            	
  0170            * Check for address bits stuck high.
  0171 A11E 06A0  	BL	@SELPG0
       A120 A0E2 
  0172 A122 D588  	MOVB	R8,*R6		Base address = Inverted pattern
  0173            	
  0174 A124 04C9  	CLR	R9		Readback register
  0175 A126 0204  	LI	R4,1		Page 1
       A128 0001 
  0176 A12A C044  MTPB2	MOV	R4,R1
  0177 A12C 06A0  	BL	@SELPG
       A12E A0DA 
  0178 A130 D256  	MOVB	*R6,R9		Read back
  0179 A132 9247  	CB	R7,R9		Equals Pattern
  0180 A134 162C  	JNE	MTPBE8		No, stuck high!
  0181 A136 0A14  	SLA	R4,1		Page <<= 1
  0182 A138 8284  	C	R4,R10		More pages?
  0183 A13A 1AF7  	JL	MTPB2		Yes!
  0184            
  0185            * Check for address bits stuck low or shorted.
  0186 A13C 06A0  	BL	@SELPG0		Page 0
       A13E A0E2 
  0187 A140 D587  	MOVB	R7,*R6		Base address = Pattern
  0188            
  0189 A142 0204  	LI	R4,1		Page 1
       A144 0001 
  0190 A146 C044  MTPB3	MOV	R4,R1
  0191 A148 06A0  	BL	@SELPG
       A14A A0DA 
  0192 A14C D588  	MOVB	R8,*R6		= Inverted Pattern
  0193            
  0194 A14E 06A0  	BL	@SELPG0		Page 0
       A150 A0E2 
  0195 A152 D256  	MOVB	*R6,R9		Readback Base address
  0196 A154 9247  	CB	R7,R9		Address stuck low?
  0197 A156 1618  	JNE	MTPBE7		Yes, Error!
  0198            

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0005
  0199 A158 0205  	LI	R5,1		Page 1
       A15A 0001 
  0200 A15C 8105  MTPB4	C	R5,R4		Page == Test Page?
  0201 A15E 1306  	JEQ	MTPB5		Yes, do not check!
  0202            
  0203 A160 C045  	MOV	R5,R1
  0204 A162 06A0  	BL	@SELPG
       A164 A0DA 
  0205 A166 D256  	MOVB	*R6,R9		Readback
  0206 A168 9247  	CB	R7,R9		Equals Pattern
  0207 A16A 1614  	JNE	MTPBE9		No, address lines shorted!
  0208 A16C 0A15  MTPB5	SLA	R5,1		Page <<= 1
  0209 A16E 8285  	C	R5,R10		More pages?
  0210 A170 1AF5  	JL	MTPB4		Yes!
  0211            
  0212 A172 C044  	MOV	R4,R1		Restore pattern
  0213 A174 06A0  	BL	@SELPG
       A176 A0DA 
  0214 A178 D587  	MOVB	R7,*R6		= Pattern
  0215            
  0216 A17A 0A14  	SLA	R4,1		Page <<= 1
  0217 A17C 8284  	C	R4,R10		More pages?
  0218 A17E 1AE3  	JL	MTPB3		Yes!
  0219            
  0220 A180 04C0  MTPBEQ	CLR	R0		Error 0: Success
  0221 A182 026F  	ORI	R15,>2000	Success, set EQ
       A184 2000 
  0222 A186 0380  	RTWP
  0223            	
  0224 A188 0200  MTPBE7	LI	R0,7		Error 2: Page line stuck low
       A18A 0007 
  0225 A18C 1005  	JMP	MTPBNE	
  0226 A18E 0200  MTPBE8	LI	R0,8		Error 3: Page line stuck high
       A190 0008 
  0227 A192 1002  	JMP	MTPBNE	
  0228 A194 0200  MTPBE9	LI	R0,9		Error 4: Page lines shorted
       A196 0009 
  0229 A198 024F  MTPBNE	ANDI	R15,>DFFF	Failure, reset EQ
       A19A DFFF 
  0230 A19C 0380  	RTWP
  0231            
  0232            * End of Main ...
  0233            	COPY ".\MEMT_MISC.A99"
  0234            * MEMTMISC - Main Memory Misc Functions
  0235            *
  0236            *	TITL 'MEMTEST MISC 06/05/2007'
  0237            *	IDT 'MISC'
  0238            
  0239            *---------------------------------------------------
  0240 A19E   54  TXTBAD	TEXT	'Testing >xxxx size >xxxx'
  0241 A1B6   00  	BYTE	0
  0242 A1B7   20  TXTDBT	TEXT	' Databus test   '
  0243 A1C7   00  	BYTE	0
  0244 A1C8   20  TXTABT	TEXT	' Addressbus test'
  0245 A1D8   00  	BYTE	0
  0246 A1D9   20  TXTDVT	TEXT	' Device test    '
  0247 A1E9   00  	BYTE	0
  0248 A1EA   20  TXTPBT	TEXT	' Pagebus test   '
  0249 A1FA   00  	BYTE	0

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0006
  0250 A1FB   20  TXTOK	TEXT    ' Ok'
  0251 A1FE   00  	BYTE	0
  0252 A1FF   20  TXTFLD	TEXT	' Failed'
  0253 A206   00  	BYTE	0
  0254            *---------------------------------------------------
  0255            * Error texts
  0256            	EVEN
  0257 A208 A21C  TXTERT	DATA	TXTER0,TXTER1,TXTER2,TXTER3,TXTER4
       A20A A22B 
       A20C A23C 
       A20E A254 
       A210 A26D 
  0258 A212 A284  	DATA	TXTER5,TXTER6,TXTER7,TXTER8,TXTER9
       A214 A29D 
       A216 A2BB 
       A218 A2D0 
       A21A A2E6 
  0259            
  0260 A21C   20  TXTER0	TEXT	' Unknown error'
  0261 A22A   00  	BYTE	0
  0262 A22B   20  TXTER1	TEXT	' Databus failure'
  0263 A23B   00  	BYTE	0
  0264 A23C   20  TXTER2	TEXT	' Address line stuck low'
  0265 A253   00  	BYTE	0
  0266 A254   20  TXTER3	TEXT	' Address line stuck high'
  0267 A26C   00  	BYTE	0
  0268 A26D   20  TXTER4	TEXT	' Address lines shorted'
  0269 A283   00  	BYTE	0
  0270 A284   20  TXTER5	TEXT	' Wrong pattern read back'
  0271 A29C   00  	BYTE	0
  0272 A29D   20  TXTER6	TEXT	' Wrong inv. pattern read back'
  0273 A2BA   00  	BYTE	0
  0274 A2BB   20  TXTER7	TEXT	' Page line stuck low'
  0275 A2CF   00  	BYTE	0
  0276 A2D0   20  TXTER8	TEXT	' Page line stuck high'
  0277 A2E5   00  	BYTE	0
  0278 A2E6   20  TXTER9	TEXT	' Page lines shorted'
  0279 A2F9   00  	BYTE	0
  0280            *---------------------------------------------------
  0281 A2FA   20  TXTERR	TEXT	' Error >0000'
  0282 A306   00  	BYTE	0
  0283 A307   20  TXTPGN	TEXT	' Page number      >xxxx'
  0284 A31E   00  	BYTE	0
  0285 A31F   20  TXTBAS	TEXT	' Base address     >xxxx'
  0286 A336   00  	BYTE	0
  0287 A337   20  TXTADR	TEXT	' Test address     >xxxx'
  0288 A34E   00  	BYTE	0
  0289 A34F   20  TXTWRP	TEXT	' Pattern written  >xxxx'
  0290 A366   00  	BYTE	0
  0291 A367   20  TXTRDP	TEXT	' Pattern readback >xxxx'
  0292 A37E   00  	BYTE	0
  0293 A37F   20  TXTEXP	TEXT	' Pattern expected >xxxx'
  0294 A396   00  	BYTE	0
  0295            *---------------------------------------------------
  0296 A397   50  TXTBCK	TEXT	'Press <proceed> or <back>'
  0297 A3B0   00  	BYTE	0
  0298 A3B1   50  TXTRED	TEXT	'Press <redo> or <back>'
  0299 A3C7   00  	BYTE	0
  0300            	EVEN

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0007
  0301            *---------------------------------------------------
  0302            
  0303            
  0304            * MTEST - Memory test
  0305            *
  0306            * Do the databus, addressbus and device test
  0307            *
  0308            * Input : R15 addess of memory entry width
  0309            *             base address, regionsize and width
  0310            *
  0311            * Uses  : R0 - R11
  0312            * Output: 
  0313            *
  0314 A3C8 CE8B  MTEST	MOV	R11,*R10+	Save return address
  0315            *---------------------------------------------------
  0316            * User Init Function
  0317            *---------------------------------------------------
  0318 A3CA 06A0  	BL	@USINIT
       A3CC A0BE 
  0319            
  0320            *---------------------------------------------------
  0321            * Initialize registers
  0322            *---------------------------------------------------
  0323 A3CE C01F  	MOV	*R15,R0		Base Address
  0324 A3D0 0201  	LI	R1,TXTBAD+9
       A3D2 A1A7 
  0325 A3D4 06A0  	BL	@WRDASC
       A3D6 A808 
  0326 A3D8 0200  	LI	R0,>2000	Remove '0' in string
       A3DA 2000 
  0327 A3DC D440  	MOVB	R0,*R1
  0328            
  0329 A3DE C02F  	MOV	@2(R15),R0	Region Size
       A3E0 0002 
  0330 A3E2 0201  	LI	R1,TXTBAD+20
       A3E4 A1B2 
  0331 A3E6 06A0  	BL	@WRDASC
       A3E8 A808 
  0332            
  0333 A3EA 0201  	LI	R1,TXTBAD	Print: Testing >xxxx Size >xxxx
       A3EC A19E 
  0334 A3EE 06A0  	BL	@PRTLIN
       A3F0 A772 
  0335            
  0336            *---------------------------------------------------
  0337            * Databus test
  0338            *---------------------------------------------------
  0339 A3F2 0200  MTEST1	LI	R0,23*32
       A3F4 02E0 
  0340 A3F6 0201  	LI	R1,TXTDBT	Print: Adresbus test
       A3F8 A1B7 
  0341 A3FA 06A0  	BL	@DSPLIN
       A3FC A750 
  0342            *	DATA	>0D00
  0343 A3FE C00F  	MOV	R15,R0		Test entry
  0344 A400 0420  	BLWP	@MTDB		Test databus
       A402 A854 
  0345 A404 06A0  	BL	@MTFAIL		Failure?
       A406 A576 

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0008
  0346            	
  0347            *---------------------------------------------------
  0348            * Addressbus test
  0349            *---------------------------------------------------
  0350 A408 0200  MTEST2	LI	R0,23*32
       A40A 02E0 
  0351 A40C 0201  	LI	R1,TXTABT	Print: Databus test
       A40E A1C8 
  0352 A410 06A0  	BL	@DSPLIN
       A412 A750 
  0353            *	DATA	>0D00		Debugger
  0354 A414 C00F  	MOV	R15,R0		Test entry
  0355 A416 0420  	BLWP	@MTAB		Test addressbus
       A418 A858 
  0356 A41A 06A0  	BL	@MTFAIL		Failure?
       A41C A576 
  0357            	
  0358            *---------------------------------------------------
  0359            * Device test
  0360            *---------------------------------------------------
  0361 A41E 0200  MTEST3	LI	R0,23*32
       A420 02E0 
  0362 A422 0201  	LI	R1,TXTDVT	Print: Device test
       A424 A1D9 
  0363 A426 06A0  	BL	@DSPLIN
       A428 A750 
  0364 A42A C00F  	MOV	R15,R0		Test entry
  0365 A42C 0420  	BLWP	@MTDV		Test device
       A42E A85C 
  0366 A430 06A0  	BL	@MTFAIL		Failure?
       A432 A576 
  0367            
  0368 TRUE       #ifdef MTPB
  0369            *---------------------------------------------------
  0370            * Pagebus test
  0371            *---------------------------------------------------
  0372 A434 C04F  MTEST4	MOV	R15,R1		Any pages to test?
  0373 A436 C021  	MOV	@OFPAGE(R1),R0
       A438 0008 
  0374 A43A 130B  	JEQ	MTST4X		No!	
  0375            
  0376 A43C 0200  	LI	R0,23*32
       A43E 02E0 
  0377 A440 0201  	LI	R1,TXTPBT	Print: Pagebus test
       A442 A1EA 
  0378 A444 06A0  	BL	@DSPLIN
       A446 A750 
  0379 A448 C00F  	MOV	R15,R0		Base address
  0380 A44A 0420  	BLWP	@MTPB		Test pagebus
       A44C A0EA 
  0381 A44E 06A0  	BL	@MTFAIL
       A450 A576 
  0382            MTST4X
  0383 TRUE       #endif
  0384            
  0385            *---------------------------------------------------
  0386            * User Exit Function
  0387            *---------------------------------------------------
  0388 A452 06A0  	BL	@USEXIT

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0009
       A454 A0CC 
  0389 A456 06A0  	BL	@SCROLL		Test finished
       A458 A704 
  0390 A45A 0460  	B	@RETURN
       A45C A674 
  0391            
  0392            *---------------------------------------------------
  0393            * Error message definitions
  0394            *---------------------------------------------------
  0395            	
  0396            *		Text,Reg,Reg,Conv
  0397            
  0398            * Page number      >xxxx
  0399 A45E A307  PN00LB	DATA	TXTPGN,0,0,LOBASC
       A460 0000 
       A462 0000 
       A464 A7EC 
  0400 A466 A307  PN40LB	DATA	TXTPGN,MT#OF1,0,LOBASC
       A468 A83C 
       A46A 0000 
       A46C A7EC 
  0401 A46E A307  PN50LB	DATA	TXTPGN,MT#OF2,0,LOBASC
       A470 A83E 
       A472 0000 
       A474 A7EC 
  0402            
  0403            * Base address     >xxxx
  0404 A476 A31F  BA10WD	DATA	TXTBAS,MT#BAS,0,WRDASC
       A478 A836 
       A47A 0000 
       A47C A808 
  0405            
  0406            * Test address     >xxxx
  0407 A47E A337  TA60WD	DATA	TXTADR,MT#ADR,0,WRDASC
       A480 A840 
       A482 0000 
       A484 A808 
  0408 A486 A337  TA14WD	DATA	TXTADR,MT#BAS,MT#OF1,WRDASC
       A488 A836 
       A48A A83C 
       A48C A808 
  0409 A48E A337  TA15WD	DATA	TXTADR,MT#BAS,MT#OF2,WRDASC
       A490 A836 
       A492 A83E 
       A494 A808 
  0410            
  0411            * Pattern written  >xxxx
  0412 A496 A34F  PW70HB	DATA	TXTWRP,MT#WDP,0,HOBASC
       A498 A842 
       A49A 0000 
       A49C A7EA 
  0413 A49E A34F  PW70WD	DATA	TXTWRP,MT#WDP,0,WRDASC
       A4A0 A842 
       A4A2 0000 
       A4A4 A808 
  0414 A4A6 A34F  PW80HB	DATA	TXTWRP,MT#WIP,0,HOBASC
       A4A8 A844 
       A4AA 0000 
       A4AC A7EA 

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0010
  0415 A4AE A34F  PW80WD	DATA	TXTWRP,MT#WIP,0,WRDASC
       A4B0 A844 
       A4B2 0000 
       A4B4 A808 
  0416            
  0417            * Pattern readback >xxxx
  0418 A4B6 A367  PR90HB	DATA	TXTRDP,MT#RBP,0,HOBASC
       A4B8 A846 
       A4BA 0000 
       A4BC A7EA 
  0419 A4BE A367  PR90WD	DATA	TXTRDP,MT#RBP,0,WRDASC
       A4C0 A846 
       A4C2 0000 
       A4C4 A808 
  0420            
  0421            * Pattern expected >xxxx
  0422 A4C6 A37F  PE70HB	DATA	TXTEXP,MT#WDP,0,HOBASC
       A4C8 A842 
       A4CA 0000 
       A4CC A7EA 
  0423 A4CE A37F  PE70WD	DATA	TXTEXP,MT#WDP,0,WRDASC
       A4D0 A842 
       A4D2 0000 
       A4D4 A808 
  0424 A4D6 A37F  PE80WD	DATA	TXTEXP,MT#WIP,0,WRDASC
       A4D8 A844 
       A4DA 0000 
       A4DC A808 
  0425            
  0426            
  0427            ERRT0
  0428 A4DE A486  ERRT1	DATA	TA14WD,PW70HB,PR90HB,PE70HB
       A4E0 A496 
       A4E2 A4B6 
       A4E4 A4C6 
  0429 A4E6 0000  	DATA	0
  0430            
  0431 A4E8 A476  ERRT2	DATA	BA10WD,PW70HB,TA14WD,PW80HB
       A4EA A496 
       A4EC A486 
       A4EE A4A6 
  0432 A4F0 A476  	DATA	BA10WD,PR90HB,PE70HB
       A4F2 A4B6 
       A4F4 A4C6 
  0433 A4F6 0000  	DATA	0
  0434            
  0435 A4F8 A486  ERRT3	DATA	TA14WD,PW70HB,BA10WD,PW80HB
       A4FA A496 
       A4FC A476 
       A4FE A4A6 
  0436 A500 A486  	DATA	TA14WD,PR90HB,PE70HB
       A502 A4B6 
       A504 A4C6 
  0437 A506 0000  	DATA	0
  0438            
  0439 A508 A48E  ERRT4	DATA	TA15WD,PW70HB,TA14WD,PW80HB
       A50A A496 
       A50C A486 
       A50E A4A6 

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0011
  0440 A510 A48E  	DATA	TA15WD,PR90HB,PE70HB
       A512 A4B6 
       A514 A4C6 
  0441 A516 0000  	DATA	0
  0442            
  0443 A518 A47E  ERRT5	DATA	TA60WD,PW70WD,PR90WD,PE70WD
       A51A A49E 
       A51C A4BE 
       A51E A4CE 
  0444 A520 0000  	DATA	0
  0445            
  0446 A522 A47E  ERRT6	DATA	TA60WD,PW80WD,PR90WD,PE80WD
       A524 A4AE 
       A526 A4BE 
       A528 A4D6 
  0447 A52A 0000  	DATA	0
  0448            
  0449 A52C A47E  ERRT7	DATA	TA60WD,PN00LB,PW70HB,PN40LB
       A52E A45E 
       A530 A496 
       A532 A466 
  0450 A534 A4A6  	DATA	PW80HB,PN00LB,PR90HB,PE70HB
       A536 A45E 
       A538 A4B6 
       A53A A4C6 
  0451 A53C 0000  	DATA	0
  0452            
  0453 A53E A47E  ERRT8	DATA	TA60WD,PN40LB,PW70HB,PN00LB
       A540 A466 
       A542 A496 
       A544 A45E 
  0454 A546 A4A6  	DATA	PW80HB,PN40LB,PR90HB,PE70HB
       A548 A466 
       A54A A4B6 
       A54C A4C6 
  0455 A54E 0000  	DATA	0
  0456            
  0457 A550 A47E  ERRT9	DATA	TA60WD,PN50LB,PW70HB,PN40LB
       A552 A46E 
       A554 A496 
       A556 A466 
  0458 A558 A4A6  	DATA	PW80HB,PN50LB,PR90HB,PE70HB
       A55A A46E 
       A55C A4B6 
       A55E A4C6 
  0459 A560 0000  	DATA	0
  0460            
  0461 A562 A4DE  ERMTAB	DATA	ERRT0,ERRT1,ERRT2,ERRT3,ERRT4
       A564 A4DE 
       A566 A4E8 
       A568 A4F8 
       A56A A508 
  0462 A56C A518  	DATA	ERRT5,ERRT6,ERRT7,ERRT8,ERRT9
       A56E A522 
       A570 A52C 
       A572 A53E 
       A574 A550 
  0463            
  0464            *---------------------------------------------------

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0012
  0465            * MTFAIL - Print informative messages about the
  0466            *          failure.
  0467            *
  0468            * Input : MT#xxx Filled
  0469            * Output: -
  0470            * Uses  : R0 - R11
  0471            
  0472 A576 1604  MTFAIL	JNE	MTFL$0		Failure
  0473 A578 0201  	LI	R1,TXTOK	Print: Ok
       A57A A1FB 
  0474 A57C 0460  	B	@PRTCUR
       A57E A780 
  0475            
  0476 A580 CE8B  MTFL$0	MOV	R11,*R10+	Save return address
  0477 A582 06A0  	BL	@USEXIT		User Exit Function
       A584 A0CC 
  0478 A586 0201  	LI	R1,TXTFLD	Print: Failed
       A588 A1FF 
  0479 A58A 06A0  	BL	@PRTCUR
       A58C A780 
  0480            
  0481 A58E C020  	MOV	@MT#ERR,R0	Error code
       A590 A834 
  0482 A592 0201  	LI	R1,TXTERR+8	Convert
       A594 A302 
  0483 A596 06A0  	BL	@WRDASC
       A598 A808 
  0484 A59A 0201  	LI	R1,TXTERR
       A59C A2FA 
  0485 A59E 06A0  	BL	@PRTLIN
       A5A0 A772 
  0486            	
  0487 A5A2 C160  	MOV	@MT#ERR,R5	Error code
       A5A4 A834 
  0488 A5A6 0285  	CI	R5,9		Max error code
       A5A8 0009 
  0489 A5AA 1203  	JLE	MTFL$1		Ok
  0490 A5AC 04C5  	CLR	R5		Unknown error
  0491 A5AE 04E0  	CLR	@MT#ERR
       A5B0 A834 
  0492 A5B2 0A15  MTFL$1	SLA	R5,1
  0493 A5B4 C065  	MOV	@TXTERT(R5),R1	Error text
       A5B6 A208 
  0494 A5B8 06A0  	BL	@PRTLIN
       A5BA A772 
  0495            	
  0496 A5BC C165  	MOV	@ERMTAB(R5),R5
       A5BE A562 
  0497 A5C0 C1B5  MTFL$2	MOV	*R5+,R6		Text table address
  0498 A5C2 1311  	JEQ	MTFL$E		End Of Table
  0499            	
  0500 A5C4 C1F6  	MOV	*R6+,R7		Text address
  0501 A5C6 04C0  	CLR	R0
  0502 A5C8 C236  	MOV	*R6+,R8		Register 1
  0503 A5CA 1301  	JEQ	MTFL$3
  0504 A5CC A018  	A	*R8,R0		Add value
  0505 A5CE C236  MTFL$3	MOV	*R6+,R8		Register 2
  0506 A5D0 1301  	JEQ	MTFL$4
  0507 A5D2 A018  	A	*R8,R0		Add value

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0013
  0508 A5D4 C236  MTFL$4	MOV	*R6+,R8		Conversion function
  0509            	
  0510 A5D6 C047  	MOV	R7,R1		Address for Value
  0511 A5D8 0221  	AI	R1,19
       A5DA 0013 
  0512 A5DC 0698  	BL	*R8		Convert
  0513            	
  0514 A5DE C047  	MOV	R7,R1		Print text
  0515 A5E0 06A0  	BL	@PRTLIN
       A5E2 A772 
  0516 A5E4 10ED  	JMP	MTFL$2
  0517            
  0518 A5E6 06A0  MTFL$E	BL	@BACK		Proceed or back?
       A5E8 A626 
  0519 A5EA 06A0  	BL	@USINIT		User init function
       A5EC A0BE 
  0520 A5EE 0460  	B	@RETURN
       A5F0 A674 
  0521            		
  0522            *---------------------------------------------------
  0523            * Utility routines
  0524      83E0  GPLWS	EQU	>83E0
  0525      000E  SCAN	EQU	>000E
  0526            *VDPRD	EQU	>8800
  0527            *VDPSTA	EQU	>8802
  0528            *VDPWD	EQU	>8C00
  0529            *VDPWA	EQU	>8C02
  0530            
  0531      0000  HOB	EQU	0	High order byte offset
  0532      0001  LOB	EQU	1	Low order byte offset
  0533            
  0534      0000  OFR0	EQU	0	Register offsets from workspace
  0535      0002  OFR1	EQU	2
  0536      0004  OFR2	EQU	4
  0537      0006  OFR3	EQU	6
  0538      0008  OFR4	EQU	8
  0539      000A  OFR5	EQU	10
  0540      000C  OFR6	EQU	12
  0541      000E  OFR7	EQU	14
  0542      0010  OFR8	EQU	16
  0543      0012  OFR9	EQU	18
  0544      0014  OFR10	EQU	20
  0545      0016  OFR11	EQU	22
  0546      0018  OFR12	EQU	24
  0547      001A  OFR13	EQU	26
  0548      001C  OFR14	EQU	28
  0549      001E  OFR15	EQU	30
  0550            
  0551      A04A  UTLWS	EQU	MYWS
  0552 A5F2 0000  SAVR11	DATA	>0000
  0553            
  0554            * KSCAN - Scan the keyboard
  0555            *
  0556            * Input : -
  0557            * Output: SR EQ=1 No key pressed
  0558            *         SR EQ=0 Key pressed
  0559            *         R0 Keycode in LSB
  0560            * Uses  : R0
  0561            *

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0014
  0562      A5F4  KSCAN	EQU	$	DATA UTLWS,KSCAN$
  0563 A5F4 02E0  KSCAN$	LWPI	GPLWS
       A5F6 83E0 
  0564 A5F8 C80B  	MOV	R11,@SAVR11
       A5FA A5F2 
  0565 A5FC 06A0  	BL	@SCAN
       A5FE 000E 
  0566 A600 C2E0  	MOV	@SAVR11,R11
       A602 A5F2 
  0567 A604 02E0  	LWPI	UTLWS
       A606 A04A 
  0568            *	MOV	@SAVR11,@GPLWS+OFR11
  0569 A608 D020  	MOVB	@>8375,R0	Get key code
       A60A 8375 
  0570 A60C 0980  	SRL	R0,8
  0571 A60E 0280  	CI	R0,>00FF	Key pressed
       A610 00FF 
  0572 A612 045B  	B	*R11
  0573            
  0574            * PAUSE - Wait for a key press
  0575            *
  0576            * Input : -
  0577            * Output: -
  0578            * Uses  : R0
  0579            
  0580 A614 CE8B  PAUSE	MOV	R11,*R10+
  0581 A616 06A0  PAUSE1	BL	@KSCAN		Wait for key pressed
       A618 A5F4 
  0582 A61A 13FD  	JEQ	PAUSE1
  0583 A61C 06A0  PAUSE2	BL	@KSCAN		Wait for key release
       A61E A5F4 
  0584 A620 16FD  	JNE	PAUSE2
  0585 A622 0460  	B	@RETURN
       A624 A674 
  0586            
  0587            * BACK - Wait for a key <proceed> or <back>
  0588            *        Goes to title screen if <back>
  0589            *
  0590            * Input : -
  0591            * Output: -
  0592            * Uses  : R0, R1, R2, R3, R13, R14
  0593            *
  0594 A626 CE8B  BACK	MOV	R11,*R10+
  0595 A628 06A0  	BL	@SCROLL
       A62A A704 
  0596 A62C 0201  	LI	R1,TXTBCK	Proceed or back
       A62E A397 
  0597 A630 020E  	LI	R14,12		Proceed key code
       A632 000C 
  0598 A634 1009  	JMP	WHAT0
  0599            
  0600            * REDO - Wait for a key <redo> or <back>
  0601            *        Goes to title screen if <back>
  0602            *
  0603            * Input : -
  0604            * Output: -
  0605            * Uses  : R0, R1, R2, R3, R13, R14
  0606            *
  0607 A636 CE8B  REDO	MOV	R11,*R10+

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0015
  0608 A638 06A0  	BL	@SCROLL
       A63A A704 
  0609 A63C 0201  	LI	R1,TXTRED	Proceed or back
       A63E A3B1 
  0610 A640 020E  	LI	R14,6		Redo key code
       A642 0006 
  0611 A644 1001  	JMP	WHAT0
  0612            
  0613            * WHAT - Wait for a key press 
  0614            *        Goes to title screen if <back>
  0615            *
  0616            * Input : R1 address of text to print
  0617            *         R14 <proceed> or <redo>
  0618            * Output: -
  0619            * Uses  : R0, R1, R2, R3
  0620            *
  0621 A646 CE8B  WHAT	MOV	R11,*R10+
  0622 A648 0200  WHAT0	LI	R0,23*32+1
       A64A 02E1 
  0623 A64C 06A0  	BL	@DSPLIN		Print text
       A64E A750 
  0624 A650 06A0  WHAT1	BL	@KSCAN		Wait for key pressed
       A652 A5F4 
  0625 A654 13FD  	JEQ	WHAT1
  0626 A656 C040  	MOV	R0,R1
  0627 A658 06A0  WHAT2	BL	@KSCAN		Wait for key release
       A65A A5F4 
  0628 A65C 16FD  	JNE	WHAT2
  0629 A65E 8381  	C	R1,R14		Proceed/Redo?
  0630 A660 1305  	JEQ	WHAT3		Yes!
  0631 A662 0281  	CI	R1,15		Back?
       A664 000F 
  0632 A666 16F4  	JNE	WHAT1		No!
  0633 A668 0460  	B	@QUIT		Goodbye!
       A66A A67A 
  0634 A66C 06A0  WHAT3	BL	@SCROLL
       A66E A704 
  0635 A670 0460  	B	@RETURN
       A672 A674 
  0636            
  0637            * General stack routines
  0638            *
  0639            * Return from subroutine (called with BL @xxxx)
  0640            * With undefined status
  0641            *
  0642 A674 064A  RETURN	DECT R10		Fetch return adres
  0643 A676 C2DA  	MOV  *R10,R11
  0644 A678 045B  	B    *R11		Return to calling program
  0645            
  0646            * Quit function
  0647            *
  0648            * First call user exit function before
  0649            * returning to title screen
  0650            *
  0651 A67A 06A0  QUIT   BL   @USEXIT
       A67C A0CC 
  0652 A67E 0420         BLWP @>0000
       A680 0000 
  0653            

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0016
  0654            
  0655            * General VDP routines
  0656            
  0657      8C02  VDPWA  EQU  >8C02	      VDP write address
  0658      8C00  VDPWD  EQU  >8C00	      VDP write data address
  0659      8800  VDPRD  EQU  >8800	      VDP read  data address
  0660            
  0661            * VDPADW - VDP Address Write
  0662            * VDPADR - VDP Address Read
  0663            *
  0664            * Set the VDP write address
  0665            *
  0666            * Input:
  0667            *      R0   VDP address
  0668            * Output:
  0669            * Uses:
  0670            *      R0
  0671            
  0672 A682 0000  VDPLWA DATA >0000        VDP last write address
  0673 A684 4000  VDPWAO DATA >4000        VDP write address bits
  0674            
  0675 A686 C800  VDPADW	MOV  R0,@VDPLWA  Save VDP write address
       A688 A682 
  0676 A68A E020  	SOC  @VDPWAO,R0	 Set write address bits
       A68C A684 
  0677 A68E 06C0  VDPADR	SWPB R0		 Write lsb R0 first
  0678 A690 D800  	MOVB R0,@VDPWA
       A692 8C02 
  0679 A694 06C0  	SWPB R0		 Write msb R0
  0680 A696 D800  	MOVB R0,@VDPWA
       A698 8C02 
  0681 A69A 045B  	B    *R11
  0682            
  0683            * VSBW - VDP Single Byte Write
  0684            *
  0685            * Input:
  0686            *      R0   VDP address
  0687            *      R1   msb Data
  0688            * Output:
  0689            * Uses:
  0690            *      R0
  0691            
  0692 A69C CE8B  VSBW	MOV  R11,*R10+
  0693 A69E 06A0  	BL   @VDPADW
       A6A0 A686 
  0694 A6A2 D801  	MOVB R1,@VDPWD
       A6A4 8C00 
  0695 A6A6 0460  	B    @RETURN
       A6A8 A674 
  0696            
  0697            * VMBW - VDP Multiple Byte Write
  0698            *
  0699            * Input:
  0700            *      R0   VDP address
  0701            *      R1   Data address
  0702            *      R2   Bytecount
  0703            * Output:
  0704            * Uses:
  0705            *      R0,R1,R2

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0017
  0706            
  0707 A6AA CE8B  VMBW	MOV  R11,*R10+
  0708 A6AC 06A0  	BL   @VDPADW
       A6AE A686 
  0709 A6B0 C082  	MOV  R2,R2	Something to copy?
  0710 A6B2 1304  	JEQ  VMBW2	No!
  0711 A6B4 D831  VMBW1	MOVB *R1+,@VDPWD
       A6B6 8C00 
  0712 A6B8 0602  	DEC  R2
  0713 A6BA 16FC  	JNE  VMBW1
  0714 A6BC 0460  VMBW2	B    @RETURN
       A6BE A674 
  0715            
  0716            * VSBR - VDP Single Byte Read
  0717            *
  0718            * Input:
  0719            *      R0   VDP address
  0720            * Output:
  0721            *      R1   msb Data
  0722            * Uses:
  0723            *      R0,R1
  0724            
  0725 A6C0 CE8B  VSBR	MOV  R11,*R10+
  0726 A6C2 06A0  	BL   @VDPADR
       A6C4 A68E 
  0727 A6C6 D060  	MOVB @VDPRD,R1
       A6C8 8800 
  0728 A6CA 0460  	B    @RETURN
       A6CC A674 
  0729            
  0730            * VMBR - VDP Multiple Byte Read
  0731            *
  0732            * Input:
  0733            *      R0   VDP address
  0734            *      R1   Data address
  0735            *      R2   Bytecount
  0736            * Output:
  0737            * Uses:
  0738            *      R0,R1,R2
  0739            
  0740 A6CE CE8B  VMBR	MOV  R11,*R10+
  0741 A6D0 06A0  	BL   @VDPADR
       A6D2 A68E 
  0742 A6D4 C082  	MOV  R2,R2	Something to copy?
  0743 A6D6 1304  	JEQ  VMBR2	No!
  0744 A6D8 DC60  VMBR1	MOVB @VDPRD,*R1+
       A6DA 8800 
  0745 A6DC 0602  	DEC  R2
  0746 A6DE 16FC  	JNE  VMBR1
  0747 A6E0 0460  VMBR2	B    @RETURN
       A6E2 A674 
  0748            
  0749            * SCROLL - Scrolls the screen (24*32) one line up
  0750            *
  0751            * Input:
  0752            * Output:
  0753            * Uses: 
  0754            *      R0,R1,R2,R3
  0755            *

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0018
  0756 A6E4       SCRBUF	BSS	32
  0757 A704 CE8B  SCROLL	MOV	R11,*R10+
  0758 A706 0203  SCRLL0	LI	R3,0		To line number
       A708 0000 
  0759            
  0760 A70A C003  SCRLL1	MOV	R3,R0		Copy from
  0761 A70C 0220  	AI	R0,32
       A70E 0020 
  0762 A710 0201  	LI	R1,SCRBUF
       A712 A6E4 
  0763 A714 0202  	LI	R2,32
       A716 0020 
  0764 A718 06A0  	BL	@VMBR
       A71A A6CE 
  0765            
  0766 A71C C003  	MOV	R3,R0		Copy to
  0767 A71E 0201  	LI	R1,SCRBUF
       A720 A6E4 
  0768 A722 0202  	LI	R2,32
       A724 0020 
  0769 A726 06A0  	BL	@VMBW
       A728 A6AA 
  0770 A72A 0223  	AI	R3,32
       A72C 0020 
  0771 A72E 0283  	CI	R3,23*32	All lines done?
       A730 02E0 
  0772 A732 1AEB  	JL	SCRLL1		No!
  0773            
  0774 A734 0201  	LI	R1,>2000	+>6000	Space
       A736 2000 
  0775 A738 A060  	A	@SCROFF,R1
       A73A A004 
  0776 A73C 0202  	LI	R2,32
       A73E 0020 
  0777 A740 D801  SCRLL2	MOVB	R1,@VDPWD
       A742 8C00 
  0778 A744 0602  	DEC	R2
  0779 A746 16FC  	JNE	SCRLL2
  0780 A748 0460  	B	@RETURN
       A74A A674 
  0781            
  0782            * DSPLIN - Displays a line with text at the given location
  0783            *		until character 0 encountered
  0784            * DSPCUR - Displays a line with text at the current location
  0785            *		until character 0 encountered
  0786            *
  0787            * Input : R0 Screen location
  0788            *         R1 Address of line with text
  0789            * Output: R2 Number of characters printed
  0790            * Uses  : R0,R1,R2,R3
  0791            *
  0792 A74C CE8B  DSPCUR	MOV	R11,*R10+	Save return address
  0793 A74E 1003  	JMP	DSPLN0
  0794 A750 CE8B  DSPLIN	MOV	R11,*R10+	Save return address
  0795 A752 06A0  	BL	@VDPADW		Set screen location
       A754 A686 
  0796 A756 04C2  DSPLN0	CLR	R2
  0797 A758 C0E0  	MOV	@SCROFF,R3
       A75A A004 

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0019
  0798 A75C D031  DSPLN1	MOVB	*R1+,R0		Get character
  0799 A75E 1307  	JEQ	DSPLN2		End of string
  0800 A760 A003  	A	R3,R0		Add screen offset
  0801 A762 D800  	MOVB	R0,@VDPWD
       A764 8C00 
  0802 A766 05A0  	INC	@VDPLWA
       A768 A682 
  0803 A76A 0582  	INC	R2
  0804 A76C 10F7  	JMP	DSPLN1
  0805 A76E 0460  DSPLN2	B	@RETURN
       A770 A674 
  0806            
  0807            * PRTLIN - Prints a line with text on the last line of the s
  0808            *		until character 0 encountered and scroll the screen
  0809            *		one line.
  0810            *
  0811            * Input : R1 Address of line with text
  0812            * Output: -
  0813            * Uses  : R0,R1,R2
  0814            *
  0815 A772 CE8B  PRTLIN	MOV	R11,*R10+
  0816 A774 0200  	LI	R0,23*32	Set screen address at line 23
       A776 02E0 
  0817 A778 06A0  	BL	@DSPLIN
       A77A A750 
  0818 A77C 0460  	B	@SCRLL0		Scroll a line and return
       A77E A706 
  0819            
  0820            * PRTCUR - Appends a line with text on the last line of the 
  0821            *		until character 0 encountered and scroll the screen
  0822            *		one line.
  0823            *
  0824            * Input : R1 Address of line with text
  0825            * Output: -
  0826            * Uses  : R0,R1,R2
  0827            *
  0828 A780 CE8B  PRTCUR	MOV	R11,*R10+
  0829 A782 06A0  	BL	@DSPCUR
       A784 A74C 
  0830 A786 0460  	B	@SCRLL0		Scroll a line and return
       A788 A706 
  0831            
  0832            
  0833 TRUE       #ifdef TXTCRU
  0834            * ASKCRU - Ask for CRU address
  0835            *
  0836            * Input : -
  0837            * Output: R12 CRU address, or >0000 to quit
  0838            * Uses  : R0, R1, R2, R3, R11, R12, R13, R14, R15
  0839            *
  0840 A78A CE8B  ASKCRU	MOV	R11,*R10+
  0841 A78C 06A0  	BL	@SCROLL
       A78E A704 
  0842 A790 0201  	LI	R1,TXTCRU
       A792 A01A 
  0843 A794 06A0  	BL	@DSPLIN
       A796 A750 
  0844 A798 0620  	DEC	@VDPLWA		Backspace one character
       A79A A682 

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0020
  0845 A79C 04CC  	CLR	R12
  0846            	
  0847 A79E 06A0  ASKCR0	BL	@KSCAN		Wait for key pressed
       A7A0 A5F4 
  0848 A7A2 13FD  	JEQ	ASKCR0
  0849 A7A4 C040  	MOV	R0,R1
  0850            
  0851 A7A6 0281  	CI	R1,15		Back?
       A7A8 000F 
  0852 A7AA 131D  	JEQ	ASKCR4		Yes!
  0853            
  0854 A7AC C020  	MOV	@VDPLWA,R0	Display key
       A7AE A682 
  0855 A7B0 C301  	MOV	R1,R12
  0856 A7B2 06C1  	SWPB	R1
  0857 A7B4 06A0  	BL	@VSBW
       A7B6 A69C 
  0858            
  0859 A7B8 06A0  ASKCR1	BL	@KSCAN		Wait for key release
       A7BA A5F4 
  0860 A7BC 16FD  	JNE	ASKCR1
  0861            	
  0862 A7BE 028C  	CI	R12,>0030	0 - 9
       A7C0 0030 
  0863 A7C2 11ED  	JLT	ASKCR0
  0864 A7C4 028C  	CI	R12,>0039
       A7C6 0039 
  0865 A7C8 1B03  	JH	ASKCR2
  0866 A7CA 022C  	AI	R12,->0030	Make nibble >0 - >9
       A7CC FFD0 
  0867 A7CE 1008  	JMP	ASKCR3	
  0868            	
  0869 A7D0 028C  ASKCR2	CI	R12,>0041	A - F
       A7D2 0041 
  0870 A7D4 11E4  	JLT	ASKCR0
  0871 A7D6 028C  	CI	R12,>0046
       A7D8 0046 
  0872 A7DA 1BE1  	JH	ASKCR0
  0873 A7DC 022C  	AI	R12,->0041+>A	Make nibble >A - >F
       A7DE FFC9 
  0874            	
  0875 A7E0 0A8C  ASKCR3	SLA	R12,8		Make CRU address
  0876 A7E2 022C  	AI	R12,>1000
       A7E4 1000 
  0877 A7E6 0460  ASKCR4	B	@RETURN
       A7E8 A674 
  0878 TRUE       #endif
  0879            
  0880            * WRDASC - Convert WORD in R0 to ASCII string
  0881            * LOBASC - Convert LO-BYTE in R0 to ASCII
  0882            * HOBASC - Convert HO-BYTE in R0 to ASCII
  0883            *
  0884            * Input:
  0885            *	R0 Number
  0886            *	R1 address of buffer
  0887            * Output:
  0888            * Uses: R0, R1, R2
  0889            *
  0890 A7EA 06C0  HOBASC	SWPB	R0

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0021
  0891 A7EC CE8B  LOBASC	MOV	R11,*R10+
  0892 A7EE C080  	MOV	R0,R2		Save byte
  0893 A7F0 0240  	ANDI	R0,>00F0	First HO-Nibble
       A7F2 00F0 
  0894 A7F4 0940  	SRL	R0,4
  0895 A7F6 06A0  	BL	@CASCII
       A7F8 A81A 
  0896 A7FA C002  	MOV	R2,R0		Second LO-Nibble
  0897 A7FC 0240  	ANDI	R0,>000F
       A7FE 000F 
  0898 A800 06A0  	BL	@CASCII
       A802 A81A 
  0899 A804 0460  	B	@RETURN
       A806 A674 
  0900            	
  0901 A808 CE8B  WRDASC	MOV	R11,*R10+
  0902 A80A 06A0  	BL	@HOBASC		First HO-Byte
       A80C A7EA 
  0903 A80E C002  	MOV	R2,R0
  0904 A810 06A0  	BL	@HOBASC		Next LO-Byte
       A812 A7EA 
  0905 A814 0460  	B	@RETURN
       A816 A674 
  0906            
  0907            
  0908            * CASCII - Convert LONibble in R0 to ASCII
  0909            *
  0910            * Input:
  0911            *	R0 LON hex digit
  0912            *	R1 Address to store ASCII
  0913            * Output:
  0914            *	R0 HOB ascii value
  0915            * Uses:
  0916            *	R1, R1
  0917            *
  0918 A818 0000  CNULL	DATA	>0000
  0919 A81A 0280  CASCII	CI	R0,9
       A81C 0009 
  0920 A81E 1B03  	JH	CASCAF
  0921 A820 0220  	AI	R0,'0'
       A822 0030 
  0922 A824 1002  	JMP	CASEND
  0923 A826 0220  CASCAF	AI	R0,'A'-10
       A828 0037 
  0924 A82A 06C0  CASEND	SWPB	R0
  0925 A82C DC40  	MOVB	R0,*R1+
  0926 A82E D460  	MOVB	@CNULL,*R1
       A830 A818 
  0927 A832 045B  	B	*R11
  0928            
  0929            
  0930            * End Of Misc Functions
  0931            	COPY ".\MEMT_FUNC.A99"
  0932            * TI99 Memory test functions
  0933            *
  0934            * Copyright (c) 1998 by Michael Barr.
  0935            * Converted to TMS9900 assembly by: Frederik G. Kaal, 06 may
  0936            
  0937            *	TITL 'MEMTEST FUNCTIONS 06/05/2007'

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0022
  0938            *	IDT 'MEMTEST'
  0939            
  0940            	DEF	MTDB,MTAB,MTDV
  0941            
  0942            * Memory test functions
  0943            *
  0944            * All test functions take as input an address in R0
  0945            * consisting of a Base address, Region size and the
  0946            * databus width of the device.
  0947            * All test functions returns the used addresses,
  0948            * values and patterns as described in the following
  0949            * table.
  0950            *
  0951      A834  MT#WSP	EQU	$	Memorytest workspace
  0952 A834 0000  MT#ERR	DATA	0	(R0)  Error code
  0953 A836 0000  MT#BAS	DATA	0	(R1)  Base address
  0954 A838 0000  MT#RSZ	DATA	0	(R2)  Region size
  0955 A83A 0000  MT#IAP	DATA	0	(R3)  Inverted address mask
  0956 A83C 0000  MT#OF1	DATA	0	(R4)  Offset 1 in device (write)
  0957 A83E 0000  MT#OF2	DATA	0	(R5)  Offset 2 in device (read/test)
  0958 A840 0000  MT#ADR	DATA	0	(R6)  Base address + Offset 1 or 2
  0959 A842 0000  MT#WDP	DATA	0	(R7)  Written default  pattern
  0960 A844 0000  MT#WIP	DATA	0	(R8)  Written inverted pattern
  0961 A846 0000  MT#RBP	DATA	0	(R9)  Readback pattern
  0962 A848 0000  MT#MNP	DATA	0	(R10) Max number of pages
  0963 A84A 0000  MT#R11	DATA	0
  0964 A84C 0000  MT#R12	DATA	0
  0965 A84E 0000  MT#R13	DATA	0
  0966 A850 0000  MT#R14	DATA	0
  0967 A852 0000  MT#R15	DATA	0
  0968            
  0969 A854 A834  MTDB	DATA	MT#WSP,MTDB$	Databus test
       A856 A87A 
  0970 A858 A834  MTAB	DATA	MT#WSP,MTAB$	Adresbus test
       A85A A8BC 
  0971 A85C A834  MTDV	DATA	MT#WSP,MTDV$	Device test
       A85E A952 
  0972            
  0973            * MTGTTV - Memorytest Get Table Values
  0974            *
  0975            * Get the table values of a memory region under test.
  0976            *
  0977            * Input : R13 Pointer to callers workspace in witch
  0978            *             R0 contains the address of structure with
  0979            *             Base address,Region size,Databus width 8/16,
  0980            *             address mask and number of pages.
  0981            *
  0982            * Output: R1 Base address
  0983            *         R2 Region size
  0984            *         R3 Databus width
  0985            *         R10 Number of pages
  0986            *
  0987            * Uses  : R0,R1,R2,R3,R11
  0988            *
  0989 A860 C29D  MTGTTV	MOV	*R13,R10	Get test table entry
  0990 A862 C07A  	MOV	*R10+,R1	Base address
  0991 A864 C0BA  	MOV	*R10+,R2	Region size
  0992 A866 C0FA  	MOV	*R10+,R3	Databus with
  0993 A868 C03A  	MOV	*R10+,R0	Address mask

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0023
  0994 A86A C2BA  	MOV	*R10+,R10	Number of pages
  0995 A86C 04C4  	CLR	R4
  0996 A86E 04C5  	CLR	R5
  0997 A870 04C6  	CLR	R6
  0998 A872 04C7  	CLR	R7
  0999 A874 04C8  	CLR	R8
  1000 A876 04C9  	CLR	R9
  1001 A878 045B  	B	*R11
  1002            
  1003            * MTDB - Memorytest DataBus
  1004            *
  1005            * Test the databus wiring in a memory region by
  1006            * performing a walking 1's test (LSB to MSB) at
  1007            * a fixed address within that region.
  1008            *
  1009            * Input : R0 of callers workspace contains address of
  1010            *            structure with  Base address,Region size,
  1011            *            Databus width 8/16, Address mask and
  1012            *            Number of pages.
  1013            *
  1014            * Output: SR EQ=1 test succeeded, MT#ERR=0
  1015            *         SR EQ=0 test failed
  1016            *	  MT#ERR=1 Databus failure
  1017            *         and rest of MT#WSP filled as described.
  1018            *
  1019            * Uses  : All
  1020            
  1021 A87A 06A0  MTDB$	BL	@MTGTTV		Get memory test table values
       A87C A860 
  1022 A87E C181  	MOV	R1,R6		Test address
  1023 A880 0207  	LI	R7,>0001	Assume 16 bits
       A882 0001 
  1024 A884 0283  	CI	R3,16		Width is 16 bits?
       A886 0010 
  1025 A888 1309  	JEQ	MTDB3		Yes!
  1026 A88A 0207  	LI	R7,>0100	No, 8 bits!
       A88C 0100 
  1027            	
  1028 A88E D587  MTDB1	MOVB	R7,*R6		Write pattern
  1029 A890 D256  	MOVB	*R6,R9		Read back
  1030 A892 9247  	CB	R7,R9		Equal?
  1031 A894 160E  	JNE	MTDBNE		No!
  1032 A896 0A17  	SLA	R7,1		Next bit
  1033 A898 16FA  	JNE	MTDB1
  1034 A89A 1007  	JMP	MTDBEQ		Success
  1035            	
  1036 A89C C587  MTDB3	MOV	R7,*R6		Write pattern
  1037 A89E C256  	MOV	*R6,R9		Read back
  1038 A8A0 8247  	C	R7,R9		Equal?
  1039 A8A2 1607  	JNE	MTDBNE		No!
  1040 A8A4 0A17  	SLA	R7,1		Next bit
  1041 A8A6 16FA  	JNE	MTDB3		
  1042 A8A8 1000  	JMP	MTDBEQ		Success
  1043            
  1044 A8AA 04C0  MTDBEQ	CLR	R0		Error 0: Success
  1045 A8AC 026F  	ORI	R15,>2000	Success, set EQ
       A8AE 2000 
  1046 A8B0 0380  	RTWP
  1047 A8B2 0200  MTDBNE	LI	R0,1		Error 1: Databus failure

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0024
       A8B4 0001 
  1048 A8B6 024F  	ANDI	R15,>DFFF	Failure, reset EQ
       A8B8 DFFF 
  1049 A8BA 0380  	RTWP
  1050            
  1051            
  1052            * MTAB - Memorytest AddressBus
  1053            *
  1054            * Test the address bus wiring in a memory region by
  1055            * performing a walking 1's test on the relevant bits
  1056            * of the address and checking for aliasing. This test
  1057            * will find single-bit address failures such as stuck
  1058            * -high, stuck-low, and shorted pins.  The base address
  1059            * and size of the region are selected by the caller.
  1060            *
  1061            * Input : R0 of callers workspace contains address of
  1062            *            structure with  Base address,Region size,
  1063            *            Databus width 8/16, Address mask and
  1064            *            Number of pages.
  1065            *
  1066            * Output: SR EQ=1 test succeeded
  1067            *         SR EQ=0 test failed
  1068            *         MT#ERR=2 Address line stuck low
  1069            *         MT#ERR=3 Address line stuck high
  1070            *         MT#ERR=4 Address lines shorted
  1071            *         and rest of MT#WSP filled as described.
  1072            *
  1073            * Uses  : All
  1074            
  1075 A8BC 06A0  MTAB$	BL	@MTGTTV		Get memory test table values
       A8BE A860 
  1076            
  1077 A8C0 C101  	MOV	R1,R4		Base address
  1078 A8C2 C142  	MOV	R2,R5		Region size
  1079 A8C4 04F4  MTAB0	CLR	*R4+		Clear region
  1080 A8C6 0645  	DECT	R5
  1081 A8C8 16FD  	JNE	MTAB0	
  1082            
  1083 A8CA C0C0  	MOV	R0,R3		Address mask
  1084 A8CC 0543  	INV	R3		Inverted address mask
  1085 A8CE 0207  	LI	R7,>A500	Pattern
       A8D0 A500 
  1086 A8D2 0208  	LI	R8,>5A00	Inverted pattern
       A8D4 5A00 
  1087            
  1088            * Write the default pattern at each of the power-of-two offs
  1089 A8D6 0204  	LI	R4,1		Offset
       A8D8 0001 
  1090 A8DA C181  MTAB1	MOV	R1,R6		Base address
  1091 A8DC A184  	A	R4,R6		+ Offset
  1092 A8DE D587  	MOVB	R7,*R6		= Pattern
  1093 A8E0 0A14  	SLA	R4,1		Offset <<= 1
  1094 A8E2 4103  	SZC	R3,R4		& address mask
  1095 A8E4 16FA  	JNE	MTAB1
  1096            	
  1097            * Check for address bits stuck high.
  1098 A8E6 D448  	MOVB	R8,*R1		Base address = Inverted pattern
  1099            	
  1100 A8E8 04C9  	CLR	R9		Readback register

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0025
  1101 A8EA 0204  	LI	R4,1		Offset
       A8EC 0001 
  1102 A8EE C181  MTAB2	MOV	R1,R6		Base address
  1103 A8F0 A184  	A	R4,R6		+ Offset
  1104 A8F2 D256  	MOVB	*R6,R9		Read back
  1105 A8F4 9247  	CB	R7,R9		Equals Pattern
  1106 A8F6 1625  	JNE	MTABE3		No, stuck high!
  1107 A8F8 0A14  	SLA	R4,1		Offset <<= 1
  1108 A8FA 4103  	SZC	R3,R4		& address mask
  1109 A8FC 16F8  	JNE	MTAB2
  1110            
  1111            * Check for address bits stuck low or shorted.
  1112 A8FE D447  	MOVB	R7,*R1		Base address = Pattern
  1113            
  1114 A900 0204  	LI	R4,1		Testoffset
       A902 0001 
  1115 A904 C181  MTAB3	MOV	R1,R6		Base address
  1116 A906 A184  	A	R4,R6		+ TestOffset
  1117 A908 D588  	MOVB	R8,*R6		= Inverted Pattern
  1118 A90A D251  	MOVB	*R1,R9		Readback Base address
  1119 A90C 9247  	CB	R7,R9		Address stuck low?
  1120 A90E 1616  	JNE	MTABE2		Yes, Error!
  1121            
  1122 A910 0205  	LI	R5,1		Offset
       A912 0001 
  1123 A914 8105  MTAB4	C	R5,R4		Offset == TestOffset?
  1124 A916 1305  	JEQ	MTAB5		Yes, do not check!
  1125 A918 C181  	MOV	R1,R6		Base address
  1126 A91A A185  	A	R5,R6		+ Offset
  1127 A91C D256  	MOVB	*R6,R9		Readback
  1128 A91E 9247  	CB	R7,R9		Equals Pattern
  1129 A920 1613  	JNE	MTABE4		No, address lines shorted!
  1130 A922 0A15  MTAB5	SLA	R5,1		Offset <<= 1
  1131 A924 4143  	SZC	R3,R5		& address mask
  1132 A926 16F6  	JNE	MTAB4
  1133            
  1134 A928 C181  	MOV	R1,R6		Base address
  1135 A92A A184  	A	R4,R6		+ TestOffset
  1136 A92C D587  	MOVB	R7,*R6		= Pattern
  1137            
  1138 A92E 0A14  	SLA	R4,1		TestOffset <<= 1
  1139 A930 4103  	SZC	R3,R4		& address mask
  1140 A932 16E8  	JNE	MTAB3
  1141            
  1142 A934 04C0  MTABEQ	CLR	R0		Error 0: Success
  1143 A936 026F  	ORI	R15,>2000	Success, set EQ
       A938 2000 
  1144 A93A 0380  	RTWP
  1145            	
  1146 A93C 0200  MTABE2	LI	R0,2		Error 2: Address line stuck low
       A93E 0002 
  1147 A940 1005  	JMP	MTABNE	
  1148 A942 0200  MTABE3	LI	R0,3		Error 3: Address line stuck high
       A944 0003 
  1149 A946 1002  	JMP	MTABNE	
  1150 A948 0200  MTABE4	LI	R0,4		Error 4: Address lines shorted
       A94A 0004 
  1151 A94C 024F  MTABNE	ANDI	R15,>DFFF	Failure, reset EQ
       A94E DFFF 

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0026
  1152 A950 0380  	RTWP
  1153            
  1154            
  1155            * MTDV - Memorytest Device
  1156            *
  1157            * Test the integrity of a physical memory device by
  1158            * performing an increment/decrement test over the
  1159            * entire region.  In the process every storage bit 
  1160            * in the device is tested as a zero and a one.  The
  1161            * base address and the size of the region are
  1162            * selected by the caller.
  1163            *
  1164            * Input : R0 of callers workspace contains address of
  1165            *            structure with  Base address,Region size,
  1166            *            Databus width 8/16, Address mask and
  1167            *            Number of pages.
  1168            *
  1169            * Output: SR EQ=1 test succeeded
  1170            *         SR EQ=0 test failed
  1171            *         MT#ERR=5 Wrong pattern read back
  1172            *         MT#ERR=6 Wrong inverted pattern read back
  1173            *         and rest of MT#WSP filled as described.
  1174            *
  1175            * Uses  : All
  1176            
  1177 A952 06A0  MTDV$	BL	@MTGTTV		Get memory test table values
       A954 A860 
  1178            
  1179            * Fill memory with a known pattern.
  1180            
  1181 A956 04C4  	CLR	R4		Offset
  1182 A958 0207  	LI	R7,1		Pattern
       A95A 0001 
  1183 A95C C181  	MOV	R1,R6		Base address
  1184 A95E CD87  MTDV1	MOV	R7,*R6+
  1185 A960 0587  	INC	R7
  1186 A962 05C4  	INCT	R4
  1187 A964 8084  	C	R4,R2		End of region?
  1188 A966 1AFB  	JL	MTDV1		No!
  1189            	
  1190            * Check each location and invert it for the second pass.
  1191            
  1192 A968 04C9  	CLR	R9		Readback register
  1193 A96A 04C4  	CLR	R4		Offset
  1194 A96C 0207  	LI	R7,1		Pattern
       A96E 0001 
  1195 A970 C181  	MOV	R1,R6		Base address
  1196 A972 C256  MTDV2	MOV	*R6,R9		Read pattern
  1197 A974 8247  	C	R7,R9		Equals pattern?
  1198 A976 1619  	JNE	MTDVE5		No!
  1199 A978 C207  	MOV	R7,R8		Write inverted pattern
  1200 A97A 0548  	INV	R8
  1201 A97C CD88  	MOV	R8,*R6+
  1202 A97E 0587  	INC	R7		Increment pattern
  1203 A980 05C4  	INCT	R4		Increment offset
  1204 A982 8084  	C	R4,R2		End of region?
  1205 A984 1AF6  	JL	MTDV2		No!
  1206            
  1207            * Check each location for the inverted pattern and zero it.

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0027
  1208            
  1209 A986 04C4  	CLR	R4		Offset
  1210 A988 0207  	LI	R7,1		Pattern
       A98A 0001 
  1211 A98C C181  	MOV	R1,R6		Base address
  1212 A98E C207  MTDV3	MOV	R7,R8		Invert pattern
  1213 A990 0548  	INV	R8
  1214 A992 C256  	MOV	*R6,R9		Read pattern
  1215 A994 8248  	C	R8,R9		Equals inverted pattern?
  1216 A996 160C  	JNE	MTDVE6		No!
  1217 A998 04F6  	CLR	*R6+		Clear address
  1218 A99A 0587  	INC	R7		Next pattern
  1219 A99C 05C4  	INCT	R4		Next offset
  1220 A99E 8084  	C	R4,R2		End of region?
  1221 A9A0 1AF6  	JL	MTDV3		No!
  1222 A9A2 04C0  MTDVEQ	CLR	R0		Error 0: Success
  1223 A9A4 026F  	ORI	R15,>2000	Success, set EQ
       A9A6 2000 
  1224 A9A8 0380  	RTWP
  1225            
  1226 A9AA 0200  MTDVE5	LI	R0,5		Error 5: Wrong pattern
       A9AC 0005 
  1227 A9AE 1002  	JMP	MTDVNE
  1228 A9B0 0200  MTDVE6	LI	R0,6		Error 6: Wrong inverted pattern
       A9B2 0006 
  1229 A9B4 024F  MTDVNE	ANDI	R15,>DFFF	Failure, reset EQ
       A9B6 DFFF 
  1230 A9B8 0380  	RTWP
  1231            	
  1232            *	END
  1233                   
  1234      A9BA  SLAST	EQU	$
  1235            	END

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0028
    ASKCR0  A79E      ASKCR1  A7B8      ASKCR2  A7D0      ASKCR3  A7E0  
    ASKCR4  A7E6      ASKCRU  A78A      BA10WD  A476      BACK    A626  
    BEGIN   A074      BEGIN1  A07C      BEGIN2  A096      BEGIN3  A0AA  
    CASCAF  A826      CASCII  A81A      CASEND  A82A      CNULL   A818  
    DSPCUR  A74C      DSPLIN  A750      DSPLN0  A756      DSPLN1  A75C  
    DSPLN2  A76E      ENDTAB  A044      ERMTAB  A562      ERRT0   A4DE  
    ERRT1   A4DE      ERRT2   A4E8      ERRT3   A4F8      ERRT4   A508  
    ERRT5   A518      ERRT6   A522      ERRT7   A52C      ERRT8   A53E  
    ERRT9   A550      GPLWS   83E0      HOB     0000      HOBASC  A7EA  
    KSCAN   A5F4      KSCAN$  A5F4      LOB     0001      LOBASC  A7EC  
    MAIN    A074      MEMTAB  A03A      MEMTEZ  000A      MT#ADR  A840  
    MT#BAS  A836      MT#ERR  A834      MT#IAP  A83A      MT#MNP  A848  
    MT#OF1  A83C      MT#OF2  A83E      MT#R11  A84A      MT#R12  A84C  
    MT#R13  A84E      MT#R14  A850      MT#R15  A852      MT#RBP  A846  
    MT#RSZ  A838      MT#WDP  A842      MT#WIP  A844      MT#WSP  A834  
  D MTAB    A858      MTAB$   A8BC      MTAB0   A8C4      MTAB1   A8DA  
    MTAB2   A8EE      MTAB3   A904      MTAB4   A914      MTAB5   A922  
    MTABE2  A93C      MTABE3  A942      MTABE4  A948      MTABEQ  A934  
    MTABNE  A94C    D MTDB    A854      MTDB$   A87A      MTDB1   A88E  
    MTDB3   A89C      MTDBEQ  A8AA      MTDBNE  A8B2    D MTDV    A85C  
    MTDV$   A952      MTDV1   A95E      MTDV2   A972      MTDV3   A98E  
    MTDVE5  A9AA      MTDVE6  A9B0      MTDVEQ  A9A2      MTDVNE  A9B4  
    MTEST   A3C8      MTEST1  A3F2      MTEST2  A408      MTEST3  A41E  
    MTEST4  A434      MTFAIL  A576      MTFL$0  A580      MTFL$1  A5B2  
    MTFL$2  A5C0      MTFL$3  A5CE      MTFL$4  A5D4      MTFL$E  A5E6  
    MTGTTV  A860      MTPB    A0EA      MTPB$   A0EE      MTPB0   A0FE  
    MTPB1   A110      MTPB2   A12A      MTPB3   A146      MTPB4   A15C  
    MTPB5   A16C      MTPBE7  A188      MTPBE8  A18E      MTPBE9  A194  
    MTPBEQ  A180      MTPBNE  A198      MTST4X  A452      MYCRU   A048  
    MYWS    A04A      OFBASE  0000      OFMASK  0006      OFPAGE  0008  
    OFR0    0000      OFR1    0002      OFR10   0014      OFR11   0016  
    OFR12   0018      OFR13   001A      OFR14   001C      OFR15   001E  
    OFR2    0004      OFR3    0006      OFR4    0008      OFR5    000A  
    OFR6    000C      OFR7    000E      OFR8    0010      OFR9    0012  
    OFSIZE  0002      OFWIDT  0004      PAUSE   A614      PAUSE1  A616  
    PAUSE2  A61C      PE70HB  A4C6      PE70WD  A4CE      PE80WD  A4D6  
    PN00LB  A45E      PN40LB  A466      PN50LB  A46E      PR90HB  A4B6  
    PR90WD  A4BE      PRTCUR  A780      PRTLIN  A772      PW70HB  A496  
    PW70WD  A49E      PW80HB  A4A6      PW80WD  A4AE      QUIT    A67A  
    R0      0000      R1      0001      R10     000A      R11     000B  
    R12     000C      R13     000D      R14     000E      R15     000F  
    R2      0002      R3      0003      R4      0004      R5      0005  
    R6      0006      R7      0007      R8      0008      R9      0009  
    REDO    A636      RETURN  A674      SAVR11  A5F2      SCAN    000E  
    SCRBUF  A6E4      SCRLL0  A706      SCRLL1  A70A      SCRLL2  A740  
    SCROFF  A004      SCROLL  A704      SELPG   A0DA      SELPG0  A0E2  
    SELPG1  A0E6    D SFIRST  A000    D SLAST   A9BA      STACK   A06A  
    TA14WD  A486      TA15WD  A48E      TA60WD  A47E      TITLE   A006  
    TXTABT  A1C8      TXTADR  A337      TXTBAD  A19E      TXTBAS  A31F  
    TXTBCK  A397      TXTCRU  A01A      TXTDBT  A1B7      TXTDVT  A1D9  
    TXTER0  A21C      TXTER1  A22B      TXTER2  A23C      TXTER3  A254  
    TXTER4  A26D      TXTER5  A284      TXTER6  A29D      TXTER7  A2BB  
    TXTER8  A2D0      TXTER9  A2E6      TXTERR  A2FA      TXTERT  A208  
    TXTEXP  A37F      TXTFLD  A1FF      TXTOK   A1FB      TXTPBT  A1EA  
    TXTPGN  A307      TXTRDP  A367      TXTRED  A3B1      TXTWRP  A34F  
    USEXIT  A0CC      USEXT0  A0D8      USINI0  A0CA      USINIT  A0BE  
    UTLWS   A04A      VDPADR  A68E      VDPADW  A686      VDPLWA  A682  
    VDPRD   8800      VDPWA   8C02      VDPWAO  A684      VDPWD   8C00  

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0029
    VMBR    A6CE      VMBR1   A6D8      VMBR2   A6E0      VMBW    A6AA  
    VMBW1   A6B4      VMBW2   A6BC      VSBR    A6C0      VSBW    A69C  
    WHAT    A646      WHAT0   A648      WHAT1   A650      WHAT2   A658  
    WHAT3   A66C      WRDASC  A808  
  0000 ERRORS

 Xa99 Cross Assembler
MEMTEST HDX 25/05/2015                                       PAGE 0030
  SEGMENT AORG     SIZE 02490 (>09BA) BYTES
