
 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0001
  0002            	IDT  'EA_IDE'
  0003            
  0004 A000       	AORG	>A000
  0005            
  0006            	DEF	SFIRST,SLAST
  0007            
  0008 A000 0460  SFIRST	B	@MAIN
       A002 A074 
  0009            	
  0010 A004 0000  SCROFF	DATA	>0000	Screen offset
  0011            
  0012            	COPY ".\MEMT_IDE.A99"
  0013            * MEMT_IDE - Main Memory Test Program for Ide Card
  0014            *
  0016            	IDT 'MAIN'
  0017            
  0018            *---------------------------------------------------	
  0019 A006   49  TITLE	TEXT	'Ide Ram Memory test'
  0020 A019   00  	BYTE	0
  0021 A01A   45  TXTCRU	TEXT	'Enter IDE-card CRU address >1x'
  0022 A038   00  	BYTE	0
  0023            	EVEN
  0024            *---------------------------------------------------	
  0025            * Memorytable with testaddresses 
  0026            *
  0027            *               Base  Size  Width Mask  Pages
  0028 A03A 4000  MEMTAB	DATA	>4000,>2000,>0008,>1FFF,64
       A03C 2000 
       A03E 0008 
       A040 1FFF 
       A042 0040 
  0029 A044 0000  ENDTAB	DATA	>0000,>0000
       A046 0000 
  0030            
  0031      0000  OFBASE	EQU	0		Offset Base address
  0032      0002  OFSIZE	EQU	2		Offset Region Size
  0033      0004  OFWIDT	EQU	4		Offset Databus width
  0034      0006  OFMASK	EQU	6		Offset Address mask
  0035      0008  OFPAGE	EQU	8		Offset Number of pages
  0036      000A  MEMTEZ	EQU	10		Memtab entry size
  0037            
  0038 A048 0000  MYCRU	DATA	0		My Card's CRU address
  0039 A04A       MYWS	BSS	32		My workspace
  0040 A06A       STACK	BSS	10		My stack
  0041            *---------------------------------------------------	
  0042            
  0043            MAIN	
  0044 A074 02E0  BEGIN	LWPI	MYWS
       A076 A04A 
  0045 A078 020A  	LI	R10,STACK
       A07A A06A 
  0046            *	DATA	>0D00
  0047            
  0048            * Title	
  0049 A07C 0201  BEGIN1	LI	R1,TITLE
       A07E A006 
  0050 A080 06A0  	BL	@PRTLIN
       A082 A782 
  0051 A084 06A0  	BL	@SCROLL

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0002
       A086 A714 
  0052            
  0053            * Ask CRU address
  0054 A088 06A0  	BL	@ASKCRU
       A08A A79A 
  0055 A08C C80C  	MOV	R12,@MYCRU	Save CRU addres
       A08E A048 
  0056 A090 1602  	JNE	BEGIN2		Not >0000, Continue
  0057 A092 0460  	B	@QUIT		Goodbye!
       A094 A68A 
  0058 A096 06A0  BEGIN2	BL	@SCROLL
       A098 A714 
  0059            
  0060            * First initialization and select Page 0
  0061 A09A 06A0  	BL	@USINIT		Card on
       A09C A0BE 
  0062 A09E 06A0  	BL	@SELPG0		Page 0
       A0A0 A0DE 
  0063 A0A2 06A0  	BL	@USEXIT		Card off
       A0A4 A0D4 
  0064            
  0065 A0A6 020F  	LI	R15,MEMTAB
       A0A8 A03A 
  0066 A0AA 06A0  BEGIN3	BL	@MTEST
       A0AC A3D8 
  0067            	
  0068            *	DATA	>0D00
  0069 A0AE 022F  	AI	R15,MEMTEZ	Next entry
       A0B0 000A 
  0070 A0B2 C02F  	MOV	@2(R15),R0	Size nil?
       A0B4 0002 
  0071 A0B6 16F9  	JNE	BEGIN3		No!
  0072            
  0073            * Return to title screen
  0074            *	DATA	>0D00		Debugger
  0075 A0B8 06A0  	BL	@REDO
       A0BA A646 
  0076 A0BC 10DB  	JMP	BEGIN
  0077            
  0078            * User Init function
  0079            *
  0080            * Initialize your hardware, like card on, etc.
  0081            * This function is called before a test is executed.
  0082            *
  0083 A0BE C320  USINIT	MOV	@MYCRU,R12
       A0C0 A048 
  0084 A0C2 1307  	JEQ	USINI0
  0085 A0C4 1D00  	SBO	0		Card on
  0086 A0C6 1E01  	SBZ	1		Map SRAM, not IDE/CLOCK
  0087 A0C8 1E02  	SBZ	2		Latch SRAM page off
  0088 A0CA 1D03  	SBO	3		No fixed page at >4000
  0089 A0CC 1E05  	SBZ	5		Not write protected
  0090 A0CE 1E06  	SBZ	6		Not used
  0091 A0D0 1E07  	SBZ	7		Disable reset IDE, just read it
  0092            *	DATA	>0D00
  0093 A0D2 045B  USINI0	B	*R11
  0094            
  0095            * User Exit function.
  0096            *

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0003
  0097            * Save your hardware, like card off, etc.
  0098            * This function is called after a test has been executed.
  0099            *
  0100 A0D4 C320  USEXIT	MOV	@MYCRU,R12
       A0D6 A048 
  0101 A0D8 1301  	JEQ	USEXT0
  0102 A0DA 1E00  	SBZ	0		Card off
  0103            *	DATA	>0D00
  0104 A0DC 045B  USEXT0	B	*R11
  0105            
  0106            *---------------------------------------------------	
  0107            * Page Test Functions
  0108            *---------------------------------------------------	
  0109            
  0110            * SELPG0 - Select page 0
  0111            * SELPG  - Select a page x
  0112            *
  0113            * Input : R1 Page address 0-63
  0114            * Output: Page selected
  0115            * Uses  : R1, R11, R12
  0116            *
  0117 A0DE 04C1  SELPG0	CLR	R1
  0118 A0E0 C320  SELPG	MOV	@MYCRU,R12
       A0E2 A048 
  0119 A0E4 0A11  	SLA	R1,1		A15 is not latched
  0120 A0E6 1E03  	SBZ	3		Fixed page at >4000
  0121 A0E8 1D05  	SBO	5		Write protect SRAM
  0122 A0EA 1D02  	SBO	2		Latch on
  0123 A0EC C841  	MOV	R1,@>5000(R1)	Select page
       A0EE 5000 
  0124 A0F0 1E02  	SBZ	2		Latch off
  0125 A0F2 1E05  	SBZ	5		Write enable SRAM
  0126 A0F4 1D03  	SBO	3		No fixed page at >4000
  0127 A0F6 045B  	B	*R11
  0128            
  0129            * MTPB - Memorytest PageBus
  0130            *
  0131            * Test the page bus wiring by performing a walking 1's test
  0132            * on the relevant bits of the page addresses and checking
  0133            * for aliasing. This test will find single-bit address
  0134            * failures such as stuck-high, stuck-low, and shorted pins.
  0135            * The base address and size of the region are selected by
  0136            * the caller.
  0137            *
  0138            * Input : R0 of callers workspace contains address of
  0139            *            structure with Base address, Region size,
  0140            *            Databus width 8/16, Address mask and
  0141            *            Number of pages.
  0142            *
  0143            * Output: SR EQ=1 test succeeded
  0144            *         SR EQ=0 test failed
  0145            *         MT#ERR=7 Page line stuck low
  0146            *         MT#ERR=8 Page line stuck high
  0147            *         MT#ERR=9 Page lines shorted
  0148            *         and rest of MT#WSP filled as described.
  0149            *
  0150            * Uses  : All
  0151            
  0152 A0F8 A844  MTPB	DATA	MT#WSP,MTPB$	Pagebus test

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0004
       A0FA A0FC 
  0153            
  0154 A0FC 06A0  MTPB$	BL	@MTGTTV		Get memory test table values
       A0FE A870 
  0155            *	MOV	R1,R6		Base address (Ti994w anly has fixed >4000)
  0156 A100 0206  	LI	R6,>5000	Base address (this works also in Ti994w)
       A102 5000 
  0157            
  0158 A104 0207  	LI	R7,>A500	Pattern
       A106 A500 
  0159 A108 0208  	LI	R8,>5A00	Inverted pattern
       A10A 5A00 
  0160            	
  0161            * Clear all pages base address
  0162 A10C 04C4  	CLR	R4		Page 0
  0163 A10E C044  MTPB0	MOV	R4,R1	
  0164 A110 06A0  	BL	@SELPG
       A112 A0E0 
  0165 A114 04D6  	CLR	*R6		Base address = 0
  0166 A116 0584  	INC	R4		Next page
  0167 A118 8284  	C	R4,R10		More pages?
  0168 A11A 1AF9  	JL	MTPB0		Yes!
  0169            
  0170            * Write the default pattern at each page of the power-of-two
  0171 A11C 0204  	LI	R4,1		Page 1
       A11E 0001 
  0172 A120 C044  MTPB1	MOV	R4,R1
  0173 A122 06A0  	BL	@SELPG
       A124 A0E0 
  0174 A126 D587  	MOVB	R7,*R6		= Pattern
  0175 A128 0A14  	SLA	R4,1		Page <<= 1
  0176 A12A 8284  	C	R4,R10		More pages?
  0177 A12C 1AF9  	JL	MTPB1		Yes!
  0178            	
  0179            * Check for page line stuck high.
  0180 A12E 06A0  	BL	@SELPG0
       A130 A0DE 
  0181 A132 D588  	MOVB	R8,*R6		Base address = Inverted pattern
  0182            	
  0183 A134 04C9  	CLR	R9		Readback register
  0184 A136 0204  	LI	R4,1		Page 1
       A138 0001 
  0185 A13A C044  MTPB2	MOV	R4,R1
  0186 A13C 06A0  	BL	@SELPG
       A13E A0E0 
  0187 A140 D256  	MOVB	*R6,R9		Read back
  0188 A142 9247  	CB	R7,R9		Equals Pattern
  0189 A144 162C  	JNE	MTPBE8		No, stuck high!
  0190 A146 0A14  	SLA	R4,1		Page <<= 1
  0191 A148 8284  	C	R4,R10		More pages?
  0192 A14A 1AF7  	JL	MTPB2		Yes!
  0193            
  0194            * Check for page line stuck low or shorted.
  0195 A14C 06A0  	BL	@SELPG0		Page 0
       A14E A0DE 
  0196 A150 D587  	MOVB	R7,*R6		Base address = Pattern
  0197            
  0198 A152 0204  	LI	R4,1		Page 1
       A154 0001 

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0005
  0199 A156 C044  MTPB3	MOV	R4,R1
  0200 A158 06A0  	BL	@SELPG
       A15A A0E0 
  0201 A15C D588  	MOVB	R8,*R6		= Inverted Pattern
  0202            
  0203 A15E 06A0  	BL	@SELPG0		Page 0
       A160 A0DE 
  0204 A162 D256  	MOVB	*R6,R9		Readback Base address
  0205 A164 9247  	CB	R7,R9		Address stuck low?
  0206 A166 1618  	JNE	MTPBE7		Yes, Error!
  0207            
  0208 A168 0205  	LI	R5,1		Page 1
       A16A 0001 
  0209 A16C 8105  MTPB4	C	R5,R4		Page == Test Page?
  0210 A16E 1306  	JEQ	MTPB5		Yes, do not check!
  0211            
  0212 A170 C045  	MOV	R5,R1
  0213 A172 06A0  	BL	@SELPG
       A174 A0E0 
  0214 A176 D256  	MOVB	*R6,R9		Readback
  0215 A178 9247  	CB	R7,R9		Equals Pattern
  0216 A17A 1614  	JNE	MTPBE9		No, address lines shorted!
  0217 A17C 0A15  MTPB5	SLA	R5,1		Page <<= 1
  0218 A17E 8285  	C	R5,R10		More pages?
  0219 A180 1AF5  	JL	MTPB4		Yes!
  0220            
  0221 A182 C044  	MOV	R4,R1		Restore pattern
  0222 A184 06A0  	BL	@SELPG
       A186 A0E0 
  0223 A188 D587  	MOVB	R7,*R6		= Pattern
  0224            
  0225 A18A 0A14  	SLA	R4,1		Page <<= 1
  0226 A18C 8284  	C	R4,R10		More pages?
  0227 A18E 1AE3  	JL	MTPB3		Yes!
  0228            
  0229 A190 04C0  MTPBEQ	CLR	R0		Error 0: Success
  0230 A192 026F  	ORI	R15,>2000	Success, set EQ
       A194 2000 
  0231 A196 0380  	RTWP
  0232            	
  0233 A198 0200  MTPBE7	LI	R0,7		Error 7: Page line stuck low
       A19A 0007 
  0234 A19C 1005  	JMP	MTPBNE	
  0235 A19E 0200  MTPBE8	LI	R0,8		Error 8: Page line stuck high
       A1A0 0008 
  0236 A1A2 1002  	JMP	MTPBNE	
  0237 A1A4 0200  MTPBE9	LI	R0,9		Error 9: Page lines shorted
       A1A6 0009 
  0238 A1A8 024F  MTPBNE	ANDI	R15,>DFFF	Failure, reset EQ
       A1AA DFFF 
  0239 A1AC 0380  	RTWP
  0240            
  0241            * End of Main ...
  0242            	COPY ".\MEMT_MISC.A99"
  0243            * MEMTMISC - Main Memory Misc Functions
  0244            *
  0245            *	TITL 'MEMTEST MISC 06/05/2007'
  0246            *	IDT 'MISC'
  0247            

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0006
  0248            *---------------------------------------------------
  0249 A1AE   54  TXTBAD	TEXT	'Testing >xxxx size >xxxx'
  0250 A1C6   00  	BYTE	0
  0251 A1C7   20  TXTDBT	TEXT	' Databus test   '
  0252 A1D7   00  	BYTE	0
  0253 A1D8   20  TXTABT	TEXT	' Addressbus test'
  0254 A1E8   00  	BYTE	0
  0255 A1E9   20  TXTDVT	TEXT	' Device test    '
  0256 A1F9   00  	BYTE	0
  0257 A1FA   20  TXTPBT	TEXT	' Pagebus test   '
  0258 A20A   00  	BYTE	0
  0259 A20B   20  TXTOK	TEXT    ' Ok'
  0260 A20E   00  	BYTE	0
  0261 A20F   20  TXTFLD	TEXT	' Failed'
  0262 A216   00  	BYTE	0
  0263            *---------------------------------------------------
  0264            * Error texts
  0265            	EVEN
  0266 A218 A22C  TXTERT	DATA	TXTER0,TXTER1,TXTER2,TXTER3,TXTER4
       A21A A23B 
       A21C A24C 
       A21E A264 
       A220 A27D 
  0267 A222 A294  	DATA	TXTER5,TXTER6,TXTER7,TXTER8,TXTER9
       A224 A2AD 
       A226 A2CB 
       A228 A2E0 
       A22A A2F6 
  0268            
  0269 A22C   20  TXTER0	TEXT	' Unknown error'
  0270 A23A   00  	BYTE	0
  0271 A23B   20  TXTER1	TEXT	' Databus failure'
  0272 A24B   00  	BYTE	0
  0273 A24C   20  TXTER2	TEXT	' Address line stuck low'
  0274 A263   00  	BYTE	0
  0275 A264   20  TXTER3	TEXT	' Address line stuck high'
  0276 A27C   00  	BYTE	0
  0277 A27D   20  TXTER4	TEXT	' Address lines shorted'
  0278 A293   00  	BYTE	0
  0279 A294   20  TXTER5	TEXT	' Wrong pattern read back'
  0280 A2AC   00  	BYTE	0
  0281 A2AD   20  TXTER6	TEXT	' Wrong inv. pattern read back'
  0282 A2CA   00  	BYTE	0
  0283 A2CB   20  TXTER7	TEXT	' Page line stuck low'
  0284 A2DF   00  	BYTE	0
  0285 A2E0   20  TXTER8	TEXT	' Page line stuck high'
  0286 A2F5   00  	BYTE	0
  0287 A2F6   20  TXTER9	TEXT	' Page lines shorted'
  0288 A309   00  	BYTE	0
  0289            *---------------------------------------------------
  0290 A30A   20  TXTERR	TEXT	' Error >0000'
  0291 A316   00  	BYTE	0
  0292 A317   20  TXTPGN	TEXT	' Page number      >xxxx'
  0293 A32E   00  	BYTE	0
  0294 A32F   20  TXTBAS	TEXT	' Base address     >xxxx'
  0295 A346   00  	BYTE	0
  0296 A347   20  TXTADR	TEXT	' Test address     >xxxx'
  0297 A35E   00  	BYTE	0
  0298 A35F   20  TXTWRP	TEXT	' Pattern written  >xxxx'

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0007
  0299 A376   00  	BYTE	0
  0300 A377   20  TXTRDP	TEXT	' Pattern readback >xxxx'
  0301 A38E   00  	BYTE	0
  0302 A38F   20  TXTEXP	TEXT	' Pattern expected >xxxx'
  0303 A3A6   00  	BYTE	0
  0304            *---------------------------------------------------
  0305 A3A7   50  TXTBCK	TEXT	'Press <proceed> or <back>'
  0306 A3C0   00  	BYTE	0
  0307 A3C1   50  TXTRED	TEXT	'Press <redo> or <back>'
  0308 A3D7   00  	BYTE	0
  0309            	EVEN
  0310            *---------------------------------------------------
  0311            
  0312            
  0313            * MTEST - Memory test
  0314            *
  0315            * Do the databus, addressbus and device test
  0316            *
  0317            * Input : R15 addess of memory entry width
  0318            *             base address, regionsize and width
  0319            *
  0320            * Uses  : R0 - R11
  0321            * Output: 
  0322            *
  0323 A3D8 CE8B  MTEST	MOV	R11,*R10+	Save return address
  0324            *---------------------------------------------------
  0325            * User Init Function
  0326            *---------------------------------------------------
  0327 A3DA 06A0  	BL	@USINIT
       A3DC A0BE 
  0328            
  0329            *---------------------------------------------------
  0330            * Initialize registers
  0331            *---------------------------------------------------
  0332 A3DE C01F  	MOV	*R15,R0		Base Address
  0333 A3E0 0201  	LI	R1,TXTBAD+9
       A3E2 A1B7 
  0334 A3E4 06A0  	BL	@WRDASC
       A3E6 A818 
  0335 A3E8 0200  	LI	R0,>2000	Remove '0' in string
       A3EA 2000 
  0336 A3EC D440  	MOVB	R0,*R1
  0337            
  0338 A3EE C02F  	MOV	@2(R15),R0	Region Size
       A3F0 0002 
  0339 A3F2 0201  	LI	R1,TXTBAD+20
       A3F4 A1C2 
  0340 A3F6 06A0  	BL	@WRDASC
       A3F8 A818 
  0341            
  0342 A3FA 0201  	LI	R1,TXTBAD	Print: Testing >xxxx Size >xxxx
       A3FC A1AE 
  0343 A3FE 06A0  	BL	@PRTLIN
       A400 A782 
  0344            
  0345            *---------------------------------------------------
  0346            * Databus test
  0347            *---------------------------------------------------
  0348 A402 0200  MTEST1	LI	R0,23*32

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0008
       A404 02E0 
  0349 A406 0201  	LI	R1,TXTDBT	Print: Adresbus test
       A408 A1C7 
  0350 A40A 06A0  	BL	@DSPLIN
       A40C A760 
  0351            *	DATA	>0D00
  0352 A40E C00F  	MOV	R15,R0		Test entry
  0353 A410 0420  	BLWP	@MTDB		Test databus
       A412 A864 
  0354 A414 06A0  	BL	@MTFAIL		Failure?
       A416 A586 
  0355            	
  0356            *---------------------------------------------------
  0357            * Addressbus test
  0358            *---------------------------------------------------
  0359 A418 0200  MTEST2	LI	R0,23*32
       A41A 02E0 
  0360 A41C 0201  	LI	R1,TXTABT	Print: Databus test
       A41E A1D8 
  0361 A420 06A0  	BL	@DSPLIN
       A422 A760 
  0362            *	DATA	>0D00		Debugger
  0363 A424 C00F  	MOV	R15,R0		Test entry
  0364 A426 0420  	BLWP	@MTAB		Test addressbus
       A428 A868 
  0365 A42A 06A0  	BL	@MTFAIL		Failure?
       A42C A586 
  0366            	
  0367            *---------------------------------------------------
  0368            * Device test
  0369            *---------------------------------------------------
  0370 A42E 0200  MTEST3	LI	R0,23*32
       A430 02E0 
  0371 A432 0201  	LI	R1,TXTDVT	Print: Device test
       A434 A1E9 
  0372 A436 06A0  	BL	@DSPLIN
       A438 A760 
  0373 A43A C00F  	MOV	R15,R0		Test entry
  0374 A43C 0420  	BLWP	@MTDV		Test device
       A43E A86C 
  0375 A440 06A0  	BL	@MTFAIL		Failure?
       A442 A586 
  0376            
  0377 TRUE       #ifdef MTPB
  0378            *---------------------------------------------------
  0379            * Pagebus test
  0380            *---------------------------------------------------
  0381 A444 C04F  MTEST4	MOV	R15,R1		Any pages to test?
  0382 A446 C021  	MOV	@OFPAGE(R1),R0
       A448 0008 
  0383 A44A 130B  	JEQ	MTST4X		No!	
  0384            
  0385 A44C 0200  	LI	R0,23*32
       A44E 02E0 
  0386 A450 0201  	LI	R1,TXTPBT	Print: Pagebus test
       A452 A1FA 
  0387 A454 06A0  	BL	@DSPLIN
       A456 A760 
  0388 A458 C00F  	MOV	R15,R0		Base address

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0009
  0389 A45A 0420  	BLWP	@MTPB		Test pagebus
       A45C A0F8 
  0390 A45E 06A0  	BL	@MTFAIL
       A460 A586 
  0391            MTST4X
  0392 TRUE       #endif
  0393            
  0394            *---------------------------------------------------
  0395            * User Exit Function
  0396            *---------------------------------------------------
  0397 A462 06A0  	BL	@USEXIT
       A464 A0D4 
  0398 A466 06A0  	BL	@SCROLL		Test finished
       A468 A714 
  0399 A46A 0460  	B	@RETURN
       A46C A684 
  0400            
  0401            *---------------------------------------------------
  0402            * Error message definitions
  0403            *---------------------------------------------------
  0404            	
  0405            *		Text,Reg,Reg,Conv
  0406            
  0407            * Page number      >xxxx
  0408 A46E A317  PN00LB	DATA	TXTPGN,0,0,LOBASC
       A470 0000 
       A472 0000 
       A474 A7FC 
  0409 A476 A317  PN40LB	DATA	TXTPGN,MT#OF1,0,LOBASC
       A478 A84C 
       A47A 0000 
       A47C A7FC 
  0410 A47E A317  PN50LB	DATA	TXTPGN,MT#OF2,0,LOBASC
       A480 A84E 
       A482 0000 
       A484 A7FC 
  0411            
  0412            * Base address     >xxxx
  0413 A486 A32F  BA10WD	DATA	TXTBAS,MT#BAS,0,WRDASC
       A488 A846 
       A48A 0000 
       A48C A818 
  0414            
  0415            * Test address     >xxxx
  0416 A48E A347  TA60WD	DATA	TXTADR,MT#ADR,0,WRDASC
       A490 A850 
       A492 0000 
       A494 A818 
  0417 A496 A347  TA14WD	DATA	TXTADR,MT#BAS,MT#OF1,WRDASC
       A498 A846 
       A49A A84C 
       A49C A818 
  0418 A49E A347  TA15WD	DATA	TXTADR,MT#BAS,MT#OF2,WRDASC
       A4A0 A846 
       A4A2 A84E 
       A4A4 A818 
  0419            
  0420            * Pattern written  >xxxx
  0421 A4A6 A35F  PW70HB	DATA	TXTWRP,MT#WDP,0,HOBASC

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0010
       A4A8 A852 
       A4AA 0000 
       A4AC A7FA 
  0422 A4AE A35F  PW70WD	DATA	TXTWRP,MT#WDP,0,WRDASC
       A4B0 A852 
       A4B2 0000 
       A4B4 A818 
  0423 A4B6 A35F  PW80HB	DATA	TXTWRP,MT#WIP,0,HOBASC
       A4B8 A854 
       A4BA 0000 
       A4BC A7FA 
  0424 A4BE A35F  PW80WD	DATA	TXTWRP,MT#WIP,0,WRDASC
       A4C0 A854 
       A4C2 0000 
       A4C4 A818 
  0425            
  0426            * Pattern readback >xxxx
  0427 A4C6 A377  PR90HB	DATA	TXTRDP,MT#RBP,0,HOBASC
       A4C8 A856 
       A4CA 0000 
       A4CC A7FA 
  0428 A4CE A377  PR90WD	DATA	TXTRDP,MT#RBP,0,WRDASC
       A4D0 A856 
       A4D2 0000 
       A4D4 A818 
  0429            
  0430            * Pattern expected >xxxx
  0431 A4D6 A38F  PE70HB	DATA	TXTEXP,MT#WDP,0,HOBASC
       A4D8 A852 
       A4DA 0000 
       A4DC A7FA 
  0432 A4DE A38F  PE70WD	DATA	TXTEXP,MT#WDP,0,WRDASC
       A4E0 A852 
       A4E2 0000 
       A4E4 A818 
  0433 A4E6 A38F  PE80WD	DATA	TXTEXP,MT#WIP,0,WRDASC
       A4E8 A854 
       A4EA 0000 
       A4EC A818 
  0434            
  0435            
  0436            ERRT0
  0437 A4EE A496  ERRT1	DATA	TA14WD,PW70HB,PR90HB,PE70HB
       A4F0 A4A6 
       A4F2 A4C6 
       A4F4 A4D6 
  0438 A4F6 0000  	DATA	0
  0439            
  0440 A4F8 A486  ERRT2	DATA	BA10WD,PW70HB,TA14WD,PW80HB
       A4FA A4A6 
       A4FC A496 
       A4FE A4B6 
  0441 A500 A486  	DATA	BA10WD,PR90HB,PE70HB
       A502 A4C6 
       A504 A4D6 
  0442 A506 0000  	DATA	0
  0443            
  0444 A508 A496  ERRT3	DATA	TA14WD,PW70HB,BA10WD,PW80HB
       A50A A4A6 

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0011
       A50C A486 
       A50E A4B6 
  0445 A510 A496  	DATA	TA14WD,PR90HB,PE70HB
       A512 A4C6 
       A514 A4D6 
  0446 A516 0000  	DATA	0
  0447            
  0448 A518 A49E  ERRT4	DATA	TA15WD,PW70HB,TA14WD,PW80HB
       A51A A4A6 
       A51C A496 
       A51E A4B6 
  0449 A520 A49E  	DATA	TA15WD,PR90HB,PE70HB
       A522 A4C6 
       A524 A4D6 
  0450 A526 0000  	DATA	0
  0451            
  0452 A528 A48E  ERRT5	DATA	TA60WD,PW70WD,PR90WD,PE70WD
       A52A A4AE 
       A52C A4CE 
       A52E A4DE 
  0453 A530 0000  	DATA	0
  0454            
  0455 A532 A48E  ERRT6	DATA	TA60WD,PW80WD,PR90WD,PE80WD
       A534 A4BE 
       A536 A4CE 
       A538 A4E6 
  0456 A53A 0000  	DATA	0
  0457            
  0458 A53C A48E  ERRT7	DATA	TA60WD,PN00LB,PW70HB,PN40LB
       A53E A46E 
       A540 A4A6 
       A542 A476 
  0459 A544 A4B6  	DATA	PW80HB,PN00LB,PR90HB,PE70HB
       A546 A46E 
       A548 A4C6 
       A54A A4D6 
  0460 A54C 0000  	DATA	0
  0461            
  0462 A54E A48E  ERRT8	DATA	TA60WD,PN40LB,PW70HB,PN00LB
       A550 A476 
       A552 A4A6 
       A554 A46E 
  0463 A556 A4B6  	DATA	PW80HB,PN40LB,PR90HB,PE70HB
       A558 A476 
       A55A A4C6 
       A55C A4D6 
  0464 A55E 0000  	DATA	0
  0465            
  0466 A560 A48E  ERRT9	DATA	TA60WD,PN50LB,PW70HB,PN40LB
       A562 A47E 
       A564 A4A6 
       A566 A476 
  0467 A568 A4B6  	DATA	PW80HB,PN50LB,PR90HB,PE70HB
       A56A A47E 
       A56C A4C6 
       A56E A4D6 
  0468 A570 0000  	DATA	0
  0469            
  0470 A572 A4EE  ERMTAB	DATA	ERRT0,ERRT1,ERRT2,ERRT3,ERRT4

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0012
       A574 A4EE 
       A576 A4F8 
       A578 A508 
       A57A A518 
  0471 A57C A528  	DATA	ERRT5,ERRT6,ERRT7,ERRT8,ERRT9
       A57E A532 
       A580 A53C 
       A582 A54E 
       A584 A560 
  0472            
  0473            *---------------------------------------------------
  0474            * MTFAIL - Print informative messages about the
  0475            *          failure.
  0476            *
  0477            * Input : MT#xxx Filled
  0478            * Output: -
  0479            * Uses  : R0 - R11
  0480            
  0481 A586 1604  MTFAIL	JNE	MTFL$0		Failure
  0482 A588 0201  	LI	R1,TXTOK	Print: Ok
       A58A A20B 
  0483 A58C 0460  	B	@PRTCUR
       A58E A790 
  0484            
  0485 A590 CE8B  MTFL$0	MOV	R11,*R10+	Save return address
  0486 A592 06A0  	BL	@USEXIT		User Exit Function
       A594 A0D4 
  0487 A596 0201  	LI	R1,TXTFLD	Print: Failed
       A598 A20F 
  0488 A59A 06A0  	BL	@PRTCUR
       A59C A790 
  0489            
  0490 A59E C020  	MOV	@MT#ERR,R0	Error code
       A5A0 A844 
  0491 A5A2 0201  	LI	R1,TXTERR+8	Convert
       A5A4 A312 
  0492 A5A6 06A0  	BL	@WRDASC
       A5A8 A818 
  0493 A5AA 0201  	LI	R1,TXTERR
       A5AC A30A 
  0494 A5AE 06A0  	BL	@PRTLIN
       A5B0 A782 
  0495            	
  0496 A5B2 C160  	MOV	@MT#ERR,R5	Error code
       A5B4 A844 
  0497 A5B6 0285  	CI	R5,9		Max error code
       A5B8 0009 
  0498 A5BA 1203  	JLE	MTFL$1		Ok
  0499 A5BC 04C5  	CLR	R5		Unknown error
  0500 A5BE 04E0  	CLR	@MT#ERR
       A5C0 A844 
  0501 A5C2 0A15  MTFL$1	SLA	R5,1
  0502 A5C4 C065  	MOV	@TXTERT(R5),R1	Error text
       A5C6 A218 
  0503 A5C8 06A0  	BL	@PRTLIN
       A5CA A782 
  0504            	
  0505 A5CC C165  	MOV	@ERMTAB(R5),R5
       A5CE A572 

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0013
  0506 A5D0 C1B5  MTFL$2	MOV	*R5+,R6		Text table address
  0507 A5D2 1311  	JEQ	MTFL$E		End Of Table
  0508            	
  0509 A5D4 C1F6  	MOV	*R6+,R7		Text address
  0510 A5D6 04C0  	CLR	R0
  0511 A5D8 C236  	MOV	*R6+,R8		Register 1
  0512 A5DA 1301  	JEQ	MTFL$3
  0513 A5DC A018  	A	*R8,R0		Add value
  0514 A5DE C236  MTFL$3	MOV	*R6+,R8		Register 2
  0515 A5E0 1301  	JEQ	MTFL$4
  0516 A5E2 A018  	A	*R8,R0		Add value
  0517 A5E4 C236  MTFL$4	MOV	*R6+,R8		Conversion function
  0518            	
  0519 A5E6 C047  	MOV	R7,R1		Address for Value
  0520 A5E8 0221  	AI	R1,19
       A5EA 0013 
  0521 A5EC 0698  	BL	*R8		Convert
  0522            	
  0523 A5EE C047  	MOV	R7,R1		Print text
  0524 A5F0 06A0  	BL	@PRTLIN
       A5F2 A782 
  0525 A5F4 10ED  	JMP	MTFL$2
  0526            
  0527 A5F6 06A0  MTFL$E	BL	@BACK		Proceed or back?
       A5F8 A636 
  0528 A5FA 06A0  	BL	@USINIT		User init function
       A5FC A0BE 
  0529 A5FE 0460  	B	@RETURN
       A600 A684 
  0530            		
  0531            *---------------------------------------------------
  0532            * Utility routines
  0533      83E0  GPLWS	EQU	>83E0
  0534      000E  SCAN	EQU	>000E
  0535            *VDPRD	EQU	>8800
  0536            *VDPSTA	EQU	>8802
  0537            *VDPWD	EQU	>8C00
  0538            *VDPWA	EQU	>8C02
  0539            
  0540      0000  HOB	EQU	0	High order byte offset
  0541      0001  LOB	EQU	1	Low order byte offset
  0542            
  0543      0000  OFR0	EQU	0	Register offsets from workspace
  0544      0002  OFR1	EQU	2
  0545      0004  OFR2	EQU	4
  0546      0006  OFR3	EQU	6
  0547      0008  OFR4	EQU	8
  0548      000A  OFR5	EQU	10
  0549      000C  OFR6	EQU	12
  0550      000E  OFR7	EQU	14
  0551      0010  OFR8	EQU	16
  0552      0012  OFR9	EQU	18
  0553      0014  OFR10	EQU	20
  0554      0016  OFR11	EQU	22
  0555      0018  OFR12	EQU	24
  0556      001A  OFR13	EQU	26
  0557      001C  OFR14	EQU	28
  0558      001E  OFR15	EQU	30
  0559            

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0014
  0560      A04A  UTLWS	EQU	MYWS
  0561 A602 0000  SAVR11	DATA	>0000
  0562            
  0563            * KSCAN - Scan the keyboard
  0564            *
  0565            * Input : -
  0566            * Output: SR EQ=1 No key pressed
  0567            *         SR EQ=0 Key pressed
  0568            *         R0 Keycode in LSB
  0569            * Uses  : R0
  0570            *
  0571      A604  KSCAN	EQU	$	DATA UTLWS,KSCAN$
  0572 A604 02E0  KSCAN$	LWPI	GPLWS
       A606 83E0 
  0573 A608 C80B  	MOV	R11,@SAVR11
       A60A A602 
  0574 A60C 06A0  	BL	@SCAN
       A60E 000E 
  0575 A610 C2E0  	MOV	@SAVR11,R11
       A612 A602 
  0576 A614 02E0  	LWPI	UTLWS
       A616 A04A 
  0577            *	MOV	@SAVR11,@GPLWS+OFR11
  0578 A618 D020  	MOVB	@>8375,R0	Get key code
       A61A 8375 
  0579 A61C 0980  	SRL	R0,8
  0580 A61E 0280  	CI	R0,>00FF	Key pressed
       A620 00FF 
  0581 A622 045B  	B	*R11
  0582            
  0583            * PAUSE - Wait for a key press
  0584            *
  0585            * Input : -
  0586            * Output: -
  0587            * Uses  : R0
  0588            
  0589 A624 CE8B  PAUSE	MOV	R11,*R10+
  0590 A626 06A0  PAUSE1	BL	@KSCAN		Wait for key pressed
       A628 A604 
  0591 A62A 13FD  	JEQ	PAUSE1
  0592 A62C 06A0  PAUSE2	BL	@KSCAN		Wait for key release
       A62E A604 
  0593 A630 16FD  	JNE	PAUSE2
  0594 A632 0460  	B	@RETURN
       A634 A684 
  0595            
  0596            * BACK - Wait for a key <proceed> or <back>
  0597            *        Goes to title screen if <back>
  0598            *
  0599            * Input : -
  0600            * Output: -
  0601            * Uses  : R0, R1, R2, R3, R13, R14
  0602            *
  0603 A636 CE8B  BACK	MOV	R11,*R10+
  0604 A638 06A0  	BL	@SCROLL
       A63A A714 
  0605 A63C 0201  	LI	R1,TXTBCK	Proceed or back
       A63E A3A7 
  0606 A640 020E  	LI	R14,12		Proceed key code

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0015
       A642 000C 
  0607 A644 1009  	JMP	WHAT0
  0608            
  0609            * REDO - Wait for a key <redo> or <back>
  0610            *        Goes to title screen if <back>
  0611            *
  0612            * Input : -
  0613            * Output: -
  0614            * Uses  : R0, R1, R2, R3, R13, R14
  0615            *
  0616 A646 CE8B  REDO	MOV	R11,*R10+
  0617 A648 06A0  	BL	@SCROLL
       A64A A714 
  0618 A64C 0201  	LI	R1,TXTRED	Proceed or back
       A64E A3C1 
  0619 A650 020E  	LI	R14,6		Redo key code
       A652 0006 
  0620 A654 1001  	JMP	WHAT0
  0621            
  0622            * WHAT - Wait for a key press 
  0623            *        Goes to title screen if <back>
  0624            *
  0625            * Input : R1 address of text to print
  0626            *         R14 <proceed> or <redo>
  0627            * Output: -
  0628            * Uses  : R0, R1, R2, R3
  0629            *
  0630 A656 CE8B  WHAT	MOV	R11,*R10+
  0631 A658 0200  WHAT0	LI	R0,23*32+1
       A65A 02E1 
  0632 A65C 06A0  	BL	@DSPLIN		Print text
       A65E A760 
  0633 A660 06A0  WHAT1	BL	@KSCAN		Wait for key pressed
       A662 A604 
  0634 A664 13FD  	JEQ	WHAT1
  0635 A666 C040  	MOV	R0,R1
  0636 A668 06A0  WHAT2	BL	@KSCAN		Wait for key release
       A66A A604 
  0637 A66C 16FD  	JNE	WHAT2
  0638 A66E 8381  	C	R1,R14		Proceed/Redo?
  0639 A670 1305  	JEQ	WHAT3		Yes!
  0640 A672 0281  	CI	R1,15		Back?
       A674 000F 
  0641 A676 16F4  	JNE	WHAT1		No!
  0642 A678 0460  	B	@QUIT		Goodbye!
       A67A A68A 
  0643 A67C 06A0  WHAT3	BL	@SCROLL
       A67E A714 
  0644 A680 0460  	B	@RETURN
       A682 A684 
  0645            
  0646            * General stack routines
  0647            *
  0648            * Return from subroutine (called with BL @xxxx)
  0649            * With undefined status
  0650            *
  0651 A684 064A  RETURN	DECT R10		Fetch return adres
  0652 A686 C2DA  	MOV  *R10,R11
  0653 A688 045B  	B    *R11		Return to calling program

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0016
  0654            
  0655            * Quit function
  0656            *
  0657            * First call user exit function before
  0658            * returning to title screen
  0659            *
  0660 A68A 06A0  QUIT   BL   @USEXIT
       A68C A0D4 
  0661 A68E 0420         BLWP @>0000
       A690 0000 
  0662            
  0663            
  0664            * General VDP routines
  0665            
  0666      8C02  VDPWA  EQU  >8C02	      VDP write address
  0667      8C00  VDPWD  EQU  >8C00	      VDP write data address
  0668      8800  VDPRD  EQU  >8800	      VDP read  data address
  0669            
  0670            * VDPADW - VDP Address Write
  0671            * VDPADR - VDP Address Read
  0672            *
  0673            * Set the VDP write address
  0674            *
  0675            * Input:
  0676            *      R0   VDP address
  0677            * Output:
  0678            * Uses:
  0679            *      R0
  0680            
  0681 A692 0000  VDPLWA DATA >0000        VDP last write address
  0682 A694 4000  VDPWAO DATA >4000        VDP write address bits
  0683            
  0684 A696 C800  VDPADW	MOV  R0,@VDPLWA  Save VDP write address
       A698 A692 
  0685 A69A E020  	SOC  @VDPWAO,R0	 Set write address bits
       A69C A694 
  0686 A69E 06C0  VDPADR	SWPB R0		 Write lsb R0 first
  0687 A6A0 D800  	MOVB R0,@VDPWA
       A6A2 8C02 
  0688 A6A4 06C0  	SWPB R0		 Write msb R0
  0689 A6A6 D800  	MOVB R0,@VDPWA
       A6A8 8C02 
  0690 A6AA 045B  	B    *R11
  0691            
  0692            * VSBW - VDP Single Byte Write
  0693            *
  0694            * Input:
  0695            *      R0   VDP address
  0696            *      R1   msb Data
  0697            * Output:
  0698            * Uses:
  0699            *      R0
  0700            
  0701 A6AC CE8B  VSBW	MOV  R11,*R10+
  0702 A6AE 06A0  	BL   @VDPADW
       A6B0 A696 
  0703 A6B2 D801  	MOVB R1,@VDPWD
       A6B4 8C00 
  0704 A6B6 0460  	B    @RETURN

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0017
       A6B8 A684 
  0705            
  0706            * VMBW - VDP Multiple Byte Write
  0707            *
  0708            * Input:
  0709            *      R0   VDP address
  0710            *      R1   Data address
  0711            *      R2   Bytecount
  0712            * Output:
  0713            * Uses:
  0714            *      R0,R1,R2
  0715            
  0716 A6BA CE8B  VMBW	MOV  R11,*R10+
  0717 A6BC 06A0  	BL   @VDPADW
       A6BE A696 
  0718 A6C0 C082  	MOV  R2,R2	Something to copy?
  0719 A6C2 1304  	JEQ  VMBW2	No!
  0720 A6C4 D831  VMBW1	MOVB *R1+,@VDPWD
       A6C6 8C00 
  0721 A6C8 0602  	DEC  R2
  0722 A6CA 16FC  	JNE  VMBW1
  0723 A6CC 0460  VMBW2	B    @RETURN
       A6CE A684 
  0724            
  0725            * VSBR - VDP Single Byte Read
  0726            *
  0727            * Input:
  0728            *      R0   VDP address
  0729            * Output:
  0730            *      R1   msb Data
  0731            * Uses:
  0732            *      R0,R1
  0733            
  0734 A6D0 CE8B  VSBR	MOV  R11,*R10+
  0735 A6D2 06A0  	BL   @VDPADR
       A6D4 A69E 
  0736 A6D6 D060  	MOVB @VDPRD,R1
       A6D8 8800 
  0737 A6DA 0460  	B    @RETURN
       A6DC A684 
  0738            
  0739            * VMBR - VDP Multiple Byte Read
  0740            *
  0741            * Input:
  0742            *      R0   VDP address
  0743            *      R1   Data address
  0744            *      R2   Bytecount
  0745            * Output:
  0746            * Uses:
  0747            *      R0,R1,R2
  0748            
  0749 A6DE CE8B  VMBR	MOV  R11,*R10+
  0750 A6E0 06A0  	BL   @VDPADR
       A6E2 A69E 
  0751 A6E4 C082  	MOV  R2,R2	Something to copy?
  0752 A6E6 1304  	JEQ  VMBR2	No!
  0753 A6E8 DC60  VMBR1	MOVB @VDPRD,*R1+
       A6EA 8800 
  0754 A6EC 0602  	DEC  R2

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0018
  0755 A6EE 16FC  	JNE  VMBR1
  0756 A6F0 0460  VMBR2	B    @RETURN
       A6F2 A684 
  0757            
  0758            * SCROLL - Scrolls the screen (24*32) one line up
  0759            *
  0760            * Input:
  0761            * Output:
  0762            * Uses: 
  0763            *      R0,R1,R2,R3
  0764            *
  0765 A6F4       SCRBUF	BSS	32
  0766 A714 CE8B  SCROLL	MOV	R11,*R10+
  0767 A716 0203  SCRLL0	LI	R3,0		To line number
       A718 0000 
  0768            
  0769 A71A C003  SCRLL1	MOV	R3,R0		Copy from
  0770 A71C 0220  	AI	R0,32
       A71E 0020 
  0771 A720 0201  	LI	R1,SCRBUF
       A722 A6F4 
  0772 A724 0202  	LI	R2,32
       A726 0020 
  0773 A728 06A0  	BL	@VMBR
       A72A A6DE 
  0774            
  0775 A72C C003  	MOV	R3,R0		Copy to
  0776 A72E 0201  	LI	R1,SCRBUF
       A730 A6F4 
  0777 A732 0202  	LI	R2,32
       A734 0020 
  0778 A736 06A0  	BL	@VMBW
       A738 A6BA 
  0779 A73A 0223  	AI	R3,32
       A73C 0020 
  0780 A73E 0283  	CI	R3,23*32	All lines done?
       A740 02E0 
  0781 A742 1AEB  	JL	SCRLL1		No!
  0782            
  0783 A744 0201  	LI	R1,>2000	+>6000	Space
       A746 2000 
  0784 A748 A060  	A	@SCROFF,R1
       A74A A004 
  0785 A74C 0202  	LI	R2,32
       A74E 0020 
  0786 A750 D801  SCRLL2	MOVB	R1,@VDPWD
       A752 8C00 
  0787 A754 0602  	DEC	R2
  0788 A756 16FC  	JNE	SCRLL2
  0789 A758 0460  	B	@RETURN
       A75A A684 
  0790            
  0791            * DSPLIN - Displays a line with text at the given location
  0792            *		until character 0 encountered
  0793            * DSPCUR - Displays a line with text at the current location
  0794            *		until character 0 encountered
  0795            *
  0796            * Input : R0 Screen location
  0797            *         R1 Address of line with text

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0019
  0798            * Output: R2 Number of characters printed
  0799            * Uses  : R0,R1,R2,R3
  0800            *
  0801 A75C CE8B  DSPCUR	MOV	R11,*R10+	Save return address
  0802 A75E 1003  	JMP	DSPLN0
  0803 A760 CE8B  DSPLIN	MOV	R11,*R10+	Save return address
  0804 A762 06A0  	BL	@VDPADW		Set screen location
       A764 A696 
  0805 A766 04C2  DSPLN0	CLR	R2
  0806 A768 C0E0  	MOV	@SCROFF,R3
       A76A A004 
  0807 A76C D031  DSPLN1	MOVB	*R1+,R0		Get character
  0808 A76E 1307  	JEQ	DSPLN2		End of string
  0809 A770 A003  	A	R3,R0		Add screen offset
  0810 A772 D800  	MOVB	R0,@VDPWD
       A774 8C00 
  0811 A776 05A0  	INC	@VDPLWA
       A778 A692 
  0812 A77A 0582  	INC	R2
  0813 A77C 10F7  	JMP	DSPLN1
  0814 A77E 0460  DSPLN2	B	@RETURN
       A780 A684 
  0815            
  0816            * PRTLIN - Prints a line with text on the last line of the s
  0817            *		until character 0 encountered and scroll the screen
  0818            *		one line.
  0819            *
  0820            * Input : R1 Address of line with text
  0821            * Output: -
  0822            * Uses  : R0,R1,R2
  0823            *
  0824 A782 CE8B  PRTLIN	MOV	R11,*R10+
  0825 A784 0200  	LI	R0,23*32	Set screen address at line 23
       A786 02E0 
  0826 A788 06A0  	BL	@DSPLIN
       A78A A760 
  0827 A78C 0460  	B	@SCRLL0		Scroll a line and return
       A78E A716 
  0828            
  0829            * PRTCUR - Appends a line with text on the last line of the 
  0830            *		until character 0 encountered and scroll the screen
  0831            *		one line.
  0832            *
  0833            * Input : R1 Address of line with text
  0834            * Output: -
  0835            * Uses  : R0,R1,R2
  0836            *
  0837 A790 CE8B  PRTCUR	MOV	R11,*R10+
  0838 A792 06A0  	BL	@DSPCUR
       A794 A75C 
  0839 A796 0460  	B	@SCRLL0		Scroll a line and return
       A798 A716 
  0840            
  0841            
  0842 TRUE       #ifdef TXTCRU
  0843            * ASKCRU - Ask for CRU address
  0844            *
  0845            * Input : -
  0846            * Output: R12 CRU address, or >0000 to quit

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0020
  0847            * Uses  : R0, R1, R2, R3, R11, R12, R13, R14, R15
  0848            *
  0849 A79A CE8B  ASKCRU	MOV	R11,*R10+
  0850 A79C 06A0  	BL	@SCROLL
       A79E A714 
  0851 A7A0 0201  	LI	R1,TXTCRU
       A7A2 A01A 
  0852 A7A4 06A0  	BL	@DSPLIN
       A7A6 A760 
  0853 A7A8 0620  	DEC	@VDPLWA		Backspace one character
       A7AA A692 
  0854 A7AC 04CC  	CLR	R12
  0855            	
  0856 A7AE 06A0  ASKCR0	BL	@KSCAN		Wait for key pressed
       A7B0 A604 
  0857 A7B2 13FD  	JEQ	ASKCR0
  0858 A7B4 C040  	MOV	R0,R1
  0859            
  0860 A7B6 0281  	CI	R1,15		Back?
       A7B8 000F 
  0861 A7BA 131D  	JEQ	ASKCR4		Yes!
  0862            
  0863 A7BC C020  	MOV	@VDPLWA,R0	Display key
       A7BE A692 
  0864 A7C0 C301  	MOV	R1,R12
  0865 A7C2 06C1  	SWPB	R1
  0866 A7C4 06A0  	BL	@VSBW
       A7C6 A6AC 
  0867            
  0868 A7C8 06A0  ASKCR1	BL	@KSCAN		Wait for key release
       A7CA A604 
  0869 A7CC 16FD  	JNE	ASKCR1
  0870            	
  0871 A7CE 028C  	CI	R12,>0030	0 - 9
       A7D0 0030 
  0872 A7D2 11ED  	JLT	ASKCR0
  0873 A7D4 028C  	CI	R12,>0039
       A7D6 0039 
  0874 A7D8 1B03  	JH	ASKCR2
  0875 A7DA 022C  	AI	R12,->0030	Make nibble >0 - >9
       A7DC FFD0 
  0876 A7DE 1008  	JMP	ASKCR3	
  0877            	
  0878 A7E0 028C  ASKCR2	CI	R12,>0041	A - F
       A7E2 0041 
  0879 A7E4 11E4  	JLT	ASKCR0
  0880 A7E6 028C  	CI	R12,>0046
       A7E8 0046 
  0881 A7EA 1BE1  	JH	ASKCR0
  0882 A7EC 022C  	AI	R12,->0041+>A	Make nibble >A - >F
       A7EE FFC9 
  0883            	
  0884 A7F0 0A8C  ASKCR3	SLA	R12,8		Make CRU address
  0885 A7F2 022C  	AI	R12,>1000
       A7F4 1000 
  0886 A7F6 0460  ASKCR4	B	@RETURN
       A7F8 A684 
  0887 TRUE       #endif
  0888            

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0021
  0889            * WRDASC - Convert WORD in R0 to ASCII string
  0890            * LOBASC - Convert LO-BYTE in R0 to ASCII
  0891            * HOBASC - Convert HO-BYTE in R0 to ASCII
  0892            *
  0893            * Input:
  0894            *	R0 Number
  0895            *	R1 address of buffer
  0896            * Output:
  0897            * Uses: R0, R1, R2
  0898            *
  0899 A7FA 06C0  HOBASC	SWPB	R0
  0900 A7FC CE8B  LOBASC	MOV	R11,*R10+
  0901 A7FE C080  	MOV	R0,R2		Save byte
  0902 A800 0240  	ANDI	R0,>00F0	First HO-Nibble
       A802 00F0 
  0903 A804 0940  	SRL	R0,4
  0904 A806 06A0  	BL	@CASCII
       A808 A82A 
  0905 A80A C002  	MOV	R2,R0		Second LO-Nibble
  0906 A80C 0240  	ANDI	R0,>000F
       A80E 000F 
  0907 A810 06A0  	BL	@CASCII
       A812 A82A 
  0908 A814 0460  	B	@RETURN
       A816 A684 
  0909            	
  0910 A818 CE8B  WRDASC	MOV	R11,*R10+
  0911 A81A 06A0  	BL	@HOBASC		First HO-Byte
       A81C A7FA 
  0912 A81E C002  	MOV	R2,R0
  0913 A820 06A0  	BL	@HOBASC		Next LO-Byte
       A822 A7FA 
  0914 A824 0460  	B	@RETURN
       A826 A684 
  0915            
  0916            
  0917            * CASCII - Convert LONibble in R0 to ASCII
  0918            *
  0919            * Input:
  0920            *	R0 LON hex digit
  0921            *	R1 Address to store ASCII
  0922            * Output:
  0923            *	R0 HOB ascii value
  0924            * Uses:
  0925            *	R1, R1
  0926            *
  0927 A828 0000  CNULL	DATA	>0000
  0928 A82A 0280  CASCII	CI	R0,9
       A82C 0009 
  0929 A82E 1B03  	JH	CASCAF
  0930 A830 0220  	AI	R0,'0'
       A832 0030 
  0931 A834 1002  	JMP	CASEND
  0932 A836 0220  CASCAF	AI	R0,'A'-10
       A838 0037 
  0933 A83A 06C0  CASEND	SWPB	R0
  0934 A83C DC40  	MOVB	R0,*R1+
  0935 A83E D460  	MOVB	@CNULL,*R1
       A840 A828 

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0022
  0936 A842 045B  	B	*R11
  0937            
  0938            
  0939            * End Of Misc Functions
  0940            	COPY ".\MEMT_FUNC.A99"
  0941            * TI99 Memory test functions
  0942            *
  0943            * Copyright (c) 1998 by Michael Barr.
  0944            * Converted to TMS9900 assembly by: Frederik G. Kaal, 06 may
  0945            
  0946            *	TITL 'MEMTEST FUNCTIONS 06/05/2007'
  0947            *	IDT 'MEMTEST'
  0948            
  0949            	DEF	MTDB,MTAB,MTDV
  0950            
  0951            * Memory test functions
  0952            *
  0953            * All test functions take as input an address in R0
  0954            * consisting of a Base address, Region size and the
  0955            * databus width of the device.
  0956            * All test functions returns the used addresses,
  0957            * values and patterns as described in the following
  0958            * table.
  0959            *
  0960      A844  MT#WSP	EQU	$	Memorytest workspace
  0961 A844 0000  MT#ERR	DATA	0	(R0)  Error code
  0962 A846 0000  MT#BAS	DATA	0	(R1)  Base address
  0963 A848 0000  MT#RSZ	DATA	0	(R2)  Region size
  0964 A84A 0000  MT#IAP	DATA	0	(R3)  Inverted address mask
  0965 A84C 0000  MT#OF1	DATA	0	(R4)  Offset 1 in device (write)
  0966 A84E 0000  MT#OF2	DATA	0	(R5)  Offset 2 in device (read/test)
  0967 A850 0000  MT#ADR	DATA	0	(R6)  Base address + Offset 1 or 2
  0968 A852 0000  MT#WDP	DATA	0	(R7)  Written default  pattern
  0969 A854 0000  MT#WIP	DATA	0	(R8)  Written inverted pattern
  0970 A856 0000  MT#RBP	DATA	0	(R9)  Readback pattern
  0971 A858 0000  MT#MNP	DATA	0	(R10) Max number of pages
  0972 A85A 0000  MT#R11	DATA	0
  0973 A85C 0000  MT#R12	DATA	0
  0974 A85E 0000  MT#R13	DATA	0
  0975 A860 0000  MT#R14	DATA	0
  0976 A862 0000  MT#R15	DATA	0
  0977            
  0978 A864 A844  MTDB	DATA	MT#WSP,MTDB$	Databus test
       A866 A88A 
  0979 A868 A844  MTAB	DATA	MT#WSP,MTAB$	Adresbus test
       A86A A8CC 
  0980 A86C A844  MTDV	DATA	MT#WSP,MTDV$	Device test
       A86E A962 
  0981            
  0982            * MTGTTV - Memorytest Get Table Values
  0983            *
  0984            * Get the table values of a memory region under test.
  0985            *
  0986            * Input : R13 Pointer to callers workspace in witch
  0987            *             R0 contains the address of structure with
  0988            *             Base address,Region size,Databus width 8/16,
  0989            *             address mask and number of pages.
  0990            *
  0991            * Output: R1 Base address

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0023
  0992            *         R2 Region size
  0993            *         R3 Databus width
  0994            *         R10 Number of pages
  0995            *
  0996            * Uses  : R0,R1,R2,R3,R11
  0997            *
  0998 A870 C29D  MTGTTV	MOV	*R13,R10	Get test table entry
  0999 A872 C07A  	MOV	*R10+,R1	Base address
  1000 A874 C0BA  	MOV	*R10+,R2	Region size
  1001 A876 C0FA  	MOV	*R10+,R3	Databus with
  1002 A878 C03A  	MOV	*R10+,R0	Address mask
  1003 A87A C2BA  	MOV	*R10+,R10	Number of pages
  1004 A87C 04C4  	CLR	R4
  1005 A87E 04C5  	CLR	R5
  1006 A880 04C6  	CLR	R6
  1007 A882 04C7  	CLR	R7
  1008 A884 04C8  	CLR	R8
  1009 A886 04C9  	CLR	R9
  1010 A888 045B  	B	*R11
  1011            
  1012            * MTDB - Memorytest DataBus
  1013            *
  1014            * Test the databus wiring in a memory region by
  1015            * performing a walking 1's test (LSB to MSB) at
  1016            * a fixed address within that region.
  1017            *
  1018            * Input : R0 of callers workspace contains address of
  1019            *            structure with  Base address,Region size,
  1020            *            Databus width 8/16, Address mask and
  1021            *            Number of pages.
  1022            *
  1023            * Output: SR EQ=1 test succeeded, MT#ERR=0
  1024            *         SR EQ=0 test failed
  1025            *	  MT#ERR=1 Databus failure
  1026            *         and rest of MT#WSP filled as described.
  1027            *
  1028            * Uses  : All
  1029            
  1030 A88A 06A0  MTDB$	BL	@MTGTTV		Get memory test table values
       A88C A870 
  1031 A88E C181  	MOV	R1,R6		Test address
  1032 A890 0207  	LI	R7,>0001	Assume 16 bits
       A892 0001 
  1033 A894 0283  	CI	R3,16		Width is 16 bits?
       A896 0010 
  1034 A898 1309  	JEQ	MTDB3		Yes!
  1035 A89A 0207  	LI	R7,>0100	No, 8 bits!
       A89C 0100 
  1036            	
  1037 A89E D587  MTDB1	MOVB	R7,*R6		Write pattern
  1038 A8A0 D256  	MOVB	*R6,R9		Read back
  1039 A8A2 9247  	CB	R7,R9		Equal?
  1040 A8A4 160E  	JNE	MTDBNE		No!
  1041 A8A6 0A17  	SLA	R7,1		Next bit
  1042 A8A8 16FA  	JNE	MTDB1
  1043 A8AA 1007  	JMP	MTDBEQ		Success
  1044            	
  1045 A8AC C587  MTDB3	MOV	R7,*R6		Write pattern
  1046 A8AE C256  	MOV	*R6,R9		Read back

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0024
  1047 A8B0 8247  	C	R7,R9		Equal?
  1048 A8B2 1607  	JNE	MTDBNE		No!
  1049 A8B4 0A17  	SLA	R7,1		Next bit
  1050 A8B6 16FA  	JNE	MTDB3		
  1051 A8B8 1000  	JMP	MTDBEQ		Success
  1052            
  1053 A8BA 04C0  MTDBEQ	CLR	R0		Error 0: Success
  1054 A8BC 026F  	ORI	R15,>2000	Success, set EQ
       A8BE 2000 
  1055 A8C0 0380  	RTWP
  1056 A8C2 0200  MTDBNE	LI	R0,1		Error 1: Databus failure
       A8C4 0001 
  1057 A8C6 024F  	ANDI	R15,>DFFF	Failure, reset EQ
       A8C8 DFFF 
  1058 A8CA 0380  	RTWP
  1059            
  1060            
  1061            * MTAB - Memorytest AddressBus
  1062            *
  1063            * Test the address bus wiring in a memory region by
  1064            * performing a walking 1's test on the relevant bits
  1065            * of the address and checking for aliasing. This test
  1066            * will find single-bit address failures such as stuck
  1067            * -high, stuck-low, and shorted pins.  The base address
  1068            * and size of the region are selected by the caller.
  1069            *
  1070            * Input : R0 of callers workspace contains address of
  1071            *            structure with  Base address,Region size,
  1072            *            Databus width 8/16, Address mask and
  1073            *            Number of pages.
  1074            *
  1075            * Output: SR EQ=1 test succeeded
  1076            *         SR EQ=0 test failed
  1077            *         MT#ERR=2 Address line stuck low
  1078            *         MT#ERR=3 Address line stuck high
  1079            *         MT#ERR=4 Address lines shorted
  1080            *         and rest of MT#WSP filled as described.
  1081            *
  1082            * Uses  : All
  1083            
  1084 A8CC 06A0  MTAB$	BL	@MTGTTV		Get memory test table values
       A8CE A870 
  1085            
  1086 A8D0 C101  	MOV	R1,R4		Base address
  1087 A8D2 C142  	MOV	R2,R5		Region size
  1088 A8D4 04F4  MTAB0	CLR	*R4+		Clear region
  1089 A8D6 0645  	DECT	R5
  1090 A8D8 16FD  	JNE	MTAB0	
  1091            
  1092 A8DA C0C0  	MOV	R0,R3		Address mask
  1093 A8DC 0543  	INV	R3		Inverted address mask
  1094 A8DE 0207  	LI	R7,>A500	Pattern
       A8E0 A500 
  1095 A8E2 0208  	LI	R8,>5A00	Inverted pattern
       A8E4 5A00 
  1096            
  1097            * Write the default pattern at each of the power-of-two offs
  1098 A8E6 0204  	LI	R4,1		Offset
       A8E8 0001 

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0025
  1099 A8EA C181  MTAB1	MOV	R1,R6		Base address
  1100 A8EC A184  	A	R4,R6		+ Offset
  1101 A8EE D587  	MOVB	R7,*R6		= Pattern
  1102 A8F0 0A14  	SLA	R4,1		Offset <<= 1
  1103 A8F2 4103  	SZC	R3,R4		& address mask
  1104 A8F4 16FA  	JNE	MTAB1
  1105            	
  1106            * Check for address bits stuck high.
  1107 A8F6 D448  	MOVB	R8,*R1		Base address = Inverted pattern
  1108            	
  1109 A8F8 04C9  	CLR	R9		Readback register
  1110 A8FA 0204  	LI	R4,1		Offset
       A8FC 0001 
  1111 A8FE C181  MTAB2	MOV	R1,R6		Base address
  1112 A900 A184  	A	R4,R6		+ Offset
  1113 A902 D256  	MOVB	*R6,R9		Read back
  1114 A904 9247  	CB	R7,R9		Equals Pattern
  1115 A906 1625  	JNE	MTABE3		No, stuck high!
  1116 A908 0A14  	SLA	R4,1		Offset <<= 1
  1117 A90A 4103  	SZC	R3,R4		& address mask
  1118 A90C 16F8  	JNE	MTAB2
  1119            
  1120            * Check for address bits stuck low or shorted.
  1121 A90E D447  	MOVB	R7,*R1		Base address = Pattern
  1122            
  1123 A910 0204  	LI	R4,1		Testoffset
       A912 0001 
  1124 A914 C181  MTAB3	MOV	R1,R6		Base address
  1125 A916 A184  	A	R4,R6		+ TestOffset
  1126 A918 D588  	MOVB	R8,*R6		= Inverted Pattern
  1127 A91A D251  	MOVB	*R1,R9		Readback Base address
  1128 A91C 9247  	CB	R7,R9		Address stuck low?
  1129 A91E 1616  	JNE	MTABE2		Yes, Error!
  1130            
  1131 A920 0205  	LI	R5,1		Offset
       A922 0001 
  1132 A924 8105  MTAB4	C	R5,R4		Offset == TestOffset?
  1133 A926 1305  	JEQ	MTAB5		Yes, do not check!
  1134 A928 C181  	MOV	R1,R6		Base address
  1135 A92A A185  	A	R5,R6		+ Offset
  1136 A92C D256  	MOVB	*R6,R9		Readback
  1137 A92E 9247  	CB	R7,R9		Equals Pattern
  1138 A930 1613  	JNE	MTABE4		No, address lines shorted!
  1139 A932 0A15  MTAB5	SLA	R5,1		Offset <<= 1
  1140 A934 4143  	SZC	R3,R5		& address mask
  1141 A936 16F6  	JNE	MTAB4
  1142            
  1143 A938 C181  	MOV	R1,R6		Base address
  1144 A93A A184  	A	R4,R6		+ TestOffset
  1145 A93C D587  	MOVB	R7,*R6		= Pattern
  1146            
  1147 A93E 0A14  	SLA	R4,1		TestOffset <<= 1
  1148 A940 4103  	SZC	R3,R4		& address mask
  1149 A942 16E8  	JNE	MTAB3
  1150            
  1151 A944 04C0  MTABEQ	CLR	R0		Error 0: Success
  1152 A946 026F  	ORI	R15,>2000	Success, set EQ
       A948 2000 
  1153 A94A 0380  	RTWP

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0026
  1154            	
  1155 A94C 0200  MTABE2	LI	R0,2		Error 2: Address line stuck low
       A94E 0002 
  1156 A950 1005  	JMP	MTABNE	
  1157 A952 0200  MTABE3	LI	R0,3		Error 3: Address line stuck high
       A954 0003 
  1158 A956 1002  	JMP	MTABNE	
  1159 A958 0200  MTABE4	LI	R0,4		Error 4: Address lines shorted
       A95A 0004 
  1160 A95C 024F  MTABNE	ANDI	R15,>DFFF	Failure, reset EQ
       A95E DFFF 
  1161 A960 0380  	RTWP
  1162            
  1163            
  1164            * MTDV - Memorytest Device
  1165            *
  1166            * Test the integrity of a physical memory device by
  1167            * performing an increment/decrement test over the
  1168            * entire region.  In the process every storage bit 
  1169            * in the device is tested as a zero and a one.  The
  1170            * base address and the size of the region are
  1171            * selected by the caller.
  1172            *
  1173            * Input : R0 of callers workspace contains address of
  1174            *            structure with  Base address,Region size,
  1175            *            Databus width 8/16, Address mask and
  1176            *            Number of pages.
  1177            *
  1178            * Output: SR EQ=1 test succeeded
  1179            *         SR EQ=0 test failed
  1180            *         MT#ERR=5 Wrong pattern read back
  1181            *         MT#ERR=6 Wrong inverted pattern read back
  1182            *         and rest of MT#WSP filled as described.
  1183            *
  1184            * Uses  : All
  1185            
  1186 A962 06A0  MTDV$	BL	@MTGTTV		Get memory test table values
       A964 A870 
  1187            
  1188            * Fill memory with a known pattern.
  1189            
  1190 A966 04C4  	CLR	R4		Offset
  1191 A968 0207  	LI	R7,1		Pattern
       A96A 0001 
  1192 A96C C181  	MOV	R1,R6		Base address
  1193 A96E CD87  MTDV1	MOV	R7,*R6+
  1194 A970 0587  	INC	R7
  1195 A972 05C4  	INCT	R4
  1196 A974 8084  	C	R4,R2		End of region?
  1197 A976 1AFB  	JL	MTDV1		No!
  1198            	
  1199            * Check each location and invert it for the second pass.
  1200            
  1201 A978 04C9  	CLR	R9		Readback register
  1202 A97A 04C4  	CLR	R4		Offset
  1203 A97C 0207  	LI	R7,1		Pattern
       A97E 0001 
  1204 A980 C181  	MOV	R1,R6		Base address
  1205 A982 C256  MTDV2	MOV	*R6,R9		Read pattern

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0027
  1206 A984 8247  	C	R7,R9		Equals pattern?
  1207 A986 1619  	JNE	MTDVE5		No!
  1208 A988 C207  	MOV	R7,R8		Write inverted pattern
  1209 A98A 0548  	INV	R8
  1210 A98C CD88  	MOV	R8,*R6+
  1211 A98E 0587  	INC	R7		Increment pattern
  1212 A990 05C4  	INCT	R4		Increment offset
  1213 A992 8084  	C	R4,R2		End of region?
  1214 A994 1AF6  	JL	MTDV2		No!
  1215            
  1216            * Check each location for the inverted pattern and zero it.
  1217            
  1218 A996 04C4  	CLR	R4		Offset
  1219 A998 0207  	LI	R7,1		Pattern
       A99A 0001 
  1220 A99C C181  	MOV	R1,R6		Base address
  1221 A99E C207  MTDV3	MOV	R7,R8		Invert pattern
  1222 A9A0 0548  	INV	R8
  1223 A9A2 C256  	MOV	*R6,R9		Read pattern
  1224 A9A4 8248  	C	R8,R9		Equals inverted pattern?
  1225 A9A6 160C  	JNE	MTDVE6		No!
  1226 A9A8 04F6  	CLR	*R6+		Clear address
  1227 A9AA 0587  	INC	R7		Next pattern
  1228 A9AC 05C4  	INCT	R4		Next offset
  1229 A9AE 8084  	C	R4,R2		End of region?
  1230 A9B0 1AF6  	JL	MTDV3		No!
  1231 A9B2 04C0  MTDVEQ	CLR	R0		Error 0: Success
  1232 A9B4 026F  	ORI	R15,>2000	Success, set EQ
       A9B6 2000 
  1233 A9B8 0380  	RTWP
  1234            
  1235 A9BA 0200  MTDVE5	LI	R0,5		Error 5: Wrong pattern
       A9BC 0005 
  1236 A9BE 1002  	JMP	MTDVNE
  1237 A9C0 0200  MTDVE6	LI	R0,6		Error 6: Wrong inverted pattern
       A9C2 0006 
  1238 A9C4 024F  MTDVNE	ANDI	R15,>DFFF	Failure, reset EQ
       A9C6 DFFF 
  1239 A9C8 0380  	RTWP
  1240            	
  1241            *	END
  1242                   
  1243      A9CA  SLAST	EQU	$
  1244            	END

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0028
    ASKCR0  A7AE      ASKCR1  A7C8      ASKCR2  A7E0      ASKCR3  A7F0  
    ASKCR4  A7F6      ASKCRU  A79A      BA10WD  A486      BACK    A636  
    BEGIN   A074      BEGIN1  A07C      BEGIN2  A096      BEGIN3  A0AA  
    CASCAF  A836      CASCII  A82A      CASEND  A83A      CNULL   A828  
    DSPCUR  A75C      DSPLIN  A760      DSPLN0  A766      DSPLN1  A76C  
    DSPLN2  A77E      ENDTAB  A044      ERMTAB  A572      ERRT0   A4EE  
    ERRT1   A4EE      ERRT2   A4F8      ERRT3   A508      ERRT4   A518  
    ERRT5   A528      ERRT6   A532      ERRT7   A53C      ERRT8   A54E  
    ERRT9   A560      GPLWS   83E0      HOB     0000      HOBASC  A7FA  
    KSCAN   A604      KSCAN$  A604      LOB     0001      LOBASC  A7FC  
    MAIN    A074      MEMTAB  A03A      MEMTEZ  000A      MT#ADR  A850  
    MT#BAS  A846      MT#ERR  A844      MT#IAP  A84A      MT#MNP  A858  
    MT#OF1  A84C      MT#OF2  A84E      MT#R11  A85A      MT#R12  A85C  
    MT#R13  A85E      MT#R14  A860      MT#R15  A862      MT#RBP  A856  
    MT#RSZ  A848      MT#WDP  A852      MT#WIP  A854      MT#WSP  A844  
  D MTAB    A868      MTAB$   A8CC      MTAB0   A8D4      MTAB1   A8EA  
    MTAB2   A8FE      MTAB3   A914      MTAB4   A924      MTAB5   A932  
    MTABE2  A94C      MTABE3  A952      MTABE4  A958      MTABEQ  A944  
    MTABNE  A95C    D MTDB    A864      MTDB$   A88A      MTDB1   A89E  
    MTDB3   A8AC      MTDBEQ  A8BA      MTDBNE  A8C2    D MTDV    A86C  
    MTDV$   A962      MTDV1   A96E      MTDV2   A982      MTDV3   A99E  
    MTDVE5  A9BA      MTDVE6  A9C0      MTDVEQ  A9B2      MTDVNE  A9C4  
    MTEST   A3D8      MTEST1  A402      MTEST2  A418      MTEST3  A42E  
    MTEST4  A444      MTFAIL  A586      MTFL$0  A590      MTFL$1  A5C2  
    MTFL$2  A5D0      MTFL$3  A5DE      MTFL$4  A5E4      MTFL$E  A5F6  
    MTGTTV  A870      MTPB    A0F8      MTPB$   A0FC      MTPB0   A10E  
    MTPB1   A120      MTPB2   A13A      MTPB3   A156      MTPB4   A16C  
    MTPB5   A17C      MTPBE7  A198      MTPBE8  A19E      MTPBE9  A1A4  
    MTPBEQ  A190      MTPBNE  A1A8      MTST4X  A462      MYCRU   A048  
    MYWS    A04A      OFBASE  0000      OFMASK  0006      OFPAGE  0008  
    OFR0    0000      OFR1    0002      OFR10   0014      OFR11   0016  
    OFR12   0018      OFR13   001A      OFR14   001C      OFR15   001E  
    OFR2    0004      OFR3    0006      OFR4    0008      OFR5    000A  
    OFR6    000C      OFR7    000E      OFR8    0010      OFR9    0012  
    OFSIZE  0002      OFWIDT  0004      PAUSE   A624      PAUSE1  A626  
    PAUSE2  A62C      PE70HB  A4D6      PE70WD  A4DE      PE80WD  A4E6  
    PN00LB  A46E      PN40LB  A476      PN50LB  A47E      PR90HB  A4C6  
    PR90WD  A4CE      PRTCUR  A790      PRTLIN  A782      PW70HB  A4A6  
    PW70WD  A4AE      PW80HB  A4B6      PW80WD  A4BE      QUIT    A68A  
    R0      0000      R1      0001      R10     000A      R11     000B  
    R12     000C      R13     000D      R14     000E      R15     000F  
    R2      0002      R3      0003      R4      0004      R5      0005  
    R6      0006      R7      0007      R8      0008      R9      0009  
    REDO    A646      RETURN  A684      SAVR11  A602      SCAN    000E  
    SCRBUF  A6F4      SCRLL0  A716      SCRLL1  A71A      SCRLL2  A750  
    SCROFF  A004      SCROLL  A714      SELPG   A0E0      SELPG0  A0DE  
  D SFIRST  A000    D SLAST   A9CA      STACK   A06A      TA14WD  A496  
    TA15WD  A49E      TA60WD  A48E      TITLE   A006      TXTABT  A1D8  
    TXTADR  A347      TXTBAD  A1AE      TXTBAS  A32F      TXTBCK  A3A7  
    TXTCRU  A01A      TXTDBT  A1C7      TXTDVT  A1E9      TXTER0  A22C  
    TXTER1  A23B      TXTER2  A24C      TXTER3  A264      TXTER4  A27D  
    TXTER5  A294      TXTER6  A2AD      TXTER7  A2CB      TXTER8  A2E0  
    TXTER9  A2F6      TXTERR  A30A      TXTERT  A218      TXTEXP  A38F  
    TXTFLD  A20F      TXTOK   A20B      TXTPBT  A1FA      TXTPGN  A317  
    TXTRDP  A377      TXTRED  A3C1      TXTWRP  A35F      USEXIT  A0D4  
    USEXT0  A0DC      USINI0  A0D2      USINIT  A0BE      UTLWS   A04A  
    VDPADR  A69E      VDPADW  A696      VDPLWA  A692      VDPRD   8800  
    VDPWA   8C02      VDPWAO  A694      VDPWD   8C00      VMBR    A6DE  

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0029
    VMBR1   A6E8      VMBR2   A6F0      VMBW    A6BA      VMBW1   A6C4  
    VMBW2   A6CC      VSBR    A6D0      VSBW    A6AC      WHAT    A656  
    WHAT0   A658      WHAT1   A660      WHAT2   A668      WHAT3   A67C  
    WRDASC  A818  
  0000 ERRORS

 Xa99 Cross Assembler
MEMTEST IDE 19/05/2015                                       PAGE 0030
  SEGMENT AORG     SIZE 02506 (>09CA) BYTES
