
 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0001
  0002            	IDT  'EA32KB'
  0003            
  0004 6000       	AORG	>6000
  0005            
  0006            	DEF	SFIRST,SLAST
  0007            
  0008 6000 0460  SFIRST	B	@MAIN
       6002 6080 
  0009            	
  0010 6004 0000  SCROFF	DATA	>0000	Screen offset
  0011            
  0012            	COPY ".\MEMT_SAMS.A99"
  0013            * MEMT_IDE - Main Memory Test Program for Ide Card
  0014            *
  0016            	IDT 'MAIN'
  0017            
  0018            *---------------------------------------------------	
  0019 6006   53  TITLE	TEXT	'Sams Memory test'
  0020 6016   00  	BYTE	0
  0021            *TXTCRU	TEXT	'Enter '
  0022 6017   53  TXTCRD  TEXT    'SAMS-card CRU address >1E'
  0023 6030   00  	BYTE	0
  0024            	EVEN
  0025            
  0026            *---------------------------------------------------	
  0027            * A SAMS (Super Asgard Memory System) card consists
  0028            * of 2 512Kb x 8 bits memory chips configured as
  0029            * 4Kb x 256 pages and a memory mapper.
  0030            * Any of the 256 pages can be mapped in to the memory
  0031            * area of >2000, >3000, >A000, >B000, >C000, >D000,
  0032            * >E000 or >F000.
  0033            *
  0034            * Normal 32Kb functionality can be tested with the
  0035            * RTEA_32KB progrma or also added to this SAMS test
  0036            * program.
  0037            *
  0038            * Because this program only tests the addressbus and
  0039            * databus and paging functioning of the RAM chips
  0040            * an additional test must be added if the complete
  0041            * functioning of the memory mapper must also be
  0042            * checked.
  0043            *
  0044            * SAMS CRU address >1E00
  0045            * Mapper register  CRU 0  0=Off, 1=On
  0046            * Mapper           CRU 1  0=Off (transparent) 1=On
  0047            *
  0048            * SAMS Mapper registers
  0049            * MR00 @ >4000 maps region >0000 (not used)
  0050            * MR01 @ >4002 maps region >1000 (not used)
  0051            * MR02 @ >4004 maps region >2000 (expansion memory)
  0052            * MR03 @ >4006 maps region >3000 (expansion memory)
  0053            * MR04 @ >4008 maps region >4000 (not used)
  0054            * MR05 @ >400A maps region >5000 (not used)
  0055            * MR06 @ >400C maps region >6000 (not used)
  0056            * MR07 @ >400E maps region >7000 (not used)
  0057            * MR08 @ >4010 maps region >8000 (not used)
  0058            * MR09 @ >4012 maps region >9000 (not used)
  0059            * MR10 @ >4014 maps region >A000 (expansion memory)
  0060            * MR11 @ >4016 maps region >B000 (expansion memory)

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0002
  0061            * MR12 @ >4018 maps region >C000 (expansion memory)
  0062            * MR13 @ >401A maps region >D000 (expansion memory)
  0063            * MR14 @ >401C maps region >E000 (expansion memory)
  0064            * MR15 @ >401E maps region >F000 (expansion memory)
  0065            *
  0066            *---------------------------------------------------	
  0067            * Memorytable with testaddresses 
  0068            *
  0069            *               Base  Size  Width Mask  Pages
  0070 6032 2000  MEMTAB	DATA	>2000,>2000,>0008,>1FFF,0		Transparent mode
       6034 2000 
       6036 0008 
       6038 1FFF 
       603A 0000 
  0071 603C A000  	DATA	>A000,>6000,>0008,>5FFF,0		Transparent mode
       603E 6000 
       6040 0008 
       6042 5FFF 
       6044 0000 
  0072            *	DATA	>2000,>1000,>0008,>0FFF,64		128Kb Sams
  0073            *	DATA	>2000,>1000,>0008,>0FFF,128		512Kb Sams
  0074 6046 2000  	DATA	>2000,>1000,>0008,>0FFF,256		1Mb Sams
       6048 1000 
       604A 0008 
       604C 0FFF 
       604E 0100 
  0075 6050 0000  ENDTAB	DATA	>0000,>0000
       6052 0000 
  0076            
  0077      0000  OFBASE	EQU	0		Offset Base address
  0078      0002  OFSIZE	EQU	2		Offset Region Size
  0079      0004  OFWIDT	EQU	4		Offset Databus width
  0080      0006  OFMASK	EQU	6		Offset Address mask
  0081      0008  OFPAGE	EQU	8		Offset Number of pages
  0082      000A  MEMTEZ	EQU	10		Memtab entry size
  0083            
  0084 6054 1E00  MYCRU	DATA	>1E00		My Card's CRU address
  0085 6056       MYWS	BSS	32		My workspace
  0086 6076       STACK	BSS	10		My stack
  0087            *---------------------------------------------------	
  0088            
  0089            MAIN	
  0090 6080 02E0  BEGIN	LWPI	MYWS
       6082 6056 
  0091 6084 020A  	LI	R10,STACK
       6086 6076 
  0092            *	DATA	>0D00
  0093            
  0094            * Title	
  0095 6088 0201  BEGIN1	LI	R1,TITLE
       608A 6006 
  0096 608C 06A0  	BL	@PRTLIN
       608E 6778 
  0097 6090 06A0  	BL	@SCROLL
       6092 670A 
  0098            
  0099            * Ask CRU address
  0100 6094 0201  	LI	R1,TXTCRD
       6096 6017 

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0003
  0101 6098 06A0  	BL	@PRTLIN
       609A 6778 
  0102            *	BL	@ASKCRU
  0103            *	MOV	R12,@MYCRU	Save CRU addres
  0104            *	JNE	BEGIN2		Not >0000, Continue
  0105            *	B	@QUIT		Goodbye!
  0106 609C 06A0  BEGIN2	BL	@SCROLL
       609E 670A 
  0107            
  0108            * First initialization and select Page 0
  0109 60A0 06A0  	BL	@USINIT		Card on
       60A2 60C4 
  0110 60A4 06A0  	BL	@SELPG0		Page 0
       60A6 60DC 
  0111 60A8 06A0  	BL	@USEXIT		Card off
       60AA 60D0 
  0112            
  0113 60AC 020F  	LI	R15,MEMTAB
       60AE 6032 
  0114 60B0 06A0  BEGIN3	BL	@MTEST
       60B2 63CE 
  0115            	
  0116            *	DATA	>0D00
  0117 60B4 022F  	AI	R15,MEMTEZ	Next entry
       60B6 000A 
  0118 60B8 C02F  	MOV	@2(R15),R0	Size nil?
       60BA 0002 
  0119 60BC 16F9  	JNE	BEGIN3		No!
  0120            
  0121            * Return to title screen
  0122            *	DATA	>0D00		Debugger
  0123 60BE 06A0  	BL	@REDO
       60C0 663C 
  0124 60C2 10DE  	JMP	BEGIN
  0125            
  0126            * User Init function
  0127            *
  0128            * Initialize your hardware, like card on, etc.
  0129            * This function is called before a test is executed.
  0130            *
  0131 60C4 C320  USINIT	MOV	@MYCRU,R12
       60C6 6054 
  0132 60C8 1302  	JEQ	USINI0
  0133 60CA 1E00  	SBZ	0		Card off
  0134 60CC 1E01  	SBZ	1		Mapper off
  0135            *	DATA	>0D00
  0136 60CE 045B  USINI0	B	*R11
  0137            
  0138            * User Exit function.
  0139            *
  0140            * Save your hardware, like card off, etc.
  0141            * This function is called after a test has been executed.
  0142            *
  0143 60D0 C320  USEXIT	MOV	@MYCRU,R12
       60D2 6054 
  0144 60D4 1302  	JEQ	USEXT0
  0145 60D6 1E00  	SBZ	0		Card off
  0146 60D8 1E01  	SBZ	1		Mapper off
  0147            *	DATA	>0D00

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0004
  0148 60DA 045B  USEXT0	B	*R11
  0149            
  0150            *---------------------------------------------------	
  0151            * Page Test Functions
  0152            *---------------------------------------------------	
  0153            
  0154            * SELPG0 - Select page 0
  0155            * SELPG  - Select a page x
  0156            *
  0157            * Input : R1 Page address 0-255
  0158            * Output: Page selected
  0159            * Uses  : R1, R11, R12
  0160            *
  0161 60DC 04C1  SELPG0	CLR	R1
  0162 60DE C320  SELPG	MOV	@MYCRU,R12
       60E0 6054 
  0163 60E2 1D00  	SBO	0		Enable mapper
  0164 60E4 0A81  	SLA	R1,8
  0165 60E6 D801  	MOVB	R1,@>4004	Map page @ >2000
       60E8 4004 
  0166 60EA 1D01  	SBO	1		Mapper on
  0167 60EC 1E00  	SBZ	0		Disable mapper
  0168 60EE 045B  	B	*R11
  0169            
  0170            * MTPB - Memorytest PageBus
  0171            *
  0172            * Test the page bus wiring by performing a walking 1's test
  0173            * on the relevant bits of the page addresses and checking
  0174            * for aliasing. This test will find single-bit address
  0175            * failures such as stuck-high, stuck-low, and shorted pins.
  0176            * The base address and size of the region are selected by
  0177            * the caller.
  0178            *
  0179            * Input : R0 of callers workspace contains address of
  0180            *            structure with Base address, Region size,
  0181            *            Databus width 8/16, Address mask and
  0182            *            Number of pages.
  0183            *
  0184            * Output: SR EQ=1 test succeeded
  0185            *         SR EQ=0 test failed
  0186            *         MT#ERR=7 Page line stuck low
  0187            *         MT#ERR=8 Page line stuck high
  0188            *         MT#ERR=9 Page lines shorted
  0189            *         and rest of MT#WSP filled as described.
  0190            *
  0191            * Uses  : All
  0192            
  0193 60F0 67DA  MTPB	DATA	MT#WSP,MTPB$	Pagebus test
       60F2 60F4 
  0194            
  0195 60F4 06A0  MTPB$	BL	@MTGTTV		Get memory test table values
       60F6 6806 
  0196 60F8 C181  	MOV	R1,R6		Base address
  0197            
  0198 60FA 0207  	LI	R7,>A500	Pattern
       60FC A500 
  0199 60FE 0208  	LI	R8,>5A00	Inverted pattern
       6100 5A00 
  0200            

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0005
  0201            * Clear all pages base address
  0202 6102 04C4  	CLR	R4		Page 0
  0203 6104 C044  MTPB0	MOV	R4,R1	
  0204 6106 06A0  	BL	@SELPG
       6108 60DE 
  0205 610A 04D6  	CLR	*R6		Base address = 0
  0206 610C 0584  	INC	R4		Next page
  0207 610E 8284  	C	R4,R10		More pages?
  0208 6110 1AF9  	JL	MTPB0		Yes!
  0209            
  0210            * Write the default pattern at each page of the power-of-two
  0211 6112 0204  	LI	R4,1		Page 1
       6114 0001 
  0212 6116 C044  MTPB1	MOV	R4,R1
  0213 6118 06A0  	BL	@SELPG
       611A 60DE 
  0214 611C D587  	MOVB	R7,*R6		= Pattern
  0215 611E 0A14  	SLA	R4,1		Page <<= 1
  0216 6120 8284  	C	R4,R10		More pages?
  0217 6122 1AF9  	JL	MTPB1		Yes!
  0218            	
  0219            * Check for page line stuck high.
  0220 6124 06A0  	BL	@SELPG0
       6126 60DC 
  0221 6128 D588  	MOVB	R8,*R6		Base address = Inverted pattern
  0222            	
  0223 612A 04C9  	CLR	R9		Readback register
  0224 612C 0204  	LI	R4,1		Page 1
       612E 0001 
  0225 6130 C044  MTPB2	MOV	R4,R1
  0226 6132 06A0  	BL	@SELPG
       6134 60DE 
  0227 6136 D256  	MOVB	*R6,R9		Read back
  0228 6138 9247  	CB	R7,R9		Equals Pattern
  0229 613A 162C  	JNE	MTPBE8		No, stuck high!
  0230 613C 0A14  	SLA	R4,1		Page <<= 1
  0231 613E 8284  	C	R4,R10		More pages?
  0232 6140 1AF7  	JL	MTPB2		Yes!
  0233            
  0234            * Check for page line stuck low or shorted.
  0235 6142 06A0  	BL	@SELPG0		Page 0
       6144 60DC 
  0236 6146 D587  	MOVB	R7,*R6		Base address = Pattern
  0237            
  0238 6148 0204  	LI	R4,1		Page 1
       614A 0001 
  0239 614C C044  MTPB3	MOV	R4,R1
  0240 614E 06A0  	BL	@SELPG
       6150 60DE 
  0241 6152 D588  	MOVB	R8,*R6		= Inverted Pattern
  0242            
  0243 6154 06A0  	BL	@SELPG0		Page 0
       6156 60DC 
  0244 6158 D256  	MOVB	*R6,R9		Readback Base address
  0245 615A 9247  	CB	R7,R9		Address stuck low?
  0246 615C 1618  	JNE	MTPBE7		Yes, Error!
  0247            
  0248 615E 0205  	LI	R5,1		Page 1
       6160 0001 

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0006
  0249 6162 8105  MTPB4	C	R5,R4		Page == Test Page?
  0250 6164 1306  	JEQ	MTPB5		Yes, do not check!
  0251            
  0252 6166 C045  	MOV	R5,R1
  0253 6168 06A0  	BL	@SELPG
       616A 60DE 
  0254 616C D256  	MOVB	*R6,R9		Readback
  0255 616E 9247  	CB	R7,R9		Equals Pattern
  0256 6170 1614  	JNE	MTPBE9		No, address lines shorted!
  0257 6172 0A15  MTPB5	SLA	R5,1		Page <<= 1
  0258 6174 8285  	C	R5,R10		More pages?
  0259 6176 1AF5  	JL	MTPB4		Yes!
  0260            
  0261 6178 C044  	MOV	R4,R1		Restore pattern
  0262 617A 06A0  	BL	@SELPG
       617C 60DE 
  0263 617E D587  	MOVB	R7,*R6		= Pattern
  0264            
  0265 6180 0A14  	SLA	R4,1		Page <<= 1
  0266 6182 8284  	C	R4,R10		More pages?
  0267 6184 1AE3  	JL	MTPB3		Yes!
  0268            
  0269 6186 04C0  MTPBEQ	CLR	R0		Error 0: Success
  0270 6188 026F  	ORI	R15,>2000	Success, set EQ
       618A 2000 
  0271 618C 0380  	RTWP
  0272            	
  0273 618E 0200  MTPBE7	LI	R0,7		Error 7: Page line stuck low
       6190 0007 
  0274 6192 1005  	JMP	MTPBNE	
  0275 6194 0200  MTPBE8	LI	R0,8		Error 8: Page line stuck high
       6196 0008 
  0276 6198 1002  	JMP	MTPBNE	
  0277 619A 0200  MTPBE9	LI	R0,9		Error 9: Page lines shorted
       619C 0009 
  0278 619E 024F  MTPBNE	ANDI	R15,>DFFF	Failure, reset EQ
       61A0 DFFF 
  0279 61A2 0380  	RTWP
  0280            
  0281            * End of Main ...
  0282            	COPY ".\MEMT_MISC.A99"
  0283            * MEMTMISC - Main Memory Misc Functions
  0284            *
  0285            *	TITL 'MEMTEST MISC 06/05/2007'
  0286            *	IDT 'MISC'
  0287            
  0288            *---------------------------------------------------
  0289 61A4   54  TXTBAD	TEXT	'Testing >xxxx size >xxxx'
  0290 61BC   00  	BYTE	0
  0291 61BD   20  TXTDBT	TEXT	' Databus test   '
  0292 61CD   00  	BYTE	0
  0293 61CE   20  TXTABT	TEXT	' Addressbus test'
  0294 61DE   00  	BYTE	0
  0295 61DF   20  TXTDVT	TEXT	' Device test    '
  0296 61EF   00  	BYTE	0
  0297 61F0   20  TXTPBT	TEXT	' Pagebus test   '
  0298 6200   00  	BYTE	0
  0299 6201   20  TXTOK	TEXT    ' Ok'
  0300 6204   00  	BYTE	0

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0007
  0301 6205   20  TXTFLD	TEXT	' Failed'
  0302 620C   00  	BYTE	0
  0303            *---------------------------------------------------
  0304            * Error texts
  0305            	EVEN
  0306 620E 6222  TXTERT	DATA	TXTER0,TXTER1,TXTER2,TXTER3,TXTER4
       6210 6231 
       6212 6242 
       6214 625A 
       6216 6273 
  0307 6218 628A  	DATA	TXTER5,TXTER6,TXTER7,TXTER8,TXTER9
       621A 62A3 
       621C 62C1 
       621E 62D6 
       6220 62EC 
  0308            
  0309 6222   20  TXTER0	TEXT	' Unknown error'
  0310 6230   00  	BYTE	0
  0311 6231   20  TXTER1	TEXT	' Databus failure'
  0312 6241   00  	BYTE	0
  0313 6242   20  TXTER2	TEXT	' Address line stuck low'
  0314 6259   00  	BYTE	0
  0315 625A   20  TXTER3	TEXT	' Address line stuck high'
  0316 6272   00  	BYTE	0
  0317 6273   20  TXTER4	TEXT	' Address lines shorted'
  0318 6289   00  	BYTE	0
  0319 628A   20  TXTER5	TEXT	' Wrong pattern read back'
  0320 62A2   00  	BYTE	0
  0321 62A3   20  TXTER6	TEXT	' Wrong inv. pattern read back'
  0322 62C0   00  	BYTE	0
  0323 62C1   20  TXTER7	TEXT	' Page line stuck low'
  0324 62D5   00  	BYTE	0
  0325 62D6   20  TXTER8	TEXT	' Page line stuck high'
  0326 62EB   00  	BYTE	0
  0327 62EC   20  TXTER9	TEXT	' Page lines shorted'
  0328 62FF   00  	BYTE	0
  0329            *---------------------------------------------------
  0330 6300   20  TXTERR	TEXT	' Error >0000'
  0331 630C   00  	BYTE	0
  0332 630D   20  TXTPGN	TEXT	' Page number      >xxxx'
  0333 6324   00  	BYTE	0
  0334 6325   20  TXTBAS	TEXT	' Base address     >xxxx'
  0335 633C   00  	BYTE	0
  0336 633D   20  TXTADR	TEXT	' Test address     >xxxx'
  0337 6354   00  	BYTE	0
  0338 6355   20  TXTWRP	TEXT	' Pattern written  >xxxx'
  0339 636C   00  	BYTE	0
  0340 636D   20  TXTRDP	TEXT	' Pattern readback >xxxx'
  0341 6384   00  	BYTE	0
  0342 6385   20  TXTEXP	TEXT	' Pattern expected >xxxx'
  0343 639C   00  	BYTE	0
  0344            *---------------------------------------------------
  0345 639D   50  TXTBCK	TEXT	'Press <proceed> or <back>'
  0346 63B6   00  	BYTE	0
  0347 63B7   50  TXTRED	TEXT	'Press <redo> or <back>'
  0348 63CD   00  	BYTE	0
  0349            	EVEN
  0350            *---------------------------------------------------
  0351            

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0008
  0352            
  0353            * MTEST - Memory test
  0354            *
  0355            * Do the databus, addressbus and device test
  0356            *
  0357            * Input : R15 addess of memory entry width
  0358            *             base address, regionsize and width
  0359            *
  0360            * Uses  : R0 - R11
  0361            * Output: 
  0362            *
  0363 63CE CE8B  MTEST	MOV	R11,*R10+	Save return address
  0364            *---------------------------------------------------
  0365            * User Init Function
  0366            *---------------------------------------------------
  0367 63D0 06A0  	BL	@USINIT
       63D2 60C4 
  0368            
  0369            *---------------------------------------------------
  0370            * Initialize registers
  0371            *---------------------------------------------------
  0372 63D4 C01F  	MOV	*R15,R0		Base Address
  0373 63D6 0201  	LI	R1,TXTBAD+9
       63D8 61AD 
  0374 63DA 06A0  	BL	@WRDASC
       63DC 67AE 
  0375 63DE 0200  	LI	R0,>2000	Remove '0' in string
       63E0 2000 
  0376 63E2 D440  	MOVB	R0,*R1
  0377            
  0378 63E4 C02F  	MOV	@2(R15),R0	Region Size
       63E6 0002 
  0379 63E8 0201  	LI	R1,TXTBAD+20
       63EA 61B8 
  0380 63EC 06A0  	BL	@WRDASC
       63EE 67AE 
  0381            
  0382 63F0 0201  	LI	R1,TXTBAD	Print: Testing >xxxx Size >xxxx
       63F2 61A4 
  0383 63F4 06A0  	BL	@PRTLIN
       63F6 6778 
  0384            
  0385            *---------------------------------------------------
  0386            * Databus test
  0387            *---------------------------------------------------
  0388 63F8 0200  MTEST1	LI	R0,23*32
       63FA 02E0 
  0389 63FC 0201  	LI	R1,TXTDBT	Print: Adresbus test
       63FE 61BD 
  0390 6400 06A0  	BL	@DSPLIN
       6402 6756 
  0391            *	DATA	>0D00
  0392 6404 C00F  	MOV	R15,R0		Test entry
  0393 6406 0420  	BLWP	@MTDB		Test databus
       6408 67FA 
  0394 640A 06A0  	BL	@MTFAIL		Failure?
       640C 657C 
  0395            	
  0396            *---------------------------------------------------

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0009
  0397            * Addressbus test
  0398            *---------------------------------------------------
  0399 640E 0200  MTEST2	LI	R0,23*32
       6410 02E0 
  0400 6412 0201  	LI	R1,TXTABT	Print: Databus test
       6414 61CE 
  0401 6416 06A0  	BL	@DSPLIN
       6418 6756 
  0402            *	DATA	>0D00		Debugger
  0403 641A C00F  	MOV	R15,R0		Test entry
  0404 641C 0420  	BLWP	@MTAB		Test addressbus
       641E 67FE 
  0405 6420 06A0  	BL	@MTFAIL		Failure?
       6422 657C 
  0406            	
  0407            *---------------------------------------------------
  0408            * Device test
  0409            *---------------------------------------------------
  0410 6424 0200  MTEST3	LI	R0,23*32
       6426 02E0 
  0411 6428 0201  	LI	R1,TXTDVT	Print: Device test
       642A 61DF 
  0412 642C 06A0  	BL	@DSPLIN
       642E 6756 
  0413 6430 C00F  	MOV	R15,R0		Test entry
  0414 6432 0420  	BLWP	@MTDV		Test device
       6434 6802 
  0415 6436 06A0  	BL	@MTFAIL		Failure?
       6438 657C 
  0416            
  0417 TRUE       #ifdef MTPB
  0418            *---------------------------------------------------
  0419            * Pagebus test
  0420            *---------------------------------------------------
  0421 643A C04F  MTEST4	MOV	R15,R1		Any pages to test?
  0422 643C C021  	MOV	@OFPAGE(R1),R0
       643E 0008 
  0423 6440 130B  	JEQ	MTST4X		No!	
  0424            
  0425 6442 0200  	LI	R0,23*32
       6444 02E0 
  0426 6446 0201  	LI	R1,TXTPBT	Print: Pagebus test
       6448 61F0 
  0427 644A 06A0  	BL	@DSPLIN
       644C 6756 
  0428 644E C00F  	MOV	R15,R0		Base address
  0429 6450 0420  	BLWP	@MTPB		Test pagebus
       6452 60F0 
  0430 6454 06A0  	BL	@MTFAIL
       6456 657C 
  0431            MTST4X
  0432 TRUE       #endif
  0433            
  0434            *---------------------------------------------------
  0435            * User Exit Function
  0436            *---------------------------------------------------
  0437 6458 06A0  	BL	@USEXIT
       645A 60D0 
  0438 645C 06A0  	BL	@SCROLL		Test finished

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0010
       645E 670A 
  0439 6460 0460  	B	@RETURN
       6462 667A 
  0440            
  0441            *---------------------------------------------------
  0442            * Error message definitions
  0443            *---------------------------------------------------
  0444            	
  0445            *		Text,Reg,Reg,Conv
  0446            
  0447            * Page number      >xxxx
  0448 6464 630D  PN00LB	DATA	TXTPGN,0,0,LOBASC
       6466 0000 
       6468 0000 
       646A 6792 
  0449 646C 630D  PN40LB	DATA	TXTPGN,MT#OF1,0,LOBASC
       646E 67E2 
       6470 0000 
       6472 6792 
  0450 6474 630D  PN50LB	DATA	TXTPGN,MT#OF2,0,LOBASC
       6476 67E4 
       6478 0000 
       647A 6792 
  0451            
  0452            * Base address     >xxxx
  0453 647C 6325  BA10WD	DATA	TXTBAS,MT#BAS,0,WRDASC
       647E 67DC 
       6480 0000 
       6482 67AE 
  0454            
  0455            * Test address     >xxxx
  0456 6484 633D  TA60WD	DATA	TXTADR,MT#ADR,0,WRDASC
       6486 67E6 
       6488 0000 
       648A 67AE 
  0457 648C 633D  TA14WD	DATA	TXTADR,MT#BAS,MT#OF1,WRDASC
       648E 67DC 
       6490 67E2 
       6492 67AE 
  0458 6494 633D  TA15WD	DATA	TXTADR,MT#BAS,MT#OF2,WRDASC
       6496 67DC 
       6498 67E4 
       649A 67AE 
  0459            
  0460            * Pattern written  >xxxx
  0461 649C 6355  PW70HB	DATA	TXTWRP,MT#WDP,0,HOBASC
       649E 67E8 
       64A0 0000 
       64A2 6790 
  0462 64A4 6355  PW70WD	DATA	TXTWRP,MT#WDP,0,WRDASC
       64A6 67E8 
       64A8 0000 
       64AA 67AE 
  0463 64AC 6355  PW80HB	DATA	TXTWRP,MT#WIP,0,HOBASC
       64AE 67EA 
       64B0 0000 
       64B2 6790 
  0464 64B4 6355  PW80WD	DATA	TXTWRP,MT#WIP,0,WRDASC
       64B6 67EA 

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0011
       64B8 0000 
       64BA 67AE 
  0465            
  0466            * Pattern readback >xxxx
  0467 64BC 636D  PR90HB	DATA	TXTRDP,MT#RBP,0,HOBASC
       64BE 67EC 
       64C0 0000 
       64C2 6790 
  0468 64C4 636D  PR90WD	DATA	TXTRDP,MT#RBP,0,WRDASC
       64C6 67EC 
       64C8 0000 
       64CA 67AE 
  0469            
  0470            * Pattern expected >xxxx
  0471 64CC 6385  PE70HB	DATA	TXTEXP,MT#WDP,0,HOBASC
       64CE 67E8 
       64D0 0000 
       64D2 6790 
  0472 64D4 6385  PE70WD	DATA	TXTEXP,MT#WDP,0,WRDASC
       64D6 67E8 
       64D8 0000 
       64DA 67AE 
  0473 64DC 6385  PE80WD	DATA	TXTEXP,MT#WIP,0,WRDASC
       64DE 67EA 
       64E0 0000 
       64E2 67AE 
  0474            
  0475            
  0476            ERRT0
  0477 64E4 648C  ERRT1	DATA	TA14WD,PW70HB,PR90HB,PE70HB
       64E6 649C 
       64E8 64BC 
       64EA 64CC 
  0478 64EC 0000  	DATA	0
  0479            
  0480 64EE 647C  ERRT2	DATA	BA10WD,PW70HB,TA14WD,PW80HB
       64F0 649C 
       64F2 648C 
       64F4 64AC 
  0481 64F6 647C  	DATA	BA10WD,PR90HB,PE70HB
       64F8 64BC 
       64FA 64CC 
  0482 64FC 0000  	DATA	0
  0483            
  0484 64FE 648C  ERRT3	DATA	TA14WD,PW70HB,BA10WD,PW80HB
       6500 649C 
       6502 647C 
       6504 64AC 
  0485 6506 648C  	DATA	TA14WD,PR90HB,PE70HB
       6508 64BC 
       650A 64CC 
  0486 650C 0000  	DATA	0
  0487            
  0488 650E 6494  ERRT4	DATA	TA15WD,PW70HB,TA14WD,PW80HB
       6510 649C 
       6512 648C 
       6514 64AC 
  0489 6516 6494  	DATA	TA15WD,PR90HB,PE70HB
       6518 64BC 

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0012
       651A 64CC 
  0490 651C 0000  	DATA	0
  0491            
  0492 651E 6484  ERRT5	DATA	TA60WD,PW70WD,PR90WD,PE70WD
       6520 64A4 
       6522 64C4 
       6524 64D4 
  0493 6526 0000  	DATA	0
  0494            
  0495 6528 6484  ERRT6	DATA	TA60WD,PW80WD,PR90WD,PE80WD
       652A 64B4 
       652C 64C4 
       652E 64DC 
  0496 6530 0000  	DATA	0
  0497            
  0498 6532 6484  ERRT7	DATA	TA60WD,PN00LB,PW70HB,PN40LB
       6534 6464 
       6536 649C 
       6538 646C 
  0499 653A 64AC  	DATA	PW80HB,PN00LB,PR90HB,PE70HB
       653C 6464 
       653E 64BC 
       6540 64CC 
  0500 6542 0000  	DATA	0
  0501            
  0502 6544 6484  ERRT8	DATA	TA60WD,PN40LB,PW70HB,PN00LB
       6546 646C 
       6548 649C 
       654A 6464 
  0503 654C 64AC  	DATA	PW80HB,PN40LB,PR90HB,PE70HB
       654E 646C 
       6550 64BC 
       6552 64CC 
  0504 6554 0000  	DATA	0
  0505            
  0506 6556 6484  ERRT9	DATA	TA60WD,PN50LB,PW70HB,PN40LB
       6558 6474 
       655A 649C 
       655C 646C 
  0507 655E 64AC  	DATA	PW80HB,PN50LB,PR90HB,PE70HB
       6560 6474 
       6562 64BC 
       6564 64CC 
  0508 6566 0000  	DATA	0
  0509            
  0510 6568 64E4  ERMTAB	DATA	ERRT0,ERRT1,ERRT2,ERRT3,ERRT4
       656A 64E4 
       656C 64EE 
       656E 64FE 
       6570 650E 
  0511 6572 651E  	DATA	ERRT5,ERRT6,ERRT7,ERRT8,ERRT9
       6574 6528 
       6576 6532 
       6578 6544 
       657A 6556 
  0512            
  0513            *---------------------------------------------------
  0514            * MTFAIL - Print informative messages about the
  0515            *          failure.

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0013
  0516            *
  0517            * Input : MT#xxx Filled
  0518            * Output: -
  0519            * Uses  : R0 - R11
  0520            
  0521 657C 1604  MTFAIL	JNE	MTFL$0		Failure
  0522 657E 0201  	LI	R1,TXTOK	Print: Ok
       6580 6201 
  0523 6582 0460  	B	@PRTCUR
       6584 6786 
  0524            
  0525 6586 CE8B  MTFL$0	MOV	R11,*R10+	Save return address
  0526 6588 06A0  	BL	@USEXIT		User Exit Function
       658A 60D0 
  0527 658C 0201  	LI	R1,TXTFLD	Print: Failed
       658E 6205 
  0528 6590 06A0  	BL	@PRTCUR
       6592 6786 
  0529            
  0530 6594 C020  	MOV	@MT#ERR,R0	Error code
       6596 67DA 
  0531 6598 0201  	LI	R1,TXTERR+8	Convert
       659A 6308 
  0532 659C 06A0  	BL	@WRDASC
       659E 67AE 
  0533 65A0 0201  	LI	R1,TXTERR
       65A2 6300 
  0534 65A4 06A0  	BL	@PRTLIN
       65A6 6778 
  0535            	
  0536 65A8 C160  	MOV	@MT#ERR,R5	Error code
       65AA 67DA 
  0537 65AC 0285  	CI	R5,9		Max error code
       65AE 0009 
  0538 65B0 1203  	JLE	MTFL$1		Ok
  0539 65B2 04C5  	CLR	R5		Unknown error
  0540 65B4 04E0  	CLR	@MT#ERR
       65B6 67DA 
  0541 65B8 0A15  MTFL$1	SLA	R5,1
  0542 65BA C065  	MOV	@TXTERT(R5),R1	Error text
       65BC 620E 
  0543 65BE 06A0  	BL	@PRTLIN
       65C0 6778 
  0544            	
  0545 65C2 C165  	MOV	@ERMTAB(R5),R5
       65C4 6568 
  0546 65C6 C1B5  MTFL$2	MOV	*R5+,R6		Text table address
  0547 65C8 1311  	JEQ	MTFL$E		End Of Table
  0548            	
  0549 65CA C1F6  	MOV	*R6+,R7		Text address
  0550 65CC 04C0  	CLR	R0
  0551 65CE C236  	MOV	*R6+,R8		Register 1
  0552 65D0 1301  	JEQ	MTFL$3
  0553 65D2 A018  	A	*R8,R0		Add value
  0554 65D4 C236  MTFL$3	MOV	*R6+,R8		Register 2
  0555 65D6 1301  	JEQ	MTFL$4
  0556 65D8 A018  	A	*R8,R0		Add value
  0557 65DA C236  MTFL$4	MOV	*R6+,R8		Conversion function
  0558            	

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0014
  0559 65DC C047  	MOV	R7,R1		Address for Value
  0560 65DE 0221  	AI	R1,19
       65E0 0013 
  0561 65E2 0698  	BL	*R8		Convert
  0562            	
  0563 65E4 C047  	MOV	R7,R1		Print text
  0564 65E6 06A0  	BL	@PRTLIN
       65E8 6778 
  0565 65EA 10ED  	JMP	MTFL$2
  0566            
  0567 65EC 06A0  MTFL$E	BL	@BACK		Proceed or back?
       65EE 662C 
  0568 65F0 06A0  	BL	@USINIT		User init function
       65F2 60C4 
  0569 65F4 0460  	B	@RETURN
       65F6 667A 
  0570            		
  0571            *---------------------------------------------------
  0572            * Utility routines
  0573      83E0  GPLWS	EQU	>83E0
  0574      000E  SCAN	EQU	>000E
  0575            *VDPRD	EQU	>8800
  0576            *VDPSTA	EQU	>8802
  0577            *VDPWD	EQU	>8C00
  0578            *VDPWA	EQU	>8C02
  0579            
  0580      0000  HOB	EQU	0	High order byte offset
  0581      0001  LOB	EQU	1	Low order byte offset
  0582            
  0583      0000  OFR0	EQU	0	Register offsets from workspace
  0584      0002  OFR1	EQU	2
  0585      0004  OFR2	EQU	4
  0586      0006  OFR3	EQU	6
  0587      0008  OFR4	EQU	8
  0588      000A  OFR5	EQU	10
  0589      000C  OFR6	EQU	12
  0590      000E  OFR7	EQU	14
  0591      0010  OFR8	EQU	16
  0592      0012  OFR9	EQU	18
  0593      0014  OFR10	EQU	20
  0594      0016  OFR11	EQU	22
  0595      0018  OFR12	EQU	24
  0596      001A  OFR13	EQU	26
  0597      001C  OFR14	EQU	28
  0598      001E  OFR15	EQU	30
  0599            
  0600      6056  UTLWS	EQU	MYWS
  0601 65F8 0000  SAVR11	DATA	>0000
  0602            
  0603            * KSCAN - Scan the keyboard
  0604            *
  0605            * Input : -
  0606            * Output: SR EQ=1 No key pressed
  0607            *         SR EQ=0 Key pressed
  0608            *         R0 Keycode in LSB
  0609            * Uses  : R0
  0610            *
  0611      65FA  KSCAN	EQU	$	DATA UTLWS,KSCAN$
  0612 65FA 02E0  KSCAN$	LWPI	GPLWS

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0015
       65FC 83E0 
  0613 65FE C80B  	MOV	R11,@SAVR11
       6600 65F8 
  0614 6602 06A0  	BL	@SCAN
       6604 000E 
  0615 6606 C2E0  	MOV	@SAVR11,R11
       6608 65F8 
  0616 660A 02E0  	LWPI	UTLWS
       660C 6056 
  0617            *	MOV	@SAVR11,@GPLWS+OFR11
  0618 660E D020  	MOVB	@>8375,R0	Get key code
       6610 8375 
  0619 6612 0980  	SRL	R0,8
  0620 6614 0280  	CI	R0,>00FF	Key pressed
       6616 00FF 
  0621 6618 045B  	B	*R11
  0622            
  0623            * PAUSE - Wait for a key press
  0624            *
  0625            * Input : -
  0626            * Output: -
  0627            * Uses  : R0
  0628            
  0629 661A CE8B  PAUSE	MOV	R11,*R10+
  0630 661C 06A0  PAUSE1	BL	@KSCAN		Wait for key pressed
       661E 65FA 
  0631 6620 13FD  	JEQ	PAUSE1
  0632 6622 06A0  PAUSE2	BL	@KSCAN		Wait for key release
       6624 65FA 
  0633 6626 16FD  	JNE	PAUSE2
  0634 6628 0460  	B	@RETURN
       662A 667A 
  0635            
  0636            * BACK - Wait for a key <proceed> or <back>
  0637            *        Goes to title screen if <back>
  0638            *
  0639            * Input : -
  0640            * Output: -
  0641            * Uses  : R0, R1, R2, R3, R13, R14
  0642            *
  0643 662C CE8B  BACK	MOV	R11,*R10+
  0644 662E 06A0  	BL	@SCROLL
       6630 670A 
  0645 6632 0201  	LI	R1,TXTBCK	Proceed or back
       6634 639D 
  0646 6636 020E  	LI	R14,12		Proceed key code
       6638 000C 
  0647 663A 1009  	JMP	WHAT0
  0648            
  0649            * REDO - Wait for a key <redo> or <back>
  0650            *        Goes to title screen if <back>
  0651            *
  0652            * Input : -
  0653            * Output: -
  0654            * Uses  : R0, R1, R2, R3, R13, R14
  0655            *
  0656 663C CE8B  REDO	MOV	R11,*R10+
  0657 663E 06A0  	BL	@SCROLL
       6640 670A 

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0016
  0658 6642 0201  	LI	R1,TXTRED	Proceed or back
       6644 63B7 
  0659 6646 020E  	LI	R14,6		Redo key code
       6648 0006 
  0660 664A 1001  	JMP	WHAT0
  0661            
  0662            * WHAT - Wait for a key press 
  0663            *        Goes to title screen if <back>
  0664            *
  0665            * Input : R1 address of text to print
  0666            *         R14 <proceed> or <redo>
  0667            * Output: -
  0668            * Uses  : R0, R1, R2, R3
  0669            *
  0670 664C CE8B  WHAT	MOV	R11,*R10+
  0671 664E 0200  WHAT0	LI	R0,23*32+1
       6650 02E1 
  0672 6652 06A0  	BL	@DSPLIN		Print text
       6654 6756 
  0673 6656 06A0  WHAT1	BL	@KSCAN		Wait for key pressed
       6658 65FA 
  0674 665A 13FD  	JEQ	WHAT1
  0675 665C C040  	MOV	R0,R1
  0676 665E 06A0  WHAT2	BL	@KSCAN		Wait for key release
       6660 65FA 
  0677 6662 16FD  	JNE	WHAT2
  0678 6664 8381  	C	R1,R14		Proceed/Redo?
  0679 6666 1305  	JEQ	WHAT3		Yes!
  0680 6668 0281  	CI	R1,15		Back?
       666A 000F 
  0681 666C 16F4  	JNE	WHAT1		No!
  0682 666E 0460  	B	@QUIT		Goodbye!
       6670 6680 
  0683 6672 06A0  WHAT3	BL	@SCROLL
       6674 670A 
  0684 6676 0460  	B	@RETURN
       6678 667A 
  0685            
  0686            * General stack routines
  0687            *
  0688            * Return from subroutine (called with BL @xxxx)
  0689            * With undefined status
  0690            *
  0691 667A 064A  RETURN	DECT R10		Fetch return adres
  0692 667C C2DA  	MOV  *R10,R11
  0693 667E 045B  	B    *R11		Return to calling program
  0694            
  0695            * Quit function
  0696            *
  0697            * First call user exit function before
  0698            * returning to title screen
  0699            *
  0700 6680 06A0  QUIT   BL   @USEXIT
       6682 60D0 
  0701 6684 0420         BLWP @>0000
       6686 0000 
  0702            
  0703            
  0704            * General VDP routines

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0017
  0705            
  0706      8C02  VDPWA  EQU  >8C02	      VDP write address
  0707      8C00  VDPWD  EQU  >8C00	      VDP write data address
  0708      8800  VDPRD  EQU  >8800	      VDP read  data address
  0709            
  0710            * VDPADW - VDP Address Write
  0711            * VDPADR - VDP Address Read
  0712            *
  0713            * Set the VDP write address
  0714            *
  0715            * Input:
  0716            *      R0   VDP address
  0717            * Output:
  0718            * Uses:
  0719            *      R0
  0720            
  0721 6688 0000  VDPLWA DATA >0000        VDP last write address
  0722 668A 4000  VDPWAO DATA >4000        VDP write address bits
  0723            
  0724 668C C800  VDPADW	MOV  R0,@VDPLWA  Save VDP write address
       668E 6688 
  0725 6690 E020  	SOC  @VDPWAO,R0	 Set write address bits
       6692 668A 
  0726 6694 06C0  VDPADR	SWPB R0		 Write lsb R0 first
  0727 6696 D800  	MOVB R0,@VDPWA
       6698 8C02 
  0728 669A 06C0  	SWPB R0		 Write msb R0
  0729 669C D800  	MOVB R0,@VDPWA
       669E 8C02 
  0730 66A0 045B  	B    *R11
  0731            
  0732            * VSBW - VDP Single Byte Write
  0733            *
  0734            * Input:
  0735            *      R0   VDP address
  0736            *      R1   msb Data
  0737            * Output:
  0738            * Uses:
  0739            *      R0
  0740            
  0741 66A2 CE8B  VSBW	MOV  R11,*R10+
  0742 66A4 06A0  	BL   @VDPADW
       66A6 668C 
  0743 66A8 D801  	MOVB R1,@VDPWD
       66AA 8C00 
  0744 66AC 0460  	B    @RETURN
       66AE 667A 
  0745            
  0746            * VMBW - VDP Multiple Byte Write
  0747            *
  0748            * Input:
  0749            *      R0   VDP address
  0750            *      R1   Data address
  0751            *      R2   Bytecount
  0752            * Output:
  0753            * Uses:
  0754            *      R0,R1,R2
  0755            
  0756 66B0 CE8B  VMBW	MOV  R11,*R10+

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0018
  0757 66B2 06A0  	BL   @VDPADW
       66B4 668C 
  0758 66B6 C082  	MOV  R2,R2	Something to copy?
  0759 66B8 1304  	JEQ  VMBW2	No!
  0760 66BA D831  VMBW1	MOVB *R1+,@VDPWD
       66BC 8C00 
  0761 66BE 0602  	DEC  R2
  0762 66C0 16FC  	JNE  VMBW1
  0763 66C2 0460  VMBW2	B    @RETURN
       66C4 667A 
  0764            
  0765            * VSBR - VDP Single Byte Read
  0766            *
  0767            * Input:
  0768            *      R0   VDP address
  0769            * Output:
  0770            *      R1   msb Data
  0771            * Uses:
  0772            *      R0,R1
  0773            
  0774 66C6 CE8B  VSBR	MOV  R11,*R10+
  0775 66C8 06A0  	BL   @VDPADR
       66CA 6694 
  0776 66CC D060  	MOVB @VDPRD,R1
       66CE 8800 
  0777 66D0 0460  	B    @RETURN
       66D2 667A 
  0778            
  0779            * VMBR - VDP Multiple Byte Read
  0780            *
  0781            * Input:
  0782            *      R0   VDP address
  0783            *      R1   Data address
  0784            *      R2   Bytecount
  0785            * Output:
  0786            * Uses:
  0787            *      R0,R1,R2
  0788            
  0789 66D4 CE8B  VMBR	MOV  R11,*R10+
  0790 66D6 06A0  	BL   @VDPADR
       66D8 6694 
  0791 66DA C082  	MOV  R2,R2	Something to copy?
  0792 66DC 1304  	JEQ  VMBR2	No!
  0793 66DE DC60  VMBR1	MOVB @VDPRD,*R1+
       66E0 8800 
  0794 66E2 0602  	DEC  R2
  0795 66E4 16FC  	JNE  VMBR1
  0796 66E6 0460  VMBR2	B    @RETURN
       66E8 667A 
  0797            
  0798            * SCROLL - Scrolls the screen (24*32) one line up
  0799            *
  0800            * Input:
  0801            * Output:
  0802            * Uses: 
  0803            *      R0,R1,R2,R3
  0804            *
  0805 66EA       SCRBUF	BSS	32
  0806 670A CE8B  SCROLL	MOV	R11,*R10+

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0019
  0807 670C 0203  SCRLL0	LI	R3,0		To line number
       670E 0000 
  0808            
  0809 6710 C003  SCRLL1	MOV	R3,R0		Copy from
  0810 6712 0220  	AI	R0,32
       6714 0020 
  0811 6716 0201  	LI	R1,SCRBUF
       6718 66EA 
  0812 671A 0202  	LI	R2,32
       671C 0020 
  0813 671E 06A0  	BL	@VMBR
       6720 66D4 
  0814            
  0815 6722 C003  	MOV	R3,R0		Copy to
  0816 6724 0201  	LI	R1,SCRBUF
       6726 66EA 
  0817 6728 0202  	LI	R2,32
       672A 0020 
  0818 672C 06A0  	BL	@VMBW
       672E 66B0 
  0819 6730 0223  	AI	R3,32
       6732 0020 
  0820 6734 0283  	CI	R3,23*32	All lines done?
       6736 02E0 
  0821 6738 1AEB  	JL	SCRLL1		No!
  0822            
  0823 673A 0201  	LI	R1,>2000	+>6000	Space
       673C 2000 
  0824 673E A060  	A	@SCROFF,R1
       6740 6004 
  0825 6742 0202  	LI	R2,32
       6744 0020 
  0826 6746 D801  SCRLL2	MOVB	R1,@VDPWD
       6748 8C00 
  0827 674A 0602  	DEC	R2
  0828 674C 16FC  	JNE	SCRLL2
  0829 674E 0460  	B	@RETURN
       6750 667A 
  0830            
  0831            * DSPLIN - Displays a line with text at the given location
  0832            *		until character 0 encountered
  0833            * DSPCUR - Displays a line with text at the current location
  0834            *		until character 0 encountered
  0835            *
  0836            * Input : R0 Screen location
  0837            *         R1 Address of line with text
  0838            * Output: R2 Number of characters printed
  0839            * Uses  : R0,R1,R2,R3
  0840            *
  0841 6752 CE8B  DSPCUR	MOV	R11,*R10+	Save return address
  0842 6754 1003  	JMP	DSPLN0
  0843 6756 CE8B  DSPLIN	MOV	R11,*R10+	Save return address
  0844 6758 06A0  	BL	@VDPADW		Set screen location
       675A 668C 
  0845 675C 04C2  DSPLN0	CLR	R2
  0846 675E C0E0  	MOV	@SCROFF,R3
       6760 6004 
  0847 6762 D031  DSPLN1	MOVB	*R1+,R0		Get character
  0848 6764 1307  	JEQ	DSPLN2		End of string

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0020
  0849 6766 A003  	A	R3,R0		Add screen offset
  0850 6768 D800  	MOVB	R0,@VDPWD
       676A 8C00 
  0851 676C 05A0  	INC	@VDPLWA
       676E 6688 
  0852 6770 0582  	INC	R2
  0853 6772 10F7  	JMP	DSPLN1
  0854 6774 0460  DSPLN2	B	@RETURN
       6776 667A 
  0855            
  0856            * PRTLIN - Prints a line with text on the last line of the s
  0857            *		until character 0 encountered and scroll the screen
  0858            *		one line.
  0859            *
  0860            * Input : R1 Address of line with text
  0861            * Output: -
  0862            * Uses  : R0,R1,R2
  0863            *
  0864 6778 CE8B  PRTLIN	MOV	R11,*R10+
  0865 677A 0200  	LI	R0,23*32	Set screen address at line 23
       677C 02E0 
  0866 677E 06A0  	BL	@DSPLIN
       6780 6756 
  0867 6782 0460  	B	@SCRLL0		Scroll a line and return
       6784 670C 
  0868            
  0869            * PRTCUR - Appends a line with text on the last line of the 
  0870            *		until character 0 encountered and scroll the screen
  0871            *		one line.
  0872            *
  0873            * Input : R1 Address of line with text
  0874            * Output: -
  0875            * Uses  : R0,R1,R2
  0876            *
  0877 6786 CE8B  PRTCUR	MOV	R11,*R10+
  0878 6788 06A0  	BL	@DSPCUR
       678A 6752 
  0879 678C 0460  	B	@SCRLL0		Scroll a line and return
       678E 670C 
  0880            
  0881            
  0882 FALSE      #ifdef TXTCRU
  0883            * ASKCRU - Ask for CRU address
  0884            *
  0885            * Input : -
  0886            * Output: R12 CRU address, or >0000 to quit
  0887            * Uses  : R0, R1, R2, R3, R11, R12, R13, R14, R15
  0888            *
  0889            ASKCRU	MOV	R11,*R10+
  0890            	BL	@SCROLL
  0891            	LI	R1,TXTCRU
  0892            	BL	@DSPLIN
  0893            	DEC	@VDPLWA		Backspace one character
  0894            	CLR	R12
  0895            	
  0896            ASKCR0	BL	@KSCAN		Wait for key pressed
  0897            	JEQ	ASKCR0
  0898            	MOV	R0,R1
  0899            

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0021
  0900            	CI	R1,15		Back?
  0901            	JEQ	ASKCR4		Yes!
  0902            
  0903            	MOV	@VDPLWA,R0	Display key
  0904            	MOV	R1,R12
  0905            	SWPB	R1
  0906            	BL	@VSBW
  0907            
  0908            ASKCR1	BL	@KSCAN		Wait for key release
  0909            	JNE	ASKCR1
  0910            	
  0911            	CI	R12,>0030	0 - 9
  0912            	JLT	ASKCR0
  0913            	CI	R12,>0039
  0914            	JH	ASKCR2
  0915            	AI	R12,->0030	Make nibble >0 - >9
  0916            	JMP	ASKCR3	
  0917            	
  0918            ASKCR2	CI	R12,>0041	A - F
  0919            	JLT	ASKCR0
  0920            	CI	R12,>0046
  0921            	JH	ASKCR0
  0922            	AI	R12,->0041+>A	Make nibble >A - >F
  0923            	
  0924            ASKCR3	SLA	R12,8		Make CRU address
  0925            	AI	R12,>1000
  0926            ASKCR4	B	@RETURN
  0927 TRUE       #endif
  0928            
  0929            * WRDASC - Convert WORD in R0 to ASCII string
  0930            * LOBASC - Convert LO-BYTE in R0 to ASCII
  0931            * HOBASC - Convert HO-BYTE in R0 to ASCII
  0932            *
  0933            * Input:
  0934            *	R0 Number
  0935            *	R1 address of buffer
  0936            * Output:
  0937            * Uses: R0, R1, R2
  0938            *
  0939 6790 06C0  HOBASC	SWPB	R0
  0940 6792 CE8B  LOBASC	MOV	R11,*R10+
  0941 6794 C080  	MOV	R0,R2		Save byte
  0942 6796 0240  	ANDI	R0,>00F0	First HO-Nibble
       6798 00F0 
  0943 679A 0940  	SRL	R0,4
  0944 679C 06A0  	BL	@CASCII
       679E 67C0 
  0945 67A0 C002  	MOV	R2,R0		Second LO-Nibble
  0946 67A2 0240  	ANDI	R0,>000F
       67A4 000F 
  0947 67A6 06A0  	BL	@CASCII
       67A8 67C0 
  0948 67AA 0460  	B	@RETURN
       67AC 667A 
  0949            	
  0950 67AE CE8B  WRDASC	MOV	R11,*R10+
  0951 67B0 06A0  	BL	@HOBASC		First HO-Byte
       67B2 6790 
  0952 67B4 C002  	MOV	R2,R0

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0022
  0953 67B6 06A0  	BL	@HOBASC		Next LO-Byte
       67B8 6790 
  0954 67BA 0460  	B	@RETURN
       67BC 667A 
  0955            
  0956            
  0957            * CASCII - Convert LONibble in R0 to ASCII
  0958            *
  0959            * Input:
  0960            *	R0 LON hex digit
  0961            *	R1 Address to store ASCII
  0962            * Output:
  0963            *	R0 HOB ascii value
  0964            * Uses:
  0965            *	R1, R1
  0966            *
  0967 67BE 0000  CNULL	DATA	>0000
  0968 67C0 0280  CASCII	CI	R0,9
       67C2 0009 
  0969 67C4 1B03  	JH	CASCAF
  0970 67C6 0220  	AI	R0,'0'
       67C8 0030 
  0971 67CA 1002  	JMP	CASEND
  0972 67CC 0220  CASCAF	AI	R0,'A'-10
       67CE 0037 
  0973 67D0 06C0  CASEND	SWPB	R0
  0974 67D2 DC40  	MOVB	R0,*R1+
  0975 67D4 D460  	MOVB	@CNULL,*R1
       67D6 67BE 
  0976 67D8 045B  	B	*R11
  0977            
  0978            
  0979            * End Of Misc Functions
  0980            	COPY ".\MEMT_FUNC.A99"
  0981            * TI99 Memory test functions
  0982            *
  0983            * Copyright (c) 1998 by Michael Barr.
  0984            * Converted to TMS9900 assembly by: Frederik G. Kaal, 06 may
  0985            
  0986            *	TITL 'MEMTEST FUNCTIONS 06/05/2007'
  0987            *	IDT 'MEMTEST'
  0988            
  0989            	DEF	MTDB,MTAB,MTDV
  0990            
  0991            * Memory test functions
  0992            *
  0993            * All test functions take as input an address in R0
  0994            * consisting of a Base address, Region size and the
  0995            * databus width of the device.
  0996            * All test functions returns the used addresses,
  0997            * values and patterns as described in the following
  0998            * table.
  0999            *
  1000      67DA  MT#WSP	EQU	$	Memorytest workspace
  1001 67DA 0000  MT#ERR	DATA	0	(R0)  Error code
  1002 67DC 0000  MT#BAS	DATA	0	(R1)  Base address
  1003 67DE 0000  MT#RSZ	DATA	0	(R2)  Region size
  1004 67E0 0000  MT#IAP	DATA	0	(R3)  Inverted address mask
  1005 67E2 0000  MT#OF1	DATA	0	(R4)  Offset 1 in device (write)

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0023
  1006 67E4 0000  MT#OF2	DATA	0	(R5)  Offset 2 in device (read/test)
  1007 67E6 0000  MT#ADR	DATA	0	(R6)  Base address + Offset 1 or 2
  1008 67E8 0000  MT#WDP	DATA	0	(R7)  Written default  pattern
  1009 67EA 0000  MT#WIP	DATA	0	(R8)  Written inverted pattern
  1010 67EC 0000  MT#RBP	DATA	0	(R9)  Readback pattern
  1011 67EE 0000  MT#MNP	DATA	0	(R10) Max number of pages
  1012 67F0 0000  MT#R11	DATA	0
  1013 67F2 0000  MT#R12	DATA	0
  1014 67F4 0000  MT#R13	DATA	0
  1015 67F6 0000  MT#R14	DATA	0
  1016 67F8 0000  MT#R15	DATA	0
  1017            
  1018 67FA 67DA  MTDB	DATA	MT#WSP,MTDB$	Databus test
       67FC 6820 
  1019 67FE 67DA  MTAB	DATA	MT#WSP,MTAB$	Adresbus test
       6800 6862 
  1020 6802 67DA  MTDV	DATA	MT#WSP,MTDV$	Device test
       6804 68F8 
  1021            
  1022            * MTGTTV - Memorytest Get Table Values
  1023            *
  1024            * Get the table values of a memory region under test.
  1025            *
  1026            * Input : R13 Pointer to callers workspace in witch
  1027            *             R0 contains the address of structure with
  1028            *             Base address,Region size,Databus width 8/16,
  1029            *             address mask and number of pages.
  1030            *
  1031            * Output: R1 Base address
  1032            *         R2 Region size
  1033            *         R3 Databus width
  1034            *         R10 Number of pages
  1035            *
  1036            * Uses  : R0,R1,R2,R3,R11
  1037            *
  1038 6806 C29D  MTGTTV	MOV	*R13,R10	Get test table entry
  1039 6808 C07A  	MOV	*R10+,R1	Base address
  1040 680A C0BA  	MOV	*R10+,R2	Region size
  1041 680C C0FA  	MOV	*R10+,R3	Databus with
  1042 680E C03A  	MOV	*R10+,R0	Address mask
  1043 6810 C2BA  	MOV	*R10+,R10	Number of pages
  1044 6812 04C4  	CLR	R4
  1045 6814 04C5  	CLR	R5
  1046 6816 04C6  	CLR	R6
  1047 6818 04C7  	CLR	R7
  1048 681A 04C8  	CLR	R8
  1049 681C 04C9  	CLR	R9
  1050 681E 045B  	B	*R11
  1051            
  1052            * MTDB - Memorytest DataBus
  1053            *
  1054            * Test the databus wiring in a memory region by
  1055            * performing a walking 1's test (LSB to MSB) at
  1056            * a fixed address within that region.
  1057            *
  1058            * Input : R0 of callers workspace contains address of
  1059            *            structure with  Base address,Region size,
  1060            *            Databus width 8/16, Address mask and
  1061            *            Number of pages.

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0024
  1062            *
  1063            * Output: SR EQ=1 test succeeded, MT#ERR=0
  1064            *         SR EQ=0 test failed
  1065            *	  MT#ERR=1 Databus failure
  1066            *         and rest of MT#WSP filled as described.
  1067            *
  1068            * Uses  : All
  1069            
  1070 6820 06A0  MTDB$	BL	@MTGTTV		Get memory test table values
       6822 6806 
  1071 6824 C181  	MOV	R1,R6		Test address
  1072 6826 0207  	LI	R7,>0001	Assume 16 bits
       6828 0001 
  1073 682A 0283  	CI	R3,16		Width is 16 bits?
       682C 0010 
  1074 682E 1309  	JEQ	MTDB3		Yes!
  1075 6830 0207  	LI	R7,>0100	No, 8 bits!
       6832 0100 
  1076            	
  1077 6834 D587  MTDB1	MOVB	R7,*R6		Write pattern
  1078 6836 D256  	MOVB	*R6,R9		Read back
  1079 6838 9247  	CB	R7,R9		Equal?
  1080 683A 160E  	JNE	MTDBNE		No!
  1081 683C 0A17  	SLA	R7,1		Next bit
  1082 683E 16FA  	JNE	MTDB1
  1083 6840 1007  	JMP	MTDBEQ		Success
  1084            	
  1085 6842 C587  MTDB3	MOV	R7,*R6		Write pattern
  1086 6844 C256  	MOV	*R6,R9		Read back
  1087 6846 8247  	C	R7,R9		Equal?
  1088 6848 1607  	JNE	MTDBNE		No!
  1089 684A 0A17  	SLA	R7,1		Next bit
  1090 684C 16FA  	JNE	MTDB3		
  1091 684E 1000  	JMP	MTDBEQ		Success
  1092            
  1093 6850 04C0  MTDBEQ	CLR	R0		Error 0: Success
  1094 6852 026F  	ORI	R15,>2000	Success, set EQ
       6854 2000 
  1095 6856 0380  	RTWP
  1096 6858 0200  MTDBNE	LI	R0,1		Error 1: Databus failure
       685A 0001 
  1097 685C 024F  	ANDI	R15,>DFFF	Failure, reset EQ
       685E DFFF 
  1098 6860 0380  	RTWP
  1099            
  1100            
  1101            * MTAB - Memorytest AddressBus
  1102            *
  1103            * Test the address bus wiring in a memory region by
  1104            * performing a walking 1's test on the relevant bits
  1105            * of the address and checking for aliasing. This test
  1106            * will find single-bit address failures such as stuck
  1107            * -high, stuck-low, and shorted pins.  The base address
  1108            * and size of the region are selected by the caller.
  1109            *
  1110            * Input : R0 of callers workspace contains address of
  1111            *            structure with  Base address,Region size,
  1112            *            Databus width 8/16, Address mask and
  1113            *            Number of pages.

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0025
  1114            *
  1115            * Output: SR EQ=1 test succeeded
  1116            *         SR EQ=0 test failed
  1117            *         MT#ERR=2 Address line stuck low
  1118            *         MT#ERR=3 Address line stuck high
  1119            *         MT#ERR=4 Address lines shorted
  1120            *         and rest of MT#WSP filled as described.
  1121            *
  1122            * Uses  : All
  1123            
  1124 6862 06A0  MTAB$	BL	@MTGTTV		Get memory test table values
       6864 6806 
  1125            
  1126 6866 C101  	MOV	R1,R4		Base address
  1127 6868 C142  	MOV	R2,R5		Region size
  1128 686A 04F4  MTAB0	CLR	*R4+		Clear region
  1129 686C 0645  	DECT	R5
  1130 686E 16FD  	JNE	MTAB0	
  1131            
  1132 6870 C0C0  	MOV	R0,R3		Address mask
  1133 6872 0543  	INV	R3		Inverted address mask
  1134 6874 0207  	LI	R7,>A500	Pattern
       6876 A500 
  1135 6878 0208  	LI	R8,>5A00	Inverted pattern
       687A 5A00 
  1136            
  1137            * Write the default pattern at each of the power-of-two offs
  1138 687C 0204  	LI	R4,1		Offset
       687E 0001 
  1139 6880 C181  MTAB1	MOV	R1,R6		Base address
  1140 6882 A184  	A	R4,R6		+ Offset
  1141 6884 D587  	MOVB	R7,*R6		= Pattern
  1142 6886 0A14  	SLA	R4,1		Offset <<= 1
  1143 6888 4103  	SZC	R3,R4		& address mask
  1144 688A 16FA  	JNE	MTAB1
  1145            	
  1146            * Check for address bits stuck high.
  1147 688C D448  	MOVB	R8,*R1		Base address = Inverted pattern
  1148            	
  1149 688E 04C9  	CLR	R9		Readback register
  1150 6890 0204  	LI	R4,1		Offset
       6892 0001 
  1151 6894 C181  MTAB2	MOV	R1,R6		Base address
  1152 6896 A184  	A	R4,R6		+ Offset
  1153 6898 D256  	MOVB	*R6,R9		Read back
  1154 689A 9247  	CB	R7,R9		Equals Pattern
  1155 689C 1625  	JNE	MTABE3		No, stuck high!
  1156 689E 0A14  	SLA	R4,1		Offset <<= 1
  1157 68A0 4103  	SZC	R3,R4		& address mask
  1158 68A2 16F8  	JNE	MTAB2
  1159            
  1160            * Check for address bits stuck low or shorted.
  1161 68A4 D447  	MOVB	R7,*R1		Base address = Pattern
  1162            
  1163 68A6 0204  	LI	R4,1		Testoffset
       68A8 0001 
  1164 68AA C181  MTAB3	MOV	R1,R6		Base address
  1165 68AC A184  	A	R4,R6		+ TestOffset
  1166 68AE D588  	MOVB	R8,*R6		= Inverted Pattern

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0026
  1167 68B0 D251  	MOVB	*R1,R9		Readback Base address
  1168 68B2 9247  	CB	R7,R9		Address stuck low?
  1169 68B4 1616  	JNE	MTABE2		Yes, Error!
  1170            
  1171 68B6 0205  	LI	R5,1		Offset
       68B8 0001 
  1172 68BA 8105  MTAB4	C	R5,R4		Offset == TestOffset?
  1173 68BC 1305  	JEQ	MTAB5		Yes, do not check!
  1174 68BE C181  	MOV	R1,R6		Base address
  1175 68C0 A185  	A	R5,R6		+ Offset
  1176 68C2 D256  	MOVB	*R6,R9		Readback
  1177 68C4 9247  	CB	R7,R9		Equals Pattern
  1178 68C6 1613  	JNE	MTABE4		No, address lines shorted!
  1179 68C8 0A15  MTAB5	SLA	R5,1		Offset <<= 1
  1180 68CA 4143  	SZC	R3,R5		& address mask
  1181 68CC 16F6  	JNE	MTAB4
  1182            
  1183 68CE C181  	MOV	R1,R6		Base address
  1184 68D0 A184  	A	R4,R6		+ TestOffset
  1185 68D2 D587  	MOVB	R7,*R6		= Pattern
  1186            
  1187 68D4 0A14  	SLA	R4,1		TestOffset <<= 1
  1188 68D6 4103  	SZC	R3,R4		& address mask
  1189 68D8 16E8  	JNE	MTAB3
  1190            
  1191 68DA 04C0  MTABEQ	CLR	R0		Error 0: Success
  1192 68DC 026F  	ORI	R15,>2000	Success, set EQ
       68DE 2000 
  1193 68E0 0380  	RTWP
  1194            	
  1195 68E2 0200  MTABE2	LI	R0,2		Error 2: Address line stuck low
       68E4 0002 
  1196 68E6 1005  	JMP	MTABNE	
  1197 68E8 0200  MTABE3	LI	R0,3		Error 3: Address line stuck high
       68EA 0003 
  1198 68EC 1002  	JMP	MTABNE	
  1199 68EE 0200  MTABE4	LI	R0,4		Error 4: Address lines shorted
       68F0 0004 
  1200 68F2 024F  MTABNE	ANDI	R15,>DFFF	Failure, reset EQ
       68F4 DFFF 
  1201 68F6 0380  	RTWP
  1202            
  1203            
  1204            * MTDV - Memorytest Device
  1205            *
  1206            * Test the integrity of a physical memory device by
  1207            * performing an increment/decrement test over the
  1208            * entire region.  In the process every storage bit 
  1209            * in the device is tested as a zero and a one.  The
  1210            * base address and the size of the region are
  1211            * selected by the caller.
  1212            *
  1213            * Input : R0 of callers workspace contains address of
  1214            *            structure with  Base address,Region size,
  1215            *            Databus width 8/16, Address mask and
  1216            *            Number of pages.
  1217            *
  1218            * Output: SR EQ=1 test succeeded
  1219            *         SR EQ=0 test failed

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0027
  1220            *         MT#ERR=5 Wrong pattern read back
  1221            *         MT#ERR=6 Wrong inverted pattern read back
  1222            *         and rest of MT#WSP filled as described.
  1223            *
  1224            * Uses  : All
  1225            
  1226 68F8 06A0  MTDV$	BL	@MTGTTV		Get memory test table values
       68FA 6806 
  1227            
  1228            * Fill memory with a known pattern.
  1229            
  1230 68FC 04C4  	CLR	R4		Offset
  1231 68FE 0207  	LI	R7,1		Pattern
       6900 0001 
  1232 6902 C181  	MOV	R1,R6		Base address
  1233 6904 CD87  MTDV1	MOV	R7,*R6+
  1234 6906 0587  	INC	R7
  1235 6908 05C4  	INCT	R4
  1236 690A 8084  	C	R4,R2		End of region?
  1237 690C 1AFB  	JL	MTDV1		No!
  1238            	
  1239            * Check each location and invert it for the second pass.
  1240            
  1241 690E 04C9  	CLR	R9		Readback register
  1242 6910 04C4  	CLR	R4		Offset
  1243 6912 0207  	LI	R7,1		Pattern
       6914 0001 
  1244 6916 C181  	MOV	R1,R6		Base address
  1245 6918 C256  MTDV2	MOV	*R6,R9		Read pattern
  1246 691A 8247  	C	R7,R9		Equals pattern?
  1247 691C 1619  	JNE	MTDVE5		No!
  1248 691E C207  	MOV	R7,R8		Write inverted pattern
  1249 6920 0548  	INV	R8
  1250 6922 CD88  	MOV	R8,*R6+
  1251 6924 0587  	INC	R7		Increment pattern
  1252 6926 05C4  	INCT	R4		Increment offset
  1253 6928 8084  	C	R4,R2		End of region?
  1254 692A 1AF6  	JL	MTDV2		No!
  1255            
  1256            * Check each location for the inverted pattern and zero it.
  1257            
  1258 692C 04C4  	CLR	R4		Offset
  1259 692E 0207  	LI	R7,1		Pattern
       6930 0001 
  1260 6932 C181  	MOV	R1,R6		Base address
  1261 6934 C207  MTDV3	MOV	R7,R8		Invert pattern
  1262 6936 0548  	INV	R8
  1263 6938 C256  	MOV	*R6,R9		Read pattern
  1264 693A 8248  	C	R8,R9		Equals inverted pattern?
  1265 693C 160C  	JNE	MTDVE6		No!
  1266 693E 04F6  	CLR	*R6+		Clear address
  1267 6940 0587  	INC	R7		Next pattern
  1268 6942 05C4  	INCT	R4		Next offset
  1269 6944 8084  	C	R4,R2		End of region?
  1270 6946 1AF6  	JL	MTDV3		No!
  1271 6948 04C0  MTDVEQ	CLR	R0		Error 0: Success
  1272 694A 026F  	ORI	R15,>2000	Success, set EQ
       694C 2000 
  1273 694E 0380  	RTWP

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0028
  1274            
  1275 6950 0200  MTDVE5	LI	R0,5		Error 5: Wrong pattern
       6952 0005 
  1276 6954 1002  	JMP	MTDVNE
  1277 6956 0200  MTDVE6	LI	R0,6		Error 6: Wrong inverted pattern
       6958 0006 
  1278 695A 024F  MTDVNE	ANDI	R15,>DFFF	Failure, reset EQ
       695C DFFF 
  1279 695E 0380  	RTWP
  1280            	
  1281            *	END
  1282                   
  1283      6960  SLAST	EQU	$
  1284            	END

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0029
    BA10WD  647C      BACK    662C      BEGIN   6080      BEGIN1  6088  
    BEGIN2  609C      BEGIN3  60B0      CASCAF  67CC      CASCII  67C0  
    CASEND  67D0      CNULL   67BE      DSPCUR  6752      DSPLIN  6756  
    DSPLN0  675C      DSPLN1  6762      DSPLN2  6774      ENDTAB  6050  
    ERMTAB  6568      ERRT0   64E4      ERRT1   64E4      ERRT2   64EE  
    ERRT3   64FE      ERRT4   650E      ERRT5   651E      ERRT6   6528  
    ERRT7   6532      ERRT8   6544      ERRT9   6556      GPLWS   83E0  
    HOB     0000      HOBASC  6790      KSCAN   65FA      KSCAN$  65FA  
    LOB     0001      LOBASC  6792      MAIN    6080      MEMTAB  6032  
    MEMTEZ  000A      MT#ADR  67E6      MT#BAS  67DC      MT#ERR  67DA  
    MT#IAP  67E0      MT#MNP  67EE      MT#OF1  67E2      MT#OF2  67E4  
    MT#R11  67F0      MT#R12  67F2      MT#R13  67F4      MT#R14  67F6  
    MT#R15  67F8      MT#RBP  67EC      MT#RSZ  67DE      MT#WDP  67E8  
    MT#WIP  67EA      MT#WSP  67DA    D MTAB    67FE      MTAB$   6862  
    MTAB0   686A      MTAB1   6880      MTAB2   6894      MTAB3   68AA  
    MTAB4   68BA      MTAB5   68C8      MTABE2  68E2      MTABE3  68E8  
    MTABE4  68EE      MTABEQ  68DA      MTABNE  68F2    D MTDB    67FA  
    MTDB$   6820      MTDB1   6834      MTDB3   6842      MTDBEQ  6850  
    MTDBNE  6858    D MTDV    6802      MTDV$   68F8      MTDV1   6904  
    MTDV2   6918      MTDV3   6934      MTDVE5  6950      MTDVE6  6956  
    MTDVEQ  6948      MTDVNE  695A      MTEST   63CE      MTEST1  63F8  
    MTEST2  640E      MTEST3  6424      MTEST4  643A      MTFAIL  657C  
    MTFL$0  6586      MTFL$1  65B8      MTFL$2  65C6      MTFL$3  65D4  
    MTFL$4  65DA      MTFL$E  65EC      MTGTTV  6806      MTPB    60F0  
    MTPB$   60F4      MTPB0   6104      MTPB1   6116      MTPB2   6130  
    MTPB3   614C      MTPB4   6162      MTPB5   6172      MTPBE7  618E  
    MTPBE8  6194      MTPBE9  619A      MTPBEQ  6186      MTPBNE  619E  
    MTST4X  6458      MYCRU   6054      MYWS    6056      OFBASE  0000  
    OFMASK  0006      OFPAGE  0008      OFR0    0000      OFR1    0002  
    OFR10   0014      OFR11   0016      OFR12   0018      OFR13   001A  
    OFR14   001C      OFR15   001E      OFR2    0004      OFR3    0006  
    OFR4    0008      OFR5    000A      OFR6    000C      OFR7    000E  
    OFR8    0010      OFR9    0012      OFSIZE  0002      OFWIDT  0004  
    PAUSE   661A      PAUSE1  661C      PAUSE2  6622      PE70HB  64CC  
    PE70WD  64D4      PE80WD  64DC      PN00LB  6464      PN40LB  646C  
    PN50LB  6474      PR90HB  64BC      PR90WD  64C4      PRTCUR  6786  
    PRTLIN  6778      PW70HB  649C      PW70WD  64A4      PW80HB  64AC  
    PW80WD  64B4      QUIT    6680      R0      0000      R1      0001  
    R10     000A      R11     000B      R12     000C      R13     000D  
    R14     000E      R15     000F      R2      0002      R3      0003  
    R4      0004      R5      0005      R6      0006      R7      0007  
    R8      0008      R9      0009      REDO    663C      RETURN  667A  
    SAVR11  65F8      SCAN    000E      SCRBUF  66EA      SCRLL0  670C  
    SCRLL1  6710      SCRLL2  6746      SCROFF  6004      SCROLL  670A  
    SELPG   60DE      SELPG0  60DC    D SFIRST  6000    D SLAST   6960  
    STACK   6076      TA14WD  648C      TA15WD  6494      TA60WD  6484  
    TITLE   6006      TXTABT  61CE      TXTADR  633D      TXTBAD  61A4  
    TXTBAS  6325      TXTBCK  639D      TXTCRD  6017      TXTDBT  61BD  
    TXTDVT  61DF      TXTER0  6222      TXTER1  6231      TXTER2  6242  
    TXTER3  625A      TXTER4  6273      TXTER5  628A      TXTER6  62A3  
    TXTER7  62C1      TXTER8  62D6      TXTER9  62EC      TXTERR  6300  
    TXTERT  620E      TXTEXP  6385      TXTFLD  6205      TXTOK   6201  
    TXTPBT  61F0      TXTPGN  630D      TXTRDP  636D      TXTRED  63B7  
    TXTWRP  6355      USEXIT  60D0      USEXT0  60DA      USINI0  60CE  
    USINIT  60C4      UTLWS   6056      VDPADR  6694      VDPADW  668C  
    VDPLWA  6688      VDPRD   8800      VDPWA   8C02      VDPWAO  668A  
    VDPWD   8C00      VMBR    66D4      VMBR1   66DE      VMBR2   66E6  
    VMBW    66B0      VMBW1   66BA      VMBW2   66C2      VSBR    66C6  

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0030
    VSBW    66A2      WHAT    664C      WHAT0   664E      WHAT1   6656  
    WHAT2   665E      WHAT3   6672      WRDASC  67AE  
  0000 ERRORS

 Xa99 Cross Assembler
MEMTEST SAMS 31/05/2015                                      PAGE 0031
  SEGMENT AORG     SIZE 02400 (>0960) BYTES
